-- do not edit; automatically generated by UU.AG
module DefaultRules where

import qualified List (delete,intersperse)

import qualified UU.DData.Map as Map
import qualified UU.DData.Seq as Seq
import qualified UU.DData.Set as Set
import UU.DData.Map(Map) 
import UU.DData.Seq(Seq,(<>)) 
import UU.Scanner.Position(noPos)
import UU.Pretty

import AbstractSyntax
import ErrorMessages

import Options(Options,modcopy,rename)

-- AbstractSyntax.ag imports
import UU.DData.Set(Set)
import Patterns    (Pattern(..),Patterns)
import Expression  (Expression(..))
import CommonTypes

-- Patterns.ag imports
import UU.Scanner.Position(Pos)
import CommonTypes (Constructor,Name)

fieldName n       = '@' : getName n
	
locName n         = '@' : getName n

attrName fld attr
 | fld == _LOC    = '@' :                       getName attr 
 | otherwise      = '@' : getName fld ++ "." ++ getName attr

_ACHILD = Ident "(" noPos -- hack
	
	
getConName typeSyns rename nt con1 
 | nt `elem` map fst typeSyns  =  synonym
 | otherwise                   =  normalName
 where con                            = getName con1
       normalName | rename            = getName nt++"_"++ con
                  | otherwise         =  con
       synonym    | con == "Cons"     = "(:)"
                  | con == "Nil"      = "[]"
                  | con == "Just"     = "Just"
                  | con == "Nothing"  = "Nothing"
                  | otherwise         = normalName



concatSeq = foldr Seq.append Seq.empty

splitAttrs :: Map Name a -> [Name] -> ([(Name,a)],[Name])	  -- a used as (String,String)
splitAttrs _      []           
  =  ([],[])
splitAttrs useMap (n:rest) 
  =  let (uses,normals) = splitAttrs useMap rest
     in case Map.lookup n useMap of
          Just x  -> ((n,x):uses ,   normals )       
          Nothing -> (      uses , n:normals )

removeDefined ::  Set (Name,Name) -> (Name,Attributes) -> (Name,[Name])
removeDefined defined (fld,as) 
  = ( fld
    , [ a 
      | a <- Map.keys as
      , not (Set.member (fld,a) defined) 
      ]
    )


	
	
	
deprecatedCopyRuleError nt con fld a
 = let mesg = 
                "In the definitions for alternative" 
            >#< getName con 
            >#< "of nonterminal" 
            >#< getName nt 
            >|< "," 
            >-< "the value of field" 
            >#< getName a  
            >#< "is copied by a copy-rule."                                    
            >-< "Copying the value of a field using a copy-rule is deprecated"
            >-< "Please add the following lines to your code:"
            >-< (    "SEM" 
                >#< getName nt
                >-< indent 2 (      "|" 
                             >#< getName con 
                             >#< getName fld 
                             >#< "." 
                             >#< a 
                             >#< "=" 
                             >#< "@" 
                             >|< a
                             )
                )  
    in  CustomError True (getPos a) mesg
	
	
missingRuleErrorExpr nt con fld a
 = "error \"missing rule: " 
   ++ show nt  ++ "." ++ show con ++ "." 
   ++ show fld ++ "." ++ show a   ++ "\""
	
	
	
makeRule :: (Name,Name) -> Expression -> String -> Rule
makeRule (f1,a1) expr origin 
 = Rule (Alias f1 a1 (Underscore noPos)) 
        expr 
        False 
        origin


useRule :: Set Name -> [(Name,Attributes)] -> (Name,(String,String,String)) -> Rule
useRule locals ch_outs (n,(op,e,pos)) 
 =  let elems = [ fld 
                | (fld,as) <- ch_outs
                , Map.member n as
                ]
                
        expr | Set.member n locals  =  attrName _LOC n
             | null elems           =  e
             | otherwise            =  foldr1 (\x y -> x ++ " " ++ op ++ " " ++ y) 
                                              (map (flip attrName n) elems)
             
    in makeRule (_LHS,n) 
                (Expression noPos expr) 
                ("use rule " ++ pos)




selfRule lhsNecLoc attr x   
 = let expr | lhsNecLoc  = locName attr
            | otherwise  = x
     
   in makeRule (if lhsNecLoc then _LHS else _LOC,attr)
               (Expression noPos expr)
               "self rule"
               



concatRE rsess = let (rss,ess) = unzip rsess
                 in (concat rss, concatSeq ess)


copyRule :: Name -> Name -> Bool -> Set Name -> (Map Name Name, (Name,[Name])) -> ([Rule], Seq Error)
copyRule nt con modcopy locals (env,(fld,as)) 
 = concatRE (map copyRu as)
 
 where 
       copyRu a
           = ( [ makeRule (fld,a) 
                          (Expression noPos expr)
                          (cruletxt sel)
               ]
             , err
             )
                
        where 
              sel 
               |    not modcopy 
                 && Set.member a locals  =  Just _LOC
               | otherwise               =  Map.lookup a env

              (expr,err) 
               = case sel of
                  Nothing         -> ( missingRuleErrorExpr nt con fld a
                                     , Seq.single (MissingRule nt con fld a)
                                     )
                  Just f 
                   | f == _ACHILD -> ( fieldName a
                                     , Seq.single (deprecatedCopyRuleError nt con fld a)
                                     )
                   | otherwise    -> ( attrName f a
                                     , Seq.empty
                                     )
                                            
              cruletxt sel 
               | local                            = "copy rule (from local)"
               | deprChild                        = "deprecated child copy"
               | Set.member a locals && nonlocal  = "modified copy rule"
               | incoming && outgoing             = "copy rule (chain)"
               | incoming                         = "copy rule (down)"
               | outgoing                         = "copy rule (up)"
               | otherwise                        = "copy rule (chain)"
                where outgoing  =  fld == _LHS
                      incoming  =  maybe False (== _LHS)    sel
                      nonlocal  =  maybe False (/= _LOC)    sel
                      local     =  maybe False (== _LOC)    sel
                      deprChild =  maybe False (== _ACHILD) sel
-- Alternative -------------------------------------------------
{-
   inherited attributes:
      cr                   : Bool
      inh                  : Attributes
      nonterminals         : Set Nonterminal
      nt                   : Nonterminal
      o_rename             : Bool
      syn                  : Attributes
      typeSyns             : TypeSyns
      useMap               : Map Name (String,String,String)

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      output               : SELF

-}
{-
   local variables for Alternative.Alternative:
      newRls
      errs
      output

-}
-- semantic domain
newtype T_Alternative = T_Alternative ((Bool) ->
                                       (Attributes) ->
                                       (Set Nonterminal) ->
                                       (Nonterminal) ->
                                       (Bool) ->
                                       (Attributes) ->
                                       (TypeSyns) ->
                                       (Map Name (String,String,String)) ->
                                       ( (Seq Error),(Alternative)))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative (_con) (_children) (_rules) (_typeSigs))) =
    (sem_Alternative_Alternative (_con) ((sem_Children (_children))) ((sem_Rules (_rules))) ((sem_TypeSigs (_typeSigs))))
data Inh_Alternative = Inh_Alternative {cr_Inh_Alternative :: Bool,inh_Inh_Alternative :: Attributes,nonterminals_Inh_Alternative :: Set Nonterminal,nt_Inh_Alternative :: Nonterminal,o_rename_Inh_Alternative :: Bool,syn_Inh_Alternative :: Attributes,typeSyns_Inh_Alternative :: TypeSyns,useMap_Inh_Alternative :: Map Name (String,String,String)}
data Syn_Alternative = Syn_Alternative {errors_Syn_Alternative :: Seq Error,output_Syn_Alternative :: Alternative}
wrap_Alternative :: (T_Alternative) ->
                    (Inh_Alternative) ->
                    (Syn_Alternative)
wrap_Alternative ((T_Alternative (sem))) ((Inh_Alternative (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))) =
    let ( s1,s2) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))
    in  (Syn_Alternative (s1) (s2))
sem_Alternative_Alternative :: (Constructor) ->
                               (T_Children) ->
                               (T_Rules) ->
                               (T_TypeSigs) ->
                               (T_Alternative)
sem_Alternative_Alternative (con_) ((T_Children (children_))) ((T_Rules (rules_))) ((T_TypeSigs (typeSigs_))) =
    (T_Alternative (\ _lhsIcr
                      _lhsIinh
                      _lhsInonterminals
                      _lhsInt
                      _lhsIo_rename
                      _lhsIsyn
                      _lhsItypeSyns
                      _lhsIuseMap ->
                        let _lhsOerrors :: (Seq Error)
                            _lhsOoutput :: (Alternative)
                            _childrenIerrors :: (Seq Error)
                            _childrenIfields :: ([(Name,Type)])
                            _childrenIinputs :: ([(Name, Attributes)])
                            _childrenIoutput :: (Children)
                            _childrenIoutputs :: ([(Name, Attributes)])
                            _childrenOcon :: (Constructor)
                            _childrenOcr :: (Bool)
                            _childrenOnt :: (Nonterminal)
                            _rulesIdefinedAttrs :: (Set (Name,Name))
                            _rulesIerrors :: (Seq Error)
                            _rulesIlocals :: (Set Name)
                            _rulesIoutput :: (Rules)
                            _rulesOcon :: (Constructor)
                            _rulesOnt :: (Nonterminal)
                            _typeSigsIoutput :: (TypeSigs)
                            ( _childrenIerrors,_childrenIfields,_childrenIinputs,_childrenIoutput,_childrenIoutputs) =
                                (children_ (_childrenOcon) (_childrenOcr) (_childrenOnt))
                            ( _rulesIdefinedAttrs,_rulesIerrors,_rulesIlocals,_rulesIoutput) =
                                (rules_ (_rulesOcon) (_rulesOnt))
                            ( _typeSigsIoutput) =
                                (typeSigs_ )
                            -- "DefaultRules.ag"(line 136, column 17)
                            (_childrenOcon@_) =
                                con_
                            -- "DefaultRules.ag"(line 135, column 17)
                            (_rulesOcon@_) =
                                con_
                            -- "DefaultRules.ag"(line 297, column 8)
                            ((_newRls@_,_errs@_)) =
                                let locals       = _rulesIlocals
                                    initenv      = Map.fromList (  [ (a,_ACHILD)
                                                                   | (a,_) <- _childrenIfields
                                                                   ]
                                                                ++ attrs(_LHS, _lhsIinh)
                                                                ++ [ (a,_LOC)
                                                                   |  a <- Set.toList locals
                                                                   ]
                                                                )
                                    attrs (n,as) = [ (a,n) | a <- Map.keys as ]
                                    envs       = scanl (flip Map.union)
                                                       initenv
                                                       (map (Map.fromList . attrs ) _childrenIoutputs)
                                    child_envs = init envs
                                    lhs_env    = last envs
                                    (selfAttrs, normalAttrs)
                                      = Map.partition (==NT _SELF) _lhsIsyn
                                    (_,undefAttrs)
                                      = removeDefined _rulesIdefinedAttrs (_LHS, normalAttrs)
                                    (useAttrs,others)
                                      = splitAttrs _lhsIuseMap undefAttrs
                                    (rules1, errors1)
                                      = concatRE $ map (copyRule _lhsInt con_ _lhsIcr locals)
                                                       (zip envs (map (removeDefined _rulesIdefinedAttrs) _childrenIinputs))
                                    uRules
                                      = map (useRule locals _childrenIoutputs) useAttrs
                                    selfLocRules
                                      =  [ selfRule False attr (constructor [childSelf attr nm tp | (nm,tp) <- _childrenIfields])
                                         | attr <- Map.keys selfAttrs
                                         , not (Set.member attr locals)
                                         ]
                                         where
                                           childSelf self nm tp
                                             = case tp of NT nt  -> attrName nm self
                                                          _      -> fieldName nm
                                           constructor fs
                                            | getName con_ == "Tuple" && _lhsInt `elem` map fst _lhsItypeSyns
                                              = "(" ++ concat (List.intersperse "," fs) ++ ")"
                                            | otherwise
                                              = getConName _lhsItypeSyns _lhsIo_rename _lhsInt con_ ++ " " ++ unwords fs
                                    selfRules
                                      = [ selfRule True attr undefined
                                        | attr <- Map.keys selfAttrs
                                        , not (Set.member (_LHS,attr) _rulesIdefinedAttrs)
                                        ]
                                    (rules5, errs5)
                                      = copyRule _lhsInt
                                                 con_
                                                 _lhsIcr
                                                 locals
                                                 (lhs_env, (_LHS, others))
                                in (uRules++selfLocRules++selfRules++rules5++rules1, errors1<>errs5)
                            -- "DefaultRules.ag"(line 295, column 4)
                            (_lhsOerrors@_) =
                                _childrenIerrors <> _errs <> _rulesIerrors
                            -- "DefaultRules.ag"(line 404, column 17)
                            (_lhsOoutput@_) =
                                Alternative con_ _childrenIoutput (_rulesIoutput ++ _newRls) _typeSigsIoutput
                            -- self rule
                            (_output@_) =
                                Alternative con_ _childrenIoutput _rulesIoutput _typeSigsIoutput
                            -- copy rule (down)
                            (_childrenOcr@_) =
                                _lhsIcr
                            -- copy rule (down)
                            (_childrenOnt@_) =
                                _lhsInt
                            -- copy rule (down)
                            (_rulesOnt@_) =
                                _lhsInt
                        in  ( _lhsOerrors,_lhsOoutput)))
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      cr                   : Bool
      inh                  : Attributes
      nonterminals         : Set Nonterminal
      nt                   : Nonterminal
      o_rename             : Bool
      syn                  : Attributes
      typeSyns             : TypeSyns
      useMap               : Map Name (String,String,String)

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      output               : SELF

-}
{-
   local variables for Alternatives.Cons:
      output

-}
{-
   local variables for Alternatives.Nil:
      output

-}
-- semantic domain
newtype T_Alternatives = T_Alternatives ((Bool) ->
                                         (Attributes) ->
                                         (Set Nonterminal) ->
                                         (Nonterminal) ->
                                         (Bool) ->
                                         (Attributes) ->
                                         (TypeSyns) ->
                                         (Map Name (String,String,String)) ->
                                         ( (Seq Error),(Alternatives)))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (Prelude.foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((Prelude.map sem_Alternative list)))
data Inh_Alternatives = Inh_Alternatives {cr_Inh_Alternatives :: Bool,inh_Inh_Alternatives :: Attributes,nonterminals_Inh_Alternatives :: Set Nonterminal,nt_Inh_Alternatives :: Nonterminal,o_rename_Inh_Alternatives :: Bool,syn_Inh_Alternatives :: Attributes,typeSyns_Inh_Alternatives :: TypeSyns,useMap_Inh_Alternatives :: Map Name (String,String,String)}
data Syn_Alternatives = Syn_Alternatives {errors_Syn_Alternatives :: Seq Error,output_Syn_Alternatives :: Alternatives}
wrap_Alternatives :: (T_Alternatives) ->
                     (Inh_Alternatives) ->
                     (Syn_Alternatives)
wrap_Alternatives ((T_Alternatives (sem))) ((Inh_Alternatives (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))) =
    let ( s1,s2) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))
    in  (Syn_Alternatives (s1) (s2))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons ((T_Alternative (hd_))) ((T_Alternatives (tl_))) =
    (T_Alternatives (\ _lhsIcr
                       _lhsIinh
                       _lhsInonterminals
                       _lhsInt
                       _lhsIo_rename
                       _lhsIsyn
                       _lhsItypeSyns
                       _lhsIuseMap ->
                         let _lhsOerrors :: (Seq Error)
                             _lhsOoutput :: (Alternatives)
                             _hdIerrors :: (Seq Error)
                             _hdIoutput :: (Alternative)
                             _hdOcr :: (Bool)
                             _hdOinh :: (Attributes)
                             _hdOnonterminals :: (Set Nonterminal)
                             _hdOnt :: (Nonterminal)
                             _hdOo_rename :: (Bool)
                             _hdOsyn :: (Attributes)
                             _hdOtypeSyns :: (TypeSyns)
                             _hdOuseMap :: (Map Name (String,String,String))
                             _tlIerrors :: (Seq Error)
                             _tlIoutput :: (Alternatives)
                             _tlOcr :: (Bool)
                             _tlOinh :: (Attributes)
                             _tlOnonterminals :: (Set Nonterminal)
                             _tlOnt :: (Nonterminal)
                             _tlOo_rename :: (Bool)
                             _tlOsyn :: (Attributes)
                             _tlOtypeSyns :: (TypeSyns)
                             _tlOuseMap :: (Map Name (String,String,String))
                             ( _hdIerrors,_hdIoutput) =
                                 (hd_ (_hdOcr) (_hdOinh) (_hdOnonterminals) (_hdOnt) (_hdOo_rename) (_hdOsyn) (_hdOtypeSyns) (_hdOuseMap))
                             ( _tlIerrors,_tlIoutput) =
                                 (tl_ (_tlOcr) (_tlOinh) (_tlOnonterminals) (_tlOnt) (_tlOo_rename) (_tlOsyn) (_tlOtypeSyns) (_tlOuseMap))
                             -- use rule
                             (_lhsOerrors@_) =
                                 _hdIerrors Seq.<> _tlIerrors
                             -- self rule
                             (_output@_) =
                                 (:) _hdIoutput _tlIoutput
                             -- self rule
                             (_lhsOoutput@_) =
                                 _output
                             -- copy rule (down)
                             (_hdOcr@_) =
                                 _lhsIcr
                             -- copy rule (down)
                             (_hdOinh@_) =
                                 _lhsIinh
                             -- copy rule (down)
                             (_hdOnonterminals@_) =
                                 _lhsInonterminals
                             -- copy rule (down)
                             (_hdOnt@_) =
                                 _lhsInt
                             -- copy rule (down)
                             (_hdOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_hdOsyn@_) =
                                 _lhsIsyn
                             -- copy rule (down)
                             (_hdOtypeSyns@_) =
                                 _lhsItypeSyns
                             -- copy rule (down)
                             (_hdOuseMap@_) =
                                 _lhsIuseMap
                             -- copy rule (down)
                             (_tlOcr@_) =
                                 _lhsIcr
                             -- copy rule (down)
                             (_tlOinh@_) =
                                 _lhsIinh
                             -- copy rule (down)
                             (_tlOnonterminals@_) =
                                 _lhsInonterminals
                             -- copy rule (down)
                             (_tlOnt@_) =
                                 _lhsInt
                             -- copy rule (down)
                             (_tlOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_tlOsyn@_) =
                                 _lhsIsyn
                             -- copy rule (down)
                             (_tlOtypeSyns@_) =
                                 _lhsItypeSyns
                             -- copy rule (down)
                             (_tlOuseMap@_) =
                                 _lhsIuseMap
                         in  ( _lhsOerrors,_lhsOoutput)))
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    (T_Alternatives (\ _lhsIcr
                       _lhsIinh
                       _lhsInonterminals
                       _lhsInt
                       _lhsIo_rename
                       _lhsIsyn
                       _lhsItypeSyns
                       _lhsIuseMap ->
                         let _lhsOerrors :: (Seq Error)
                             _lhsOoutput :: (Alternatives)
                             -- use rule
                             (_lhsOerrors@_) =
                                 Seq.empty
                             -- self rule
                             (_output@_) =
                                 []
                             -- self rule
                             (_lhsOoutput@_) =
                                 _output
                         in  ( _lhsOerrors,_lhsOoutput)))
-- Child -------------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      cr                   : Bool
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      field                :  (Name,Type) 
      inherited            : Attributes
      name                 : Name
      output               : SELF
      synthesized          : Attributes

-}
{-
   local variables for Child.Child:
      output

-}
-- semantic domain
newtype T_Child = T_Child ((Constructor) ->
                           (Bool) ->
                           (Nonterminal) ->
                           ( (Seq Error),( (Name,Type) ),(Attributes),(Name),(Child),(Attributes)))
-- cata
sem_Child :: (Child) ->
             (T_Child)
sem_Child ((Child (_name) (_tp) (_inh) (_syn))) =
    (sem_Child_Child (_name) (_tp) (_inh) (_syn))
data Inh_Child = Inh_Child {con_Inh_Child :: Constructor,cr_Inh_Child :: Bool,nt_Inh_Child :: Nonterminal}
data Syn_Child = Syn_Child {errors_Syn_Child :: Seq Error,field_Syn_Child ::  (Name,Type) ,inherited_Syn_Child :: Attributes,name_Syn_Child :: Name,output_Syn_Child :: Child,synthesized_Syn_Child :: Attributes}
wrap_Child :: (T_Child) ->
              (Inh_Child) ->
              (Syn_Child)
wrap_Child ((T_Child (sem))) ((Inh_Child (i1) (i2) (i3))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3))
    in  (Syn_Child (s1) (s2) (s3) (s4) (s5) (s6))
sem_Child_Child :: (Name) ->
                   (Type) ->
                   (Attributes) ->
                   (Attributes) ->
                   (T_Child)
sem_Child_Child (name_) (tp_) (inh_) (syn_) =
    (T_Child (\ _lhsIcon
                _lhsIcr
                _lhsInt ->
                  let _lhsOerrors :: (Seq Error)
                      _lhsOfield :: ( (Name,Type) )
                      _lhsOinherited :: (Attributes)
                      _lhsOname :: (Name)
                      _lhsOoutput :: (Child)
                      _lhsOsynthesized :: (Attributes)
                      -- "DefaultRules.ag"(line 138, column 11)
                      (_lhsOname@_) =
                          name_
                      -- "DefaultRules.ag"(line 148, column 11)
                      (_lhsOsynthesized@_) =
                          syn_
                      -- "DefaultRules.ag"(line 147, column 11)
                      (_lhsOinherited@_) =
                          inh_
                      -- "DefaultRules.ag"(line 385, column 11)
                      (_lhsOfield@_) =
                          (name_,tp_)
                      -- use rule
                      (_lhsOerrors@_) =
                          Seq.empty
                      -- self rule
                      (_output@_) =
                          Child name_ tp_ inh_ syn_
                      -- self rule
                      (_lhsOoutput@_) =
                          _output
                  in  ( _lhsOerrors,_lhsOfield,_lhsOinherited,_lhsOname,_lhsOoutput,_lhsOsynthesized)))
-- Children ----------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      cr                   : Bool
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      fields               : [(Name,Type)]
      inputs               : [(Name, Attributes)]
      output               : SELF
      outputs              : [(Name, Attributes)]

-}
{-
   local variables for Children.Cons:
      output

-}
{-
   local variables for Children.Nil:
      output

-}
-- semantic domain
newtype T_Children = T_Children ((Constructor) ->
                                 (Bool) ->
                                 (Nonterminal) ->
                                 ( (Seq Error),([(Name,Type)]),([(Name, Attributes)]),(Children),([(Name, Attributes)])))
-- cata
sem_Children :: (Children) ->
                (T_Children)
sem_Children (list) =
    (Prelude.foldr (sem_Children_Cons) (sem_Children_Nil) ((Prelude.map sem_Child list)))
data Inh_Children = Inh_Children {con_Inh_Children :: Constructor,cr_Inh_Children :: Bool,nt_Inh_Children :: Nonterminal}
data Syn_Children = Syn_Children {errors_Syn_Children :: Seq Error,fields_Syn_Children :: [(Name,Type)],inputs_Syn_Children :: [(Name, Attributes)],output_Syn_Children :: Children,outputs_Syn_Children :: [(Name, Attributes)]}
wrap_Children :: (T_Children) ->
                 (Inh_Children) ->
                 (Syn_Children)
wrap_Children ((T_Children (sem))) ((Inh_Children (i1) (i2) (i3))) =
    let ( s1,s2,s3,s4,s5) =
            (sem (i1) (i2) (i3))
    in  (Syn_Children (s1) (s2) (s3) (s4) (s5))
sem_Children_Cons :: (T_Child) ->
                     (T_Children) ->
                     (T_Children)
sem_Children_Cons ((T_Child (hd_))) ((T_Children (tl_))) =
    (T_Children (\ _lhsIcon
                   _lhsIcr
                   _lhsInt ->
                     let _lhsOerrors :: (Seq Error)
                         _lhsOfields :: ([(Name,Type)])
                         _lhsOinputs :: ([(Name, Attributes)])
                         _lhsOoutput :: (Children)
                         _lhsOoutputs :: ([(Name, Attributes)])
                         _hdIerrors :: (Seq Error)
                         _hdIfield :: ( (Name,Type) )
                         _hdIinherited :: (Attributes)
                         _hdIname :: (Name)
                         _hdIoutput :: (Child)
                         _hdIsynthesized :: (Attributes)
                         _hdOcon :: (Constructor)
                         _hdOcr :: (Bool)
                         _hdOnt :: (Nonterminal)
                         _tlIerrors :: (Seq Error)
                         _tlIfields :: ([(Name,Type)])
                         _tlIinputs :: ([(Name, Attributes)])
                         _tlIoutput :: (Children)
                         _tlIoutputs :: ([(Name, Attributes)])
                         _tlOcon :: (Constructor)
                         _tlOcr :: (Bool)
                         _tlOnt :: (Nonterminal)
                         ( _hdIerrors,_hdIfield,_hdIinherited,_hdIname,_hdIoutput,_hdIsynthesized) =
                             (hd_ (_hdOcon) (_hdOcr) (_hdOnt))
                         ( _tlIerrors,_tlIfields,_tlIinputs,_tlIoutput,_tlIoutputs) =
                             (tl_ (_tlOcon) (_tlOcr) (_tlOnt))
                         -- "DefaultRules.ag"(line 151, column 10)
                         (_lhsOoutputs@_) =
                             (_hdIname, _hdIsynthesized) : _tlIoutputs
                         -- "DefaultRules.ag"(line 151, column 10)
                         (_lhsOinputs@_) =
                             (_hdIname, _hdIinherited) : _tlIinputs
                         -- "DefaultRules.ag"(line 381, column 10)
                         (_lhsOfields@_) =
                             _hdIfield : _tlIfields
                         -- use rule
                         (_lhsOerrors@_) =
                             _hdIerrors Seq.<> _tlIerrors
                         -- self rule
                         (_output@_) =
                             (:) _hdIoutput _tlIoutput
                         -- self rule
                         (_lhsOoutput@_) =
                             _output
                         -- copy rule (down)
                         (_hdOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_hdOcr@_) =
                             _lhsIcr
                         -- copy rule (down)
                         (_hdOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_tlOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_tlOcr@_) =
                             _lhsIcr
                         -- copy rule (down)
                         (_tlOnt@_) =
                             _lhsInt
                     in  ( _lhsOerrors,_lhsOfields,_lhsOinputs,_lhsOoutput,_lhsOoutputs)))
sem_Children_Nil :: (T_Children)
sem_Children_Nil  =
    (T_Children (\ _lhsIcon
                   _lhsIcr
                   _lhsInt ->
                     let _lhsOerrors :: (Seq Error)
                         _lhsOfields :: ([(Name,Type)])
                         _lhsOinputs :: ([(Name, Attributes)])
                         _lhsOoutput :: (Children)
                         _lhsOoutputs :: ([(Name, Attributes)])
                         -- "DefaultRules.ag"(line 153, column 10)
                         (_lhsOoutputs@_) =
                             []
                         -- "DefaultRules.ag"(line 153, column 10)
                         (_lhsOinputs@_) =
                             []
                         -- "DefaultRules.ag"(line 382, column 10)
                         (_lhsOfields@_) =
                             []
                         -- use rule
                         (_lhsOerrors@_) =
                             Seq.empty
                         -- self rule
                         (_output@_) =
                             []
                         -- self rule
                         (_lhsOoutput@_) =
                             _output
                     in  ( _lhsOerrors,_lhsOfields,_lhsOinputs,_lhsOoutput,_lhsOoutputs)))
-- Grammar -----------------------------------------------------
{-
   inherited attributes:
      options              : Options

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      output               : SELF

-}
{-
   local variables for Grammar.Grammar:
      output

-}
-- semantic domain
newtype T_Grammar = T_Grammar ((Options) ->
                               ( (Seq Error),(Grammar)))
-- cata
sem_Grammar :: (Grammar) ->
               (T_Grammar)
sem_Grammar ((Grammar (_typeSyns) (_useMap) (_derivings) (_wrappers) (_prods))) =
    (sem_Grammar_Grammar (_typeSyns) (_useMap) (_derivings) (_wrappers) ((sem_Productions (_prods))))
data Inh_Grammar = Inh_Grammar {options_Inh_Grammar :: Options}
data Syn_Grammar = Syn_Grammar {errors_Syn_Grammar :: Seq Error,output_Syn_Grammar :: Grammar}
wrap_Grammar :: (T_Grammar) ->
                (Inh_Grammar) ->
                (Syn_Grammar)
wrap_Grammar ((T_Grammar (sem))) ((Inh_Grammar (i1))) =
    let ( s1,s2) =
            (sem (i1))
    in  (Syn_Grammar (s1) (s2))
sem_Grammar_Grammar :: (TypeSyns) ->
                       (UseMap) ->
                       (Derivings) ->
                       (Set Nonterminal) ->
                       (T_Productions) ->
                       (T_Grammar)
sem_Grammar_Grammar (typeSyns_) (useMap_) (derivings_) (wrappers_) ((T_Productions (prods_))) =
    (T_Grammar (\ _lhsIoptions ->
                    let _lhsOerrors :: (Seq Error)
                        _lhsOoutput :: (Grammar)
                        _prodsIcollect_nts :: (Set Nonterminal)
                        _prodsIerrors :: (Seq Error)
                        _prodsIoutput :: (Productions)
                        _prodsOcr :: (Bool)
                        _prodsOnonterminals :: (Set Nonterminal)
                        _prodsOo_rename :: (Bool)
                        _prodsOtypeSyns :: (TypeSyns)
                        _prodsOuseMap :: (UseMap)
                        ( _prodsIcollect_nts,_prodsIerrors,_prodsIoutput) =
                            (prods_ (_prodsOcr) (_prodsOnonterminals) (_prodsOo_rename) (_prodsOtypeSyns) (_prodsOuseMap))
                        -- "DefaultRules.ag"(line 42, column 17)
                        (_prodsOcr@_) =
                            modcopy   _lhsIoptions
                        -- "DefaultRules.ag"(line 41, column 17)
                        (_prodsOo_rename@_) =
                            rename    _lhsIoptions
                        -- "DefaultRules.ag"(line 119, column 13)
                        (_prodsOnonterminals@_) =
                            _prodsIcollect_nts
                        -- "DefaultRules.ag"(line 140, column 13)
                        (_prodsOuseMap@_) =
                            useMap_
                        -- "DefaultRules.ag"(line 142, column 13)
                        (_prodsOtypeSyns@_) =
                            typeSyns_
                        -- use rule
                        (_lhsOerrors@_) =
                            _prodsIerrors
                        -- self rule
                        (_output@_) =
                            Grammar typeSyns_ useMap_ derivings_ wrappers_ _prodsIoutput
                        -- self rule
                        (_lhsOoutput@_) =
                            _output
                    in  ( _lhsOerrors,_lhsOoutput)))
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      containsVars         : Bool
      copy                 : SELF
      definedAttrs         : Set (Name,Name)
      errors               : Seq Error
      locals               : Set Name
      output               : SELF

-}
{-
   local variables for Pattern.Alias:
      copy
      output

-}
{-
   local variables for Pattern.Constr:
      copy
      output

-}
{-
   local variables for Pattern.Product:
      copy
      output

-}
{-
   local variables for Pattern.Underscore:
      copy
      output

-}
-- semantic domain
newtype T_Pattern = T_Pattern ((Constructor) ->
                               (Nonterminal) ->
                               ( (Bool),(Pattern),(Set (Name,Name)),(Seq Error),(Set Name),(Pattern)))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Alias (_field) (_attr) (_pat))) =
    (sem_Pattern_Alias (_field) (_attr) ((sem_Pattern (_pat))))
sem_Pattern ((Constr (_name) (_pats))) =
    (sem_Pattern_Constr (_name) ((sem_Patterns (_pats))))
sem_Pattern ((Product (_pos) (_pats))) =
    (sem_Pattern_Product (_pos) ((sem_Patterns (_pats))))
sem_Pattern ((Underscore (_pos))) =
    (sem_Pattern_Underscore (_pos))
data Inh_Pattern = Inh_Pattern {con_Inh_Pattern :: Constructor,nt_Inh_Pattern :: Nonterminal}
data Syn_Pattern = Syn_Pattern {containsVars_Syn_Pattern :: Bool,copy_Syn_Pattern :: Pattern,definedAttrs_Syn_Pattern :: Set (Name,Name),errors_Syn_Pattern :: Seq Error,locals_Syn_Pattern :: Set Name,output_Syn_Pattern :: Pattern}
wrap_Pattern :: (T_Pattern) ->
                (Inh_Pattern) ->
                (Syn_Pattern)
wrap_Pattern ((T_Pattern (sem))) ((Inh_Pattern (i1) (i2))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2))
    in  (Syn_Pattern (s1) (s2) (s3) (s4) (s5) (s6))
sem_Pattern_Alias :: (Name) ->
                     (Name) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_Alias (field_) (attr_) ((T_Pattern (pat_))) =
    (T_Pattern (\ _lhsIcon
                  _lhsInt ->
                    let _lhsOcontainsVars :: (Bool)
                        _lhsOcopy :: (Pattern)
                        _lhsOdefinedAttrs :: (Set (Name,Name))
                        _lhsOerrors :: (Seq Error)
                        _lhsOlocals :: (Set Name)
                        _lhsOoutput :: (Pattern)
                        _patIcontainsVars :: (Bool)
                        _patIcopy :: (Pattern)
                        _patIdefinedAttrs :: (Set (Name,Name))
                        _patIerrors :: (Seq Error)
                        _patIlocals :: (Set Name)
                        _patIoutput :: (Pattern)
                        _patOcon :: (Constructor)
                        _patOnt :: (Nonterminal)
                        ( _patIcontainsVars,_patIcopy,_patIdefinedAttrs,_patIerrors,_patIlocals,_patIoutput) =
                            (pat_ (_patOcon) (_patOnt))
                        -- "DefaultRules.ag"(line 375, column 11)
                        (_lhsOlocals@_) =
                            if field_ == _LOC
                               then Set.insert attr_ _patIlocals
                               else _patIlocals
                        -- "DefaultRules.ag"(line 375, column 11)
                        (_lhsOdefinedAttrs@_) =
                            Set.insert (field_,attr_) _patIdefinedAttrs
                        -- "DefaultRules.ag"(line 393, column 16)
                        (_lhsOcontainsVars@_) =
                            True
                        -- use rule
                        (_lhsOerrors@_) =
                            _patIerrors
                        -- self rule
                        (_copy@_) =
                            Alias field_ attr_ _patIcopy
                        -- self rule
                        (_output@_) =
                            Alias field_ attr_ _patIoutput
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- self rule
                        (_lhsOoutput@_) =
                            _output
                        -- copy rule (down)
                        (_patOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patOnt@_) =
                            _lhsInt
                    in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
sem_Pattern_Constr :: (Constructor) ->
                      (T_Patterns) ->
                      (T_Pattern)
sem_Pattern_Constr (name_) ((T_Patterns (pats_))) =
    (T_Pattern (\ _lhsIcon
                  _lhsInt ->
                    let _lhsOcontainsVars :: (Bool)
                        _lhsOcopy :: (Pattern)
                        _lhsOdefinedAttrs :: (Set (Name,Name))
                        _lhsOerrors :: (Seq Error)
                        _lhsOlocals :: (Set Name)
                        _lhsOoutput :: (Pattern)
                        _patsIcontainsVars :: (Bool)
                        _patsIcopy :: (Patterns)
                        _patsIdefinedAttrs :: (Set (Name,Name))
                        _patsIerrors :: (Seq Error)
                        _patsIlocals :: (Set Name)
                        _patsIoutput :: (Patterns)
                        _patsOcon :: (Constructor)
                        _patsOnt :: (Nonterminal)
                        ( _patsIcontainsVars,_patsIcopy,_patsIdefinedAttrs,_patsIerrors,_patsIlocals,_patsIoutput) =
                            (pats_ (_patsOcon) (_patsOnt))
                        -- use rule
                        (_lhsOcontainsVars@_) =
                            _patsIcontainsVars
                        -- use rule
                        (_lhsOdefinedAttrs@_) =
                            _patsIdefinedAttrs
                        -- use rule
                        (_lhsOerrors@_) =
                            _patsIerrors
                        -- use rule
                        (_lhsOlocals@_) =
                            _patsIlocals
                        -- self rule
                        (_copy@_) =
                            Constr name_ _patsIcopy
                        -- self rule
                        (_output@_) =
                            Constr name_ _patsIoutput
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- self rule
                        (_lhsOoutput@_) =
                            _output
                        -- copy rule (down)
                        (_patsOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patsOnt@_) =
                            _lhsInt
                    in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
sem_Pattern_Product :: (Pos) ->
                       (T_Patterns) ->
                       (T_Pattern)
sem_Pattern_Product (pos_) ((T_Patterns (pats_))) =
    (T_Pattern (\ _lhsIcon
                  _lhsInt ->
                    let _lhsOcontainsVars :: (Bool)
                        _lhsOcopy :: (Pattern)
                        _lhsOdefinedAttrs :: (Set (Name,Name))
                        _lhsOerrors :: (Seq Error)
                        _lhsOlocals :: (Set Name)
                        _lhsOoutput :: (Pattern)
                        _patsIcontainsVars :: (Bool)
                        _patsIcopy :: (Patterns)
                        _patsIdefinedAttrs :: (Set (Name,Name))
                        _patsIerrors :: (Seq Error)
                        _patsIlocals :: (Set Name)
                        _patsIoutput :: (Patterns)
                        _patsOcon :: (Constructor)
                        _patsOnt :: (Nonterminal)
                        ( _patsIcontainsVars,_patsIcopy,_patsIdefinedAttrs,_patsIerrors,_patsIlocals,_patsIoutput) =
                            (pats_ (_patsOcon) (_patsOnt))
                        -- use rule
                        (_lhsOcontainsVars@_) =
                            _patsIcontainsVars
                        -- use rule
                        (_lhsOdefinedAttrs@_) =
                            _patsIdefinedAttrs
                        -- use rule
                        (_lhsOerrors@_) =
                            _patsIerrors
                        -- use rule
                        (_lhsOlocals@_) =
                            _patsIlocals
                        -- self rule
                        (_copy@_) =
                            Product pos_ _patsIcopy
                        -- self rule
                        (_output@_) =
                            Product pos_ _patsIoutput
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- self rule
                        (_lhsOoutput@_) =
                            _output
                        -- copy rule (down)
                        (_patsOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patsOnt@_) =
                            _lhsInt
                    in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
sem_Pattern_Underscore :: (Pos) ->
                          (T_Pattern)
sem_Pattern_Underscore (pos_) =
    (T_Pattern (\ _lhsIcon
                  _lhsInt ->
                    let _lhsOcontainsVars :: (Bool)
                        _lhsOcopy :: (Pattern)
                        _lhsOdefinedAttrs :: (Set (Name,Name))
                        _lhsOerrors :: (Seq Error)
                        _lhsOlocals :: (Set Name)
                        _lhsOoutput :: (Pattern)
                        -- use rule
                        (_lhsOcontainsVars@_) =
                            False
                        -- use rule
                        (_lhsOdefinedAttrs@_) =
                            Set.empty
                        -- use rule
                        (_lhsOerrors@_) =
                            Seq.empty
                        -- use rule
                        (_lhsOlocals@_) =
                            Set.empty
                        -- self rule
                        (_copy@_) =
                            Underscore pos_
                        -- self rule
                        (_output@_) =
                            Underscore pos_
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- self rule
                        (_lhsOoutput@_) =
                            _output
                    in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      containsVars         : Bool
      copy                 : SELF
      definedAttrs         : Set (Name,Name)
      errors               : Seq Error
      locals               : Set Name
      output               : SELF

-}
{-
   local variables for Patterns.Cons:
      copy
      output

-}
{-
   local variables for Patterns.Nil:
      copy
      output

-}
-- semantic domain
newtype T_Patterns = T_Patterns ((Constructor) ->
                                 (Nonterminal) ->
                                 ( (Bool),(Patterns),(Set (Name,Name)),(Seq Error),(Set Name),(Patterns)))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (Prelude.foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((Prelude.map sem_Pattern list)))
data Inh_Patterns = Inh_Patterns {con_Inh_Patterns :: Constructor,nt_Inh_Patterns :: Nonterminal}
data Syn_Patterns = Syn_Patterns {containsVars_Syn_Patterns :: Bool,copy_Syn_Patterns :: Patterns,definedAttrs_Syn_Patterns :: Set (Name,Name),errors_Syn_Patterns :: Seq Error,locals_Syn_Patterns :: Set Name,output_Syn_Patterns :: Patterns}
wrap_Patterns :: (T_Patterns) ->
                 (Inh_Patterns) ->
                 (Syn_Patterns)
wrap_Patterns ((T_Patterns (sem))) ((Inh_Patterns (i1) (i2))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2))
    in  (Syn_Patterns (s1) (s2) (s3) (s4) (s5) (s6))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons ((T_Pattern (hd_))) ((T_Patterns (tl_))) =
    (T_Patterns (\ _lhsIcon
                   _lhsInt ->
                     let _lhsOcontainsVars :: (Bool)
                         _lhsOcopy :: (Patterns)
                         _lhsOdefinedAttrs :: (Set (Name,Name))
                         _lhsOerrors :: (Seq Error)
                         _lhsOlocals :: (Set Name)
                         _lhsOoutput :: (Patterns)
                         _hdIcontainsVars :: (Bool)
                         _hdIcopy :: (Pattern)
                         _hdIdefinedAttrs :: (Set (Name,Name))
                         _hdIerrors :: (Seq Error)
                         _hdIlocals :: (Set Name)
                         _hdIoutput :: (Pattern)
                         _hdOcon :: (Constructor)
                         _hdOnt :: (Nonterminal)
                         _tlIcontainsVars :: (Bool)
                         _tlIcopy :: (Patterns)
                         _tlIdefinedAttrs :: (Set (Name,Name))
                         _tlIerrors :: (Seq Error)
                         _tlIlocals :: (Set Name)
                         _tlIoutput :: (Patterns)
                         _tlOcon :: (Constructor)
                         _tlOnt :: (Nonterminal)
                         ( _hdIcontainsVars,_hdIcopy,_hdIdefinedAttrs,_hdIerrors,_hdIlocals,_hdIoutput) =
                             (hd_ (_hdOcon) (_hdOnt))
                         ( _tlIcontainsVars,_tlIcopy,_tlIdefinedAttrs,_tlIerrors,_tlIlocals,_tlIoutput) =
                             (tl_ (_tlOcon) (_tlOnt))
                         -- use rule
                         (_lhsOcontainsVars@_) =
                             _hdIcontainsVars || _tlIcontainsVars
                         -- use rule
                         (_lhsOdefinedAttrs@_) =
                             _hdIdefinedAttrs `Set.union` _tlIdefinedAttrs
                         -- use rule
                         (_lhsOerrors@_) =
                             _hdIerrors Seq.<> _tlIerrors
                         -- use rule
                         (_lhsOlocals@_) =
                             _hdIlocals `Set.union` _tlIlocals
                         -- self rule
                         (_copy@_) =
                             (:) _hdIcopy _tlIcopy
                         -- self rule
                         (_output@_) =
                             (:) _hdIoutput _tlIoutput
                         -- self rule
                         (_lhsOcopy@_) =
                             _copy
                         -- self rule
                         (_lhsOoutput@_) =
                             _output
                         -- copy rule (down)
                         (_hdOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_hdOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_tlOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_tlOnt@_) =
                             _lhsInt
                     in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    (T_Patterns (\ _lhsIcon
                   _lhsInt ->
                     let _lhsOcontainsVars :: (Bool)
                         _lhsOcopy :: (Patterns)
                         _lhsOdefinedAttrs :: (Set (Name,Name))
                         _lhsOerrors :: (Seq Error)
                         _lhsOlocals :: (Set Name)
                         _lhsOoutput :: (Patterns)
                         -- use rule
                         (_lhsOcontainsVars@_) =
                             False
                         -- use rule
                         (_lhsOdefinedAttrs@_) =
                             Set.empty
                         -- use rule
                         (_lhsOerrors@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOlocals@_) =
                             Set.empty
                         -- self rule
                         (_copy@_) =
                             []
                         -- self rule
                         (_output@_) =
                             []
                         -- self rule
                         (_lhsOcopy@_) =
                             _copy
                         -- self rule
                         (_lhsOoutput@_) =
                             _output
                     in  ( _lhsOcontainsVars,_lhsOcopy,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
-- Production --------------------------------------------------
{-
   inherited attributes:
      cr                   : Bool
      nonterminals         : Set Nonterminal
      o_rename             : Bool
      typeSyns             : TypeSyns
      useMap               : UseMap

   chained attributes:

   synthesised attributes:
      collect_nts          : Set Nonterminal
      errors               : Seq Error
      output               : SELF

-}
{-
   local variables for Production.Production:
      output

-}
-- semantic domain
newtype T_Production = T_Production ((Bool) ->
                                     (Set Nonterminal) ->
                                     (Bool) ->
                                     (TypeSyns) ->
                                     (UseMap) ->
                                     ( (Set Nonterminal),(Seq Error),(Production)))
-- cata
sem_Production :: (Production) ->
                  (T_Production)
sem_Production ((Production (_nt) (_inh) (_syn) (_alts))) =
    (sem_Production_Production (_nt) (_inh) (_syn) ((sem_Alternatives (_alts))))
data Inh_Production = Inh_Production {cr_Inh_Production :: Bool,nonterminals_Inh_Production :: Set Nonterminal,o_rename_Inh_Production :: Bool,typeSyns_Inh_Production :: TypeSyns,useMap_Inh_Production :: UseMap}
data Syn_Production = Syn_Production {collect_nts_Syn_Production :: Set Nonterminal,errors_Syn_Production :: Seq Error,output_Syn_Production :: Production}
wrap_Production :: (T_Production) ->
                   (Inh_Production) ->
                   (Syn_Production)
wrap_Production ((T_Production (sem))) ((Inh_Production (i1) (i2) (i3) (i4) (i5))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5))
    in  (Syn_Production (s1) (s2) (s3))
sem_Production_Production :: (Nonterminal) ->
                             (Attributes) ->
                             (Attributes) ->
                             (T_Alternatives) ->
                             (T_Production)
sem_Production_Production (nt_) (inh_) (syn_) ((T_Alternatives (alts_))) =
    (T_Production (\ _lhsIcr
                     _lhsInonterminals
                     _lhsIo_rename
                     _lhsItypeSyns
                     _lhsIuseMap ->
                       let _lhsOcollect_nts :: (Set Nonterminal)
                           _lhsOerrors :: (Seq Error)
                           _lhsOoutput :: (Production)
                           _altsIerrors :: (Seq Error)
                           _altsIoutput :: (Alternatives)
                           _altsOcr :: (Bool)
                           _altsOinh :: (Attributes)
                           _altsOnonterminals :: (Set Nonterminal)
                           _altsOnt :: (Nonterminal)
                           _altsOo_rename :: (Bool)
                           _altsOsyn :: (Attributes)
                           _altsOtypeSyns :: (TypeSyns)
                           _altsOuseMap :: (Map Name (String,String,String))
                           ( _altsIerrors,_altsIoutput) =
                               (alts_ (_altsOcr) (_altsOinh) (_altsOnonterminals) (_altsOnt) (_altsOo_rename) (_altsOsyn) (_altsOtypeSyns) (_altsOuseMap))
                           -- "DefaultRules.ag"(line 115, column 16)
                           (_lhsOcollect_nts@_) =
                               Set.single nt_
                           -- "DefaultRules.ag"(line 132, column 17)
                           (_altsOuseMap@_) =
                               Map.findWithDefault Map.empty nt_ _lhsIuseMap
                           -- "DefaultRules.ag"(line 131, column 17)
                           (_altsOsyn@_) =
                               syn_
                           -- "DefaultRules.ag"(line 130, column 17)
                           (_altsOinh@_) =
                               inh_
                           -- "DefaultRules.ag"(line 144, column 16)
                           (_altsOnt@_) =
                               nt_
                           -- use rule
                           (_lhsOerrors@_) =
                               _altsIerrors
                           -- self rule
                           (_output@_) =
                               Production nt_ inh_ syn_ _altsIoutput
                           -- self rule
                           (_lhsOoutput@_) =
                               _output
                           -- copy rule (down)
                           (_altsOcr@_) =
                               _lhsIcr
                           -- copy rule (down)
                           (_altsOnonterminals@_) =
                               _lhsInonterminals
                           -- copy rule (down)
                           (_altsOo_rename@_) =
                               _lhsIo_rename
                           -- copy rule (down)
                           (_altsOtypeSyns@_) =
                               _lhsItypeSyns
                       in  ( _lhsOcollect_nts,_lhsOerrors,_lhsOoutput)))
-- Productions -------------------------------------------------
{-
   inherited attributes:
      cr                   : Bool
      nonterminals         : Set Nonterminal
      o_rename             : Bool
      typeSyns             : TypeSyns
      useMap               : UseMap

   chained attributes:

   synthesised attributes:
      collect_nts          : Set Nonterminal
      errors               : Seq Error
      output               : SELF

-}
{-
   local variables for Productions.Cons:
      output

-}
{-
   local variables for Productions.Nil:
      output

-}
-- semantic domain
newtype T_Productions = T_Productions ((Bool) ->
                                       (Set Nonterminal) ->
                                       (Bool) ->
                                       (TypeSyns) ->
                                       (UseMap) ->
                                       ( (Set Nonterminal),(Seq Error),(Productions)))
-- cata
sem_Productions :: (Productions) ->
                   (T_Productions)
sem_Productions (list) =
    (Prelude.foldr (sem_Productions_Cons) (sem_Productions_Nil) ((Prelude.map sem_Production list)))
data Inh_Productions = Inh_Productions {cr_Inh_Productions :: Bool,nonterminals_Inh_Productions :: Set Nonterminal,o_rename_Inh_Productions :: Bool,typeSyns_Inh_Productions :: TypeSyns,useMap_Inh_Productions :: UseMap}
data Syn_Productions = Syn_Productions {collect_nts_Syn_Productions :: Set Nonterminal,errors_Syn_Productions :: Seq Error,output_Syn_Productions :: Productions}
wrap_Productions :: (T_Productions) ->
                    (Inh_Productions) ->
                    (Syn_Productions)
wrap_Productions ((T_Productions (sem))) ((Inh_Productions (i1) (i2) (i3) (i4) (i5))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5))
    in  (Syn_Productions (s1) (s2) (s3))
sem_Productions_Cons :: (T_Production) ->
                        (T_Productions) ->
                        (T_Productions)
sem_Productions_Cons ((T_Production (hd_))) ((T_Productions (tl_))) =
    (T_Productions (\ _lhsIcr
                      _lhsInonterminals
                      _lhsIo_rename
                      _lhsItypeSyns
                      _lhsIuseMap ->
                        let _lhsOcollect_nts :: (Set Nonterminal)
                            _lhsOerrors :: (Seq Error)
                            _lhsOoutput :: (Productions)
                            _hdIcollect_nts :: (Set Nonterminal)
                            _hdIerrors :: (Seq Error)
                            _hdIoutput :: (Production)
                            _hdOcr :: (Bool)
                            _hdOnonterminals :: (Set Nonterminal)
                            _hdOo_rename :: (Bool)
                            _hdOtypeSyns :: (TypeSyns)
                            _hdOuseMap :: (UseMap)
                            _tlIcollect_nts :: (Set Nonterminal)
                            _tlIerrors :: (Seq Error)
                            _tlIoutput :: (Productions)
                            _tlOcr :: (Bool)
                            _tlOnonterminals :: (Set Nonterminal)
                            _tlOo_rename :: (Bool)
                            _tlOtypeSyns :: (TypeSyns)
                            _tlOuseMap :: (UseMap)
                            ( _hdIcollect_nts,_hdIerrors,_hdIoutput) =
                                (hd_ (_hdOcr) (_hdOnonterminals) (_hdOo_rename) (_hdOtypeSyns) (_hdOuseMap))
                            ( _tlIcollect_nts,_tlIerrors,_tlIoutput) =
                                (tl_ (_tlOcr) (_tlOnonterminals) (_tlOo_rename) (_tlOtypeSyns) (_tlOuseMap))
                            -- use rule
                            (_lhsOcollect_nts@_) =
                                _hdIcollect_nts `Set.union` _tlIcollect_nts
                            -- use rule
                            (_lhsOerrors@_) =
                                _hdIerrors Seq.<> _tlIerrors
                            -- self rule
                            (_output@_) =
                                (:) _hdIoutput _tlIoutput
                            -- self rule
                            (_lhsOoutput@_) =
                                _output
                            -- copy rule (down)
                            (_hdOcr@_) =
                                _lhsIcr
                            -- copy rule (down)
                            (_hdOnonterminals@_) =
                                _lhsInonterminals
                            -- copy rule (down)
                            (_hdOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_hdOtypeSyns@_) =
                                _lhsItypeSyns
                            -- copy rule (down)
                            (_hdOuseMap@_) =
                                _lhsIuseMap
                            -- copy rule (down)
                            (_tlOcr@_) =
                                _lhsIcr
                            -- copy rule (down)
                            (_tlOnonterminals@_) =
                                _lhsInonterminals
                            -- copy rule (down)
                            (_tlOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_tlOtypeSyns@_) =
                                _lhsItypeSyns
                            -- copy rule (down)
                            (_tlOuseMap@_) =
                                _lhsIuseMap
                        in  ( _lhsOcollect_nts,_lhsOerrors,_lhsOoutput)))
sem_Productions_Nil :: (T_Productions)
sem_Productions_Nil  =
    (T_Productions (\ _lhsIcr
                      _lhsInonterminals
                      _lhsIo_rename
                      _lhsItypeSyns
                      _lhsIuseMap ->
                        let _lhsOcollect_nts :: (Set Nonterminal)
                            _lhsOerrors :: (Seq Error)
                            _lhsOoutput :: (Productions)
                            -- use rule
                            (_lhsOcollect_nts@_) =
                                Set.empty
                            -- use rule
                            (_lhsOerrors@_) =
                                Seq.empty
                            -- self rule
                            (_output@_) =
                                []
                            -- self rule
                            (_lhsOoutput@_) =
                                _output
                        in  ( _lhsOcollect_nts,_lhsOerrors,_lhsOoutput)))
-- Rule --------------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      containsVars         : Bool
      definedAttrs         : Set (Name,Name)
      errors               : Seq Error
      locals               : Set Name
      output               : SELF

-}
{-
   local variables for Rule.Rule:
      output

-}
-- semantic domain
newtype T_Rule = T_Rule ((Constructor) ->
                         (Nonterminal) ->
                         ( (Bool),(Set (Name,Name)),(Seq Error),(Set Name),(Rule)))
-- cata
sem_Rule :: (Rule) ->
            (T_Rule)
sem_Rule ((Rule (_pattern) (_rhs) (_owrt) (_origin))) =
    (sem_Rule_Rule ((sem_Pattern (_pattern))) (_rhs) (_owrt) (_origin))
data Inh_Rule = Inh_Rule {con_Inh_Rule :: Constructor,nt_Inh_Rule :: Nonterminal}
data Syn_Rule = Syn_Rule {containsVars_Syn_Rule :: Bool,definedAttrs_Syn_Rule :: Set (Name,Name),errors_Syn_Rule :: Seq Error,locals_Syn_Rule :: Set Name,output_Syn_Rule :: Rule}
wrap_Rule :: (T_Rule) ->
             (Inh_Rule) ->
             (Syn_Rule)
wrap_Rule ((T_Rule (sem))) ((Inh_Rule (i1) (i2))) =
    let ( s1,s2,s3,s4,s5) =
            (sem (i1) (i2))
    in  (Syn_Rule (s1) (s2) (s3) (s4) (s5))
sem_Rule_Rule :: (T_Pattern) ->
                 (Expression) ->
                 (Bool) ->
                 (String) ->
                 (T_Rule)
sem_Rule_Rule ((T_Pattern (pattern_))) (rhs_) (owrt_) (origin_) =
    (T_Rule (\ _lhsIcon
               _lhsInt ->
                 let _lhsOcontainsVars :: (Bool)
                     _lhsOdefinedAttrs :: (Set (Name,Name))
                     _lhsOerrors :: (Seq Error)
                     _lhsOlocals :: (Set Name)
                     _lhsOoutput :: (Rule)
                     _patternIcontainsVars :: (Bool)
                     _patternIcopy :: (Pattern)
                     _patternIdefinedAttrs :: (Set (Name,Name))
                     _patternIerrors :: (Seq Error)
                     _patternIlocals :: (Set Name)
                     _patternIoutput :: (Pattern)
                     _patternOcon :: (Constructor)
                     _patternOnt :: (Nonterminal)
                     ( _patternIcontainsVars,_patternIcopy,_patternIdefinedAttrs,_patternIerrors,_patternIlocals,_patternIoutput) =
                         (pattern_ (_patternOcon) (_patternOnt))
                     -- use rule
                     (_lhsOcontainsVars@_) =
                         _patternIcontainsVars
                     -- use rule
                     (_lhsOdefinedAttrs@_) =
                         _patternIdefinedAttrs
                     -- use rule
                     (_lhsOerrors@_) =
                         _patternIerrors
                     -- use rule
                     (_lhsOlocals@_) =
                         _patternIlocals
                     -- self rule
                     (_output@_) =
                         Rule _patternIoutput rhs_ owrt_ origin_
                     -- self rule
                     (_lhsOoutput@_) =
                         _output
                     -- copy rule (down)
                     (_patternOcon@_) =
                         _lhsIcon
                     -- copy rule (down)
                     (_patternOnt@_) =
                         _lhsInt
                 in  ( _lhsOcontainsVars,_lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
-- Rules -------------------------------------------------------
{-
   inherited attributes:
      con                  : Constructor
      nt                   : Nonterminal

   chained attributes:

   synthesised attributes:
      definedAttrs         : Set (Name,Name)
      errors               : Seq Error
      locals               : Set Name
      output               : SELF

-}
{-
   local variables for Rules.Cons:
      output

-}
{-
   local variables for Rules.Nil:
      output

-}
-- semantic domain
newtype T_Rules = T_Rules ((Constructor) ->
                           (Nonterminal) ->
                           ( (Set (Name,Name)),(Seq Error),(Set Name),(Rules)))
-- cata
sem_Rules :: (Rules) ->
             (T_Rules)
sem_Rules (list) =
    (Prelude.foldr (sem_Rules_Cons) (sem_Rules_Nil) ((Prelude.map sem_Rule list)))
data Inh_Rules = Inh_Rules {con_Inh_Rules :: Constructor,nt_Inh_Rules :: Nonterminal}
data Syn_Rules = Syn_Rules {definedAttrs_Syn_Rules :: Set (Name,Name),errors_Syn_Rules :: Seq Error,locals_Syn_Rules :: Set Name,output_Syn_Rules :: Rules}
wrap_Rules :: (T_Rules) ->
              (Inh_Rules) ->
              (Syn_Rules)
wrap_Rules ((T_Rules (sem))) ((Inh_Rules (i1) (i2))) =
    let ( s1,s2,s3,s4) =
            (sem (i1) (i2))
    in  (Syn_Rules (s1) (s2) (s3) (s4))
sem_Rules_Cons :: (T_Rule) ->
                  (T_Rules) ->
                  (T_Rules)
sem_Rules_Cons ((T_Rule (hd_))) ((T_Rules (tl_))) =
    (T_Rules (\ _lhsIcon
                _lhsInt ->
                  let _lhsOdefinedAttrs :: (Set (Name,Name))
                      _lhsOerrors :: (Seq Error)
                      _lhsOlocals :: (Set Name)
                      _lhsOoutput :: (Rules)
                      _hdIcontainsVars :: (Bool)
                      _hdIdefinedAttrs :: (Set (Name,Name))
                      _hdIerrors :: (Seq Error)
                      _hdIlocals :: (Set Name)
                      _hdIoutput :: (Rule)
                      _hdOcon :: (Constructor)
                      _hdOnt :: (Nonterminal)
                      _tlIdefinedAttrs :: (Set (Name,Name))
                      _tlIerrors :: (Seq Error)
                      _tlIlocals :: (Set Name)
                      _tlIoutput :: (Rules)
                      _tlOcon :: (Constructor)
                      _tlOnt :: (Nonterminal)
                      ( _hdIcontainsVars,_hdIdefinedAttrs,_hdIerrors,_hdIlocals,_hdIoutput) =
                          (hd_ (_hdOcon) (_hdOnt))
                      ( _tlIdefinedAttrs,_tlIerrors,_tlIlocals,_tlIoutput) =
                          (tl_ (_tlOcon) (_tlOnt))
                      -- "DefaultRules.ag"(line 407, column 10)
                      (_lhsOoutput@_) =
                          if _hdIcontainsVars then _output else _tlIoutput
                      -- use rule
                      (_lhsOdefinedAttrs@_) =
                          _hdIdefinedAttrs `Set.union` _tlIdefinedAttrs
                      -- use rule
                      (_lhsOerrors@_) =
                          _hdIerrors Seq.<> _tlIerrors
                      -- use rule
                      (_lhsOlocals@_) =
                          _hdIlocals `Set.union` _tlIlocals
                      -- self rule
                      (_output@_) =
                          (:) _hdIoutput _tlIoutput
                      -- copy rule (down)
                      (_hdOcon@_) =
                          _lhsIcon
                      -- copy rule (down)
                      (_hdOnt@_) =
                          _lhsInt
                      -- copy rule (down)
                      (_tlOcon@_) =
                          _lhsIcon
                      -- copy rule (down)
                      (_tlOnt@_) =
                          _lhsInt
                  in  ( _lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
sem_Rules_Nil :: (T_Rules)
sem_Rules_Nil  =
    (T_Rules (\ _lhsIcon
                _lhsInt ->
                  let _lhsOdefinedAttrs :: (Set (Name,Name))
                      _lhsOerrors :: (Seq Error)
                      _lhsOlocals :: (Set Name)
                      _lhsOoutput :: (Rules)
                      -- use rule
                      (_lhsOdefinedAttrs@_) =
                          Set.empty
                      -- use rule
                      (_lhsOerrors@_) =
                          Seq.empty
                      -- use rule
                      (_lhsOlocals@_) =
                          Set.empty
                      -- self rule
                      (_output@_) =
                          []
                      -- self rule
                      (_lhsOoutput@_) =
                          _output
                  in  ( _lhsOdefinedAttrs,_lhsOerrors,_lhsOlocals,_lhsOoutput)))
-- TypeSig -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      output               : SELF

-}
{-
   local variables for TypeSig.TypeSig:
      output

-}
-- semantic domain
newtype T_TypeSig = T_TypeSig (( (TypeSig)))
-- cata
sem_TypeSig :: (TypeSig) ->
               (T_TypeSig)
sem_TypeSig ((TypeSig (_name) (_tp))) =
    (sem_TypeSig_TypeSig (_name) (_tp))
data Inh_TypeSig = Inh_TypeSig {}
data Syn_TypeSig = Syn_TypeSig {output_Syn_TypeSig :: TypeSig}
wrap_TypeSig :: (T_TypeSig) ->
                (Inh_TypeSig) ->
                (Syn_TypeSig)
wrap_TypeSig ((T_TypeSig (sem))) ((Inh_TypeSig )) =
    let ( s1) =
            (sem )
    in  (Syn_TypeSig (s1))
sem_TypeSig_TypeSig :: (Name) ->
                       (Type) ->
                       (T_TypeSig)
sem_TypeSig_TypeSig (name_) (tp_) =
    (T_TypeSig (let _lhsOoutput :: (TypeSig)
                    -- self rule
                    (_output@_) =
                        TypeSig name_ tp_
                    -- self rule
                    (_lhsOoutput@_) =
                        _output
                in  ( _lhsOoutput)))
-- TypeSigs ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      output               : SELF

-}
{-
   local variables for TypeSigs.Cons:
      output

-}
{-
   local variables for TypeSigs.Nil:
      output

-}
-- semantic domain
newtype T_TypeSigs = T_TypeSigs (( (TypeSigs)))
-- cata
sem_TypeSigs :: (TypeSigs) ->
                (T_TypeSigs)
sem_TypeSigs (list) =
    (Prelude.foldr (sem_TypeSigs_Cons) (sem_TypeSigs_Nil) ((Prelude.map sem_TypeSig list)))
data Inh_TypeSigs = Inh_TypeSigs {}
data Syn_TypeSigs = Syn_TypeSigs {output_Syn_TypeSigs :: TypeSigs}
wrap_TypeSigs :: (T_TypeSigs) ->
                 (Inh_TypeSigs) ->
                 (Syn_TypeSigs)
wrap_TypeSigs ((T_TypeSigs (sem))) ((Inh_TypeSigs )) =
    let ( s1) =
            (sem )
    in  (Syn_TypeSigs (s1))
sem_TypeSigs_Cons :: (T_TypeSig) ->
                     (T_TypeSigs) ->
                     (T_TypeSigs)
sem_TypeSigs_Cons ((T_TypeSig (hd_))) ((T_TypeSigs (tl_))) =
    (T_TypeSigs (let _lhsOoutput :: (TypeSigs)
                     _hdIoutput :: (TypeSig)
                     _tlIoutput :: (TypeSigs)
                     ( _hdIoutput) =
                         (hd_ )
                     ( _tlIoutput) =
                         (tl_ )
                     -- self rule
                     (_output@_) =
                         (:) _hdIoutput _tlIoutput
                     -- self rule
                     (_lhsOoutput@_) =
                         _output
                 in  ( _lhsOoutput)))
sem_TypeSigs_Nil :: (T_TypeSigs)
sem_TypeSigs_Nil  =
    (T_TypeSigs (let _lhsOoutput :: (TypeSigs)
                     -- self rule
                     (_output@_) =
                         []
                     -- self rule
                     (_lhsOoutput@_) =
                         _output
                 in  ( _lhsOoutput)))


