-- do not edit; automatically generated by UU.AG
module GenerateCode where

import SequentialTypes
import Code hiding (Type)
import qualified Code
import Options
import CodeSyntax
import ErrorMessages
import GrammarInfo

import qualified UU.DData.Map as Map
import UU.DData.Map(Map) 
import qualified UU.DData.Set as Set
import UU.DData.Set(Set) 
import qualified UU.DData.Seq as Seq
import UU.DData.Seq(Seq)

import Data.List(partition,intersperse,intersect,(\\))
import Maybe(fromJust,isJust)

import Patterns
import CommonTypes
import UU.DData.Map(Map)
import UU.DData.Set(Set)
import Data.Graph(Vertex)

-- Patterns.ag imports
import UU.Scanner.Position(Pos)
import CommonTypes (Constructor,Name)

mkLambda [] e = e
mkLambda xs e = Lambda xs e

makeLocalComment :: String -> Name -> Maybe Type -> String
makeLocalComment what  name tp = let  x = getName name
                                      y = maybe "_" (\t -> case t of (NT nt) -> getName nt; Haskell t -> '{':t++"}") tp
                                 in   ( what ++ " " ++ x ++ replicate ((14 - length x) `max` 0) ' ' ++ " : " ++ y )


-- Lets or nested Cases?
mkLet :: Bool -> Decls -> Expr -> Expr
mkLet False decls body = Let decls body
mkLet True decls body = foldr oneCase body decls

oneCase :: Decl -> Expr -> Expr
oneCase (Decl left rhs) exp = Case rhs [CaseAlt left exp]
oneCase _               exp = exp

-- Gives the name of the visit function
funname field 0  = show field ++ "_"
funname field nr = show field ++ "_" ++ show nr

-- Gives the name of a semantic function
seqSemname :: String -> Nonterminal -> Constructor -> Int -> String
seqSemname pre nt con  0 = semname pre nt con
seqSemname pre nt con nr = semname pre nt con ++ "_" ++ show nr

-- Gives the name of a type
typeName :: Nonterminal -> Int -> String
typeName nt 0 = "T_" ++ show nt
typeName nt n = "T_" ++ show nt ++ "_" ++ show n

-- Gives the name of a visit function
visitname  ::  String -> Nonterminal -> Int -> String
visitname pre nt n =  pre ++ getName nt ++ "_" ++ show n
-- CAlternative ------------------------------------------------
{-
   inherited attributes:
      inh                  : Attributes
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      with_sig             : Bool

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      cataAlt              : Decl
      comments             : [String]
      dataAlt              : DataAlt
      decls                : Decls

-}
{-
   local variables for CAlternative.CAlternative:

-}
-- semantic domain
newtype T_CAlternative = T_CAlternative ((Seq Error) ->
                                         (Attributes) ->
                                         (Nonterminal) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Maybe Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (String) ->
                                         (Attributes) ->
                                         (Bool) ->
                                         ( (Bool),(Decl),([String]),(DataAlt),(Decls),(Seq Error)))
-- cata
sem_CAlternative :: (CAlternative) ->
                    (T_CAlternative)
sem_CAlternative ((CAlternative (_con) (_visits) (_children) (_terminals))) =
    (sem_CAlternative_CAlternative (_con) ((sem_CVisits (_visits))) (_children) (_terminals))
data Inh_CAlternative = Inh_CAlternative {errors_Inh_CAlternative :: Seq Error
                                         ,inh_Inh_CAlternative :: Attributes
                                         ,nt_Inh_CAlternative :: Nonterminal
                                         ,o_case_Inh_CAlternative :: Bool
                                         ,o_cata_Inh_CAlternative :: Bool
                                         ,o_data_Inh_CAlternative :: Maybe Bool
                                         ,o_newtypes_Inh_CAlternative :: Bool
                                         ,o_pretty_Inh_CAlternative :: Bool
                                         ,o_rename_Inh_CAlternative :: Bool
                                         ,o_sem_Inh_CAlternative :: Bool
                                         ,o_sig_Inh_CAlternative :: Bool
                                         ,o_strictwrap_Inh_CAlternative :: Bool
                                         ,o_unbox_Inh_CAlternative :: Bool
                                         ,prefix_Inh_CAlternative :: String
                                         ,syn_Inh_CAlternative :: Attributes
                                         ,with_sig_Inh_CAlternative :: Bool
                                         }
data Syn_CAlternative = Syn_CAlternative {allTpsFound_Syn_CAlternative :: Bool,cataAlt_Syn_CAlternative :: Decl,comments_Syn_CAlternative :: [String],dataAlt_Syn_CAlternative :: DataAlt,decls_Syn_CAlternative :: Decls,errors_Syn_CAlternative :: Seq Error}
wrap_CAlternative :: (T_CAlternative) ->
                     (Inh_CAlternative) ->
                     (Syn_CAlternative)
wrap_CAlternative ((T_CAlternative (sem))) ((Inh_CAlternative (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_CAlternative (s1) (s2) (s3) (s4) (s5) (s6))
sem_CAlternative_CAlternative :: (Constructor) ->
                                 (T_CVisits) ->
                                 ([(Name,Type)]) ->
                                 ([Name]) ->
                                 (T_CAlternative)
sem_CAlternative_CAlternative (con_) ((T_CVisits (visits_))) (children_) (terminals_) =
    (T_CAlternative (\ _lhsIerrors
                       _lhsIinh
                       _lhsInt
                       _lhsIo_case
                       _lhsIo_cata
                       _lhsIo_data
                       _lhsIo_newtypes
                       _lhsIo_pretty
                       _lhsIo_rename
                       _lhsIo_sem
                       _lhsIo_sig
                       _lhsIo_strictwrap
                       _lhsIo_unbox
                       _lhsIprefix
                       _lhsIsyn
                       _lhsIwith_sig ->
                         let _lhsOallTpsFound :: (Bool)
                             _lhsOcataAlt :: (Decl)
                             _lhsOcomments :: ([String])
                             _lhsOdataAlt :: (DataAlt)
                             _lhsOdecls :: (Decls)
                             _lhsOerrors :: (Seq Error)
                             _visitsIallTpsFound :: (Bool)
                             _visitsIcomments :: ([String])
                             _visitsIdecls :: (Decls)
                             _visitsIerrors :: (Seq Error)
                             _visitsIintra :: (Exprs)
                             _visitsIisNil :: (Bool)
                             _visitsOchildren :: ([(Name,Type)])
                             _visitsOcon :: (Constructor)
                             _visitsOerrors :: (Seq Error)
                             _visitsOinh :: (Attributes)
                             _visitsOnr :: (Int)
                             _visitsOnt :: (Nonterminal)
                             _visitsOo_case :: (Bool)
                             _visitsOo_cata :: (Bool)
                             _visitsOo_data :: (Maybe Bool)
                             _visitsOo_newtypes :: (Bool)
                             _visitsOo_pretty :: (Bool)
                             _visitsOo_rename :: (Bool)
                             _visitsOo_sem :: (Bool)
                             _visitsOo_sig :: (Bool)
                             _visitsOo_strictwrap :: (Bool)
                             _visitsOo_unbox :: (Bool)
                             _visitsOprefix :: (String)
                             _visitsOsyn :: (Attributes)
                             _visitsOterminals :: ([Name])
                             _visitsOwith_sig :: (Bool)
                             ( _visitsIallTpsFound,_visitsIcomments,_visitsIdecls,_visitsIerrors,_visitsIintra,_visitsIisNil) =
                                 (visits_ (_visitsOchildren) (_visitsOcon) (_visitsOerrors) (_visitsOinh) (_visitsOnr) (_visitsOnt) (_visitsOo_case) (_visitsOo_cata) (_visitsOo_data) (_visitsOo_newtypes) (_visitsOo_pretty) (_visitsOo_rename) (_visitsOo_sem) (_visitsOo_sig) (_visitsOo_strictwrap) (_visitsOo_unbox) (_visitsOprefix) (_visitsOsyn) (_visitsOterminals) (_visitsOwith_sig))
                             -- "GenerateCode.ag"(line 66, column 20)
                             (_visitsOterminals@_) =
                                 terminals_
                             -- "GenerateCode.ag"(line 65, column 20)
                             (_visitsOcon@_) =
                                 con_
                             -- "GenerateCode.ag"(line 94, column 19)
                             (_visitsOnr@_) =
                                 0
                             -- "GenerateCode.ag"(line 163, column 19)
                             (_visitsOchildren@_) =
                                 children_
                             -- "GenerateCode.ag"(line 318, column 18)
                             (_lhsOcomments@_) =
                                 ("alternative " ++ getName con_ ++ ":")
                                 : map ind (  map (\(x,y) -> makeLocalComment "child" x (Just y)) children_
                                           ++ _visitsIcomments
                                           )
                             -- "GenerateCode.ag"(line 415, column 18)
                             (_lhsOdataAlt@_) =
                                 DataAlt (conname _lhsIo_rename _lhsInt con_) (map (typeToString _lhsInt .snd) children_)
                             -- "GenerateCode.ag"(line 470, column 18)
                             (_lhsOcataAlt@_) =
                                 let lhs = Fun (cataname _lhsIprefix _lhsInt) [lhs_pat]
                                     lhs_pat = App (conname _lhsIo_rename _lhsInt con_)
                                                   (map (SimpleExpr . locname . fst) children_)
                                     rhs = App (semname _lhsIprefix _lhsInt con_)
                                               (map argument children_)
                                     argument (nm,NT tp) = App (cataname _lhsIprefix tp)
                                                               [SimpleExpr (locname nm)]
                                     argument (nm, _)    = SimpleExpr (locname nm)
                                 in Decl lhs rhs
                             -- use rule
                             (_lhsOallTpsFound@_) =
                                 _visitsIallTpsFound
                             -- use rule
                             (_lhsOdecls@_) =
                                 _visitsIdecls
                             -- use rule
                             (_lhsOerrors@_) =
                                 _visitsIerrors
                             -- copy rule (down)
                             (_visitsOerrors@_) =
                                 _lhsIerrors
                             -- copy rule (down)
                             (_visitsOinh@_) =
                                 _lhsIinh
                             -- copy rule (down)
                             (_visitsOnt@_) =
                                 _lhsInt
                             -- copy rule (down)
                             (_visitsOo_case@_) =
                                 _lhsIo_case
                             -- copy rule (down)
                             (_visitsOo_cata@_) =
                                 _lhsIo_cata
                             -- copy rule (down)
                             (_visitsOo_data@_) =
                                 _lhsIo_data
                             -- copy rule (down)
                             (_visitsOo_newtypes@_) =
                                 _lhsIo_newtypes
                             -- copy rule (down)
                             (_visitsOo_pretty@_) =
                                 _lhsIo_pretty
                             -- copy rule (down)
                             (_visitsOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_visitsOo_sem@_) =
                                 _lhsIo_sem
                             -- copy rule (down)
                             (_visitsOo_sig@_) =
                                 _lhsIo_sig
                             -- copy rule (down)
                             (_visitsOo_strictwrap@_) =
                                 _lhsIo_strictwrap
                             -- copy rule (down)
                             (_visitsOo_unbox@_) =
                                 _lhsIo_unbox
                             -- copy rule (down)
                             (_visitsOprefix@_) =
                                 _lhsIprefix
                             -- copy rule (down)
                             (_visitsOsyn@_) =
                                 _lhsIsyn
                             -- copy rule (down)
                             (_visitsOwith_sig@_) =
                                 _lhsIwith_sig
                         in  ( _lhsOallTpsFound,_lhsOcataAlt,_lhsOcomments,_lhsOdataAlt,_lhsOdecls,_lhsOerrors)))
-- CAlternatives -----------------------------------------------
{-
   inherited attributes:
      inh                  : Attributes
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      with_sig             : Bool

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      cataAlts             : Decls
      comments             : [String]
      dataAlts             : DataAlts
      decls                : Decls

-}
{-
   local variables for CAlternatives.Cons:

-}
{-
   local variables for CAlternatives.Nil:

-}
-- semantic domain
newtype T_CAlternatives = T_CAlternatives ((Seq Error) ->
                                           (Attributes) ->
                                           (Nonterminal) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Maybe Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (Bool) ->
                                           (String) ->
                                           (Attributes) ->
                                           (Bool) ->
                                           ( (Bool),(Decls),([String]),(DataAlts),(Decls),(Seq Error)))
-- cata
sem_CAlternatives :: (CAlternatives) ->
                     (T_CAlternatives)
sem_CAlternatives (list) =
    (Prelude.foldr (sem_CAlternatives_Cons) (sem_CAlternatives_Nil) ((Prelude.map sem_CAlternative list)))
data Inh_CAlternatives = Inh_CAlternatives {errors_Inh_CAlternatives :: Seq Error
                                           ,inh_Inh_CAlternatives :: Attributes
                                           ,nt_Inh_CAlternatives :: Nonterminal
                                           ,o_case_Inh_CAlternatives :: Bool
                                           ,o_cata_Inh_CAlternatives :: Bool
                                           ,o_data_Inh_CAlternatives :: Maybe Bool
                                           ,o_newtypes_Inh_CAlternatives :: Bool
                                           ,o_pretty_Inh_CAlternatives :: Bool
                                           ,o_rename_Inh_CAlternatives :: Bool
                                           ,o_sem_Inh_CAlternatives :: Bool
                                           ,o_sig_Inh_CAlternatives :: Bool
                                           ,o_strictwrap_Inh_CAlternatives :: Bool
                                           ,o_unbox_Inh_CAlternatives :: Bool
                                           ,prefix_Inh_CAlternatives :: String
                                           ,syn_Inh_CAlternatives :: Attributes
                                           ,with_sig_Inh_CAlternatives :: Bool
                                           }
data Syn_CAlternatives = Syn_CAlternatives {allTpsFound_Syn_CAlternatives :: Bool,cataAlts_Syn_CAlternatives :: Decls,comments_Syn_CAlternatives :: [String],dataAlts_Syn_CAlternatives :: DataAlts,decls_Syn_CAlternatives :: Decls,errors_Syn_CAlternatives :: Seq Error}
wrap_CAlternatives :: (T_CAlternatives) ->
                      (Inh_CAlternatives) ->
                      (Syn_CAlternatives)
wrap_CAlternatives ((T_CAlternatives (sem))) ((Inh_CAlternatives (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_CAlternatives (s1) (s2) (s3) (s4) (s5) (s6))
sem_CAlternatives_Cons :: (T_CAlternative) ->
                          (T_CAlternatives) ->
                          (T_CAlternatives)
sem_CAlternatives_Cons ((T_CAlternative (hd_))) ((T_CAlternatives (tl_))) =
    (T_CAlternatives (\ _lhsIerrors
                        _lhsIinh
                        _lhsInt
                        _lhsIo_case
                        _lhsIo_cata
                        _lhsIo_data
                        _lhsIo_newtypes
                        _lhsIo_pretty
                        _lhsIo_rename
                        _lhsIo_sem
                        _lhsIo_sig
                        _lhsIo_strictwrap
                        _lhsIo_unbox
                        _lhsIprefix
                        _lhsIsyn
                        _lhsIwith_sig ->
                          let _lhsOallTpsFound :: (Bool)
                              _lhsOcataAlts :: (Decls)
                              _lhsOcomments :: ([String])
                              _lhsOdataAlts :: (DataAlts)
                              _lhsOdecls :: (Decls)
                              _lhsOerrors :: (Seq Error)
                              _hdIallTpsFound :: (Bool)
                              _hdIcataAlt :: (Decl)
                              _hdIcomments :: ([String])
                              _hdIdataAlt :: (DataAlt)
                              _hdIdecls :: (Decls)
                              _hdIerrors :: (Seq Error)
                              _hdOerrors :: (Seq Error)
                              _hdOinh :: (Attributes)
                              _hdOnt :: (Nonterminal)
                              _hdOo_case :: (Bool)
                              _hdOo_cata :: (Bool)
                              _hdOo_data :: (Maybe Bool)
                              _hdOo_newtypes :: (Bool)
                              _hdOo_pretty :: (Bool)
                              _hdOo_rename :: (Bool)
                              _hdOo_sem :: (Bool)
                              _hdOo_sig :: (Bool)
                              _hdOo_strictwrap :: (Bool)
                              _hdOo_unbox :: (Bool)
                              _hdOprefix :: (String)
                              _hdOsyn :: (Attributes)
                              _hdOwith_sig :: (Bool)
                              _tlIallTpsFound :: (Bool)
                              _tlIcataAlts :: (Decls)
                              _tlIcomments :: ([String])
                              _tlIdataAlts :: (DataAlts)
                              _tlIdecls :: (Decls)
                              _tlIerrors :: (Seq Error)
                              _tlOerrors :: (Seq Error)
                              _tlOinh :: (Attributes)
                              _tlOnt :: (Nonterminal)
                              _tlOo_case :: (Bool)
                              _tlOo_cata :: (Bool)
                              _tlOo_data :: (Maybe Bool)
                              _tlOo_newtypes :: (Bool)
                              _tlOo_pretty :: (Bool)
                              _tlOo_rename :: (Bool)
                              _tlOo_sem :: (Bool)
                              _tlOo_sig :: (Bool)
                              _tlOo_strictwrap :: (Bool)
                              _tlOo_unbox :: (Bool)
                              _tlOprefix :: (String)
                              _tlOsyn :: (Attributes)
                              _tlOwith_sig :: (Bool)
                              ( _hdIallTpsFound,_hdIcataAlt,_hdIcomments,_hdIdataAlt,_hdIdecls,_hdIerrors) =
                                  (hd_ (_hdOerrors) (_hdOinh) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_newtypes) (_hdOo_pretty) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_strictwrap) (_hdOo_unbox) (_hdOprefix) (_hdOsyn) (_hdOwith_sig))
                              ( _tlIallTpsFound,_tlIcataAlts,_tlIcomments,_tlIdataAlts,_tlIdecls,_tlIerrors) =
                                  (tl_ (_tlOerrors) (_tlOinh) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_newtypes) (_tlOo_pretty) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_strictwrap) (_tlOo_unbox) (_tlOprefix) (_tlOsyn) (_tlOwith_sig))
                              -- "GenerateCode.ag"(line 411, column 17)
                              (_lhsOdataAlts@_) =
                                  _hdIdataAlt : _tlIdataAlts
                              -- "GenerateCode.ag"(line 466, column 10)
                              (_lhsOcataAlts@_) =
                                  _hdIcataAlt : _tlIcataAlts
                              -- use rule
                              (_lhsOallTpsFound@_) =
                                  _hdIallTpsFound && _tlIallTpsFound
                              -- use rule
                              (_lhsOcomments@_) =
                                  _hdIcomments ++ _tlIcomments
                              -- use rule
                              (_lhsOdecls@_) =
                                  _hdIdecls ++ _tlIdecls
                              -- use rule
                              (_lhsOerrors@_) =
                                  _hdIerrors Seq.<> _tlIerrors
                              -- copy rule (down)
                              (_hdOerrors@_) =
                                  _lhsIerrors
                              -- copy rule (down)
                              (_hdOinh@_) =
                                  _lhsIinh
                              -- copy rule (down)
                              (_hdOnt@_) =
                                  _lhsInt
                              -- copy rule (down)
                              (_hdOo_case@_) =
                                  _lhsIo_case
                              -- copy rule (down)
                              (_hdOo_cata@_) =
                                  _lhsIo_cata
                              -- copy rule (down)
                              (_hdOo_data@_) =
                                  _lhsIo_data
                              -- copy rule (down)
                              (_hdOo_newtypes@_) =
                                  _lhsIo_newtypes
                              -- copy rule (down)
                              (_hdOo_pretty@_) =
                                  _lhsIo_pretty
                              -- copy rule (down)
                              (_hdOo_rename@_) =
                                  _lhsIo_rename
                              -- copy rule (down)
                              (_hdOo_sem@_) =
                                  _lhsIo_sem
                              -- copy rule (down)
                              (_hdOo_sig@_) =
                                  _lhsIo_sig
                              -- copy rule (down)
                              (_hdOo_strictwrap@_) =
                                  _lhsIo_strictwrap
                              -- copy rule (down)
                              (_hdOo_unbox@_) =
                                  _lhsIo_unbox
                              -- copy rule (down)
                              (_hdOprefix@_) =
                                  _lhsIprefix
                              -- copy rule (down)
                              (_hdOsyn@_) =
                                  _lhsIsyn
                              -- copy rule (down)
                              (_hdOwith_sig@_) =
                                  _lhsIwith_sig
                              -- copy rule (chain)
                              (_tlOerrors@_) =
                                  _hdIerrors
                              -- copy rule (down)
                              (_tlOinh@_) =
                                  _lhsIinh
                              -- copy rule (down)
                              (_tlOnt@_) =
                                  _lhsInt
                              -- copy rule (down)
                              (_tlOo_case@_) =
                                  _lhsIo_case
                              -- copy rule (down)
                              (_tlOo_cata@_) =
                                  _lhsIo_cata
                              -- copy rule (down)
                              (_tlOo_data@_) =
                                  _lhsIo_data
                              -- copy rule (down)
                              (_tlOo_newtypes@_) =
                                  _lhsIo_newtypes
                              -- copy rule (down)
                              (_tlOo_pretty@_) =
                                  _lhsIo_pretty
                              -- copy rule (down)
                              (_tlOo_rename@_) =
                                  _lhsIo_rename
                              -- copy rule (down)
                              (_tlOo_sem@_) =
                                  _lhsIo_sem
                              -- copy rule (down)
                              (_tlOo_sig@_) =
                                  _lhsIo_sig
                              -- copy rule (down)
                              (_tlOo_strictwrap@_) =
                                  _lhsIo_strictwrap
                              -- copy rule (down)
                              (_tlOo_unbox@_) =
                                  _lhsIo_unbox
                              -- copy rule (down)
                              (_tlOprefix@_) =
                                  _lhsIprefix
                              -- copy rule (down)
                              (_tlOsyn@_) =
                                  _lhsIsyn
                              -- copy rule (down)
                              (_tlOwith_sig@_) =
                                  _lhsIwith_sig
                          in  ( _lhsOallTpsFound,_lhsOcataAlts,_lhsOcomments,_lhsOdataAlts,_lhsOdecls,_lhsOerrors)))
sem_CAlternatives_Nil :: (T_CAlternatives)
sem_CAlternatives_Nil  =
    (T_CAlternatives (\ _lhsIerrors
                        _lhsIinh
                        _lhsInt
                        _lhsIo_case
                        _lhsIo_cata
                        _lhsIo_data
                        _lhsIo_newtypes
                        _lhsIo_pretty
                        _lhsIo_rename
                        _lhsIo_sem
                        _lhsIo_sig
                        _lhsIo_strictwrap
                        _lhsIo_unbox
                        _lhsIprefix
                        _lhsIsyn
                        _lhsIwith_sig ->
                          let _lhsOallTpsFound :: (Bool)
                              _lhsOcataAlts :: (Decls)
                              _lhsOcomments :: ([String])
                              _lhsOdataAlts :: (DataAlts)
                              _lhsOdecls :: (Decls)
                              _lhsOerrors :: (Seq Error)
                              -- "GenerateCode.ag"(line 412, column 17)
                              (_lhsOdataAlts@_) =
                                  []
                              -- "GenerateCode.ag"(line 467, column 10)
                              (_lhsOcataAlts@_) =
                                  []
                              -- use rule
                              (_lhsOallTpsFound@_) =
                                  True
                              -- use rule
                              (_lhsOcomments@_) =
                                  []
                              -- use rule
                              (_lhsOdecls@_) =
                                  []
                              -- use rule
                              (_lhsOerrors@_) =
                                  Seq.empty
                          in  ( _lhsOallTpsFound,_lhsOcataAlts,_lhsOcomments,_lhsOdataAlts,_lhsOdecls,_lhsOerrors)))
-- CGrammar ----------------------------------------------------
{-
   inherited attributes:
      options              : Options

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      output               : Program

-}
{-
   local variables for CGrammar.CGrammar:

-}
-- semantic domain
newtype T_CGrammar = T_CGrammar ((Options) ->
                                 ( (Seq Error),(Program)))
-- cata
sem_CGrammar :: (CGrammar) ->
                (T_CGrammar)
sem_CGrammar ((CGrammar (_typeSyns) (_derivings) (_wrappers) (_prods))) =
    (sem_CGrammar_CGrammar (_typeSyns) (_derivings) (_wrappers) ((sem_CProductions (_prods))))
data Inh_CGrammar = Inh_CGrammar {options_Inh_CGrammar :: Options}
data Syn_CGrammar = Syn_CGrammar {errors_Syn_CGrammar :: Seq Error,output_Syn_CGrammar :: Program}
wrap_CGrammar :: (T_CGrammar) ->
                 (Inh_CGrammar) ->
                 (Syn_CGrammar)
wrap_CGrammar ((T_CGrammar (sem))) ((Inh_CGrammar (i1))) =
    let ( s1,s2) =
            (sem (i1))
    in  (Syn_CGrammar (s1) (s2))
sem_CGrammar_CGrammar :: (TypeSyns) ->
                         (Derivings) ->
                         (Set Nonterminal) ->
                         (T_CProductions) ->
                         (T_CGrammar)
sem_CGrammar_CGrammar (typeSyns_) (derivings_) (wrappers_) ((T_CProductions (prods_))) =
    (T_CGrammar (\ _lhsIoptions ->
                     let _lhsOerrors :: (Seq Error)
                         _lhsOoutput :: (Program)
                         _prodsIallTpsFound :: (Bool)
                         _prodsIdecls :: (Decls)
                         _prodsIerrors :: (Seq Error)
                         _prodsOderivings :: (Derivings)
                         _prodsOerrors :: (Seq Error)
                         _prodsOo_case :: (Bool)
                         _prodsOo_cata :: (Bool)
                         _prodsOo_data :: (Maybe Bool)
                         _prodsOo_newtypes :: (Bool)
                         _prodsOo_pretty :: (Bool)
                         _prodsOo_rename :: (Bool)
                         _prodsOo_sem :: (Bool)
                         _prodsOo_sig :: (Bool)
                         _prodsOo_strictwrap :: (Bool)
                         _prodsOo_unbox :: (Bool)
                         _prodsOprefix :: (String)
                         _prodsOtypeSyns :: (TypeSyns)
                         _prodsOwith_sig :: (Bool)
                         _prodsOwrappers :: (Set Nonterminal)
                         ( _prodsIallTpsFound,_prodsIdecls,_prodsIerrors) =
                             (prods_ (_prodsOderivings) (_prodsOerrors) (_prodsOo_case) (_prodsOo_cata) (_prodsOo_data) (_prodsOo_newtypes) (_prodsOo_pretty) (_prodsOo_rename) (_prodsOo_sem) (_prodsOo_sig) (_prodsOo_strictwrap) (_prodsOo_unbox) (_prodsOprefix) (_prodsOtypeSyns) (_prodsOwith_sig) (_prodsOwrappers))
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOprefix@_) =
                             prefix        _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_data@_) =
                             if dataTypes _lhsIoptions then Just (strictData _lhsIoptions) else Nothing
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_strictwrap@_) =
                             strictWrap    _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_rename@_) =
                             rename        _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_pretty@_) =
                             attrInfo      _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_case@_) =
                             cases         _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_unbox@_) =
                             unbox         _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_newtypes@_) =
                             newtypes      _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_sem@_) =
                             semfuns       _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_cata@_) =
                             folds         _lhsIoptions
                         -- "GenerateCode.ag"(line 39, column 17)
                         (_prodsOo_sig@_) =
                             typeSigs      _lhsIoptions
                         -- "GenerateCode.ag"(line 289, column 14)
                         (_prodsOwith_sig@_) =
                             typeSigs _lhsIoptions && _prodsIallTpsFound
                         -- "GenerateCode.ag"(line 296, column 15)
                         (_prodsOerrors@_) =
                             Seq.empty
                         -- "GenerateCode.ag"(line 342, column 17)
                         (_lhsOoutput@_) =
                             if smacro _lhsIoptions
                              then Program (_prodsIdecls                                                                       )
                              else Program _prodsIdecls
                         -- "GenerateCode.ag"(line 390, column 14)
                         (_prodsOwrappers@_) =
                             wrappers_
                         -- "GenerateCode.ag"(line 390, column 14)
                         (_prodsOderivings@_) =
                             derivings_
                         -- "GenerateCode.ag"(line 390, column 14)
                         (_prodsOtypeSyns@_) =
                             typeSyns_
                         -- copy rule (up)
                         (_lhsOerrors@_) =
                             _prodsIerrors
                     in  ( _lhsOerrors,_lhsOoutput)))
-- CInterface --------------------------------------------------
{-
   inherited attributes:
      inh                  : Attributes
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      comments             : [String]
      semDom               : [Decl]
      wrapDecls            : Decls

-}
{-
   local variables for CInterface.CInterface:

-}
-- semantic domain
newtype T_CInterface = T_CInterface ((Attributes) ->
                                     (Nonterminal) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Maybe Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (String) ->
                                     (Attributes) ->
                                     ( ([String]),([Decl]),(Decls)))
-- cata
sem_CInterface :: (CInterface) ->
                  (T_CInterface)
sem_CInterface ((CInterface (_seg))) =
    (sem_CInterface_CInterface ((sem_CSegments (_seg))))
data Inh_CInterface = Inh_CInterface {inh_Inh_CInterface :: Attributes
                                     ,nt_Inh_CInterface :: Nonterminal
                                     ,o_case_Inh_CInterface :: Bool
                                     ,o_cata_Inh_CInterface :: Bool
                                     ,o_data_Inh_CInterface :: Maybe Bool
                                     ,o_newtypes_Inh_CInterface :: Bool
                                     ,o_pretty_Inh_CInterface :: Bool
                                     ,o_rename_Inh_CInterface :: Bool
                                     ,o_sem_Inh_CInterface :: Bool
                                     ,o_sig_Inh_CInterface :: Bool
                                     ,o_strictwrap_Inh_CInterface :: Bool
                                     ,o_unbox_Inh_CInterface :: Bool
                                     ,prefix_Inh_CInterface :: String
                                     ,syn_Inh_CInterface :: Attributes
                                     }
data Syn_CInterface = Syn_CInterface {comments_Syn_CInterface :: [String],semDom_Syn_CInterface :: [Decl],wrapDecls_Syn_CInterface :: Decls}
wrap_CInterface :: (T_CInterface) ->
                   (Inh_CInterface) ->
                   (Syn_CInterface)
wrap_CInterface ((T_CInterface (sem))) ((Inh_CInterface (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14))
    in  (Syn_CInterface (s1) (s2) (s3))
sem_CInterface_CInterface :: (T_CSegments) ->
                             (T_CInterface)
sem_CInterface_CInterface ((T_CSegments (seg_))) =
    (T_CInterface (\ _lhsIinh
                     _lhsInt
                     _lhsIo_case
                     _lhsIo_cata
                     _lhsIo_data
                     _lhsIo_newtypes
                     _lhsIo_pretty
                     _lhsIo_rename
                     _lhsIo_sem
                     _lhsIo_sig
                     _lhsIo_strictwrap
                     _lhsIo_unbox
                     _lhsIprefix
                     _lhsIsyn ->
                       let _lhsOcomments :: ([String])
                           _lhsOsemDom :: ([Decl])
                           _lhsOwrapDecls :: (Decls)
                           _segIcomments :: ([String])
                           _segIisNil :: (Bool)
                           _segIsemDom :: ([Decl])
                           _segIwrapDecls :: (Decls)
                           _segOinh :: (Attributes)
                           _segOnr :: (Int)
                           _segOnt :: (Nonterminal)
                           _segOo_case :: (Bool)
                           _segOo_cata :: (Bool)
                           _segOo_data :: (Maybe Bool)
                           _segOo_newtypes :: (Bool)
                           _segOo_pretty :: (Bool)
                           _segOo_rename :: (Bool)
                           _segOo_sem :: (Bool)
                           _segOo_sig :: (Bool)
                           _segOo_strictwrap :: (Bool)
                           _segOo_unbox :: (Bool)
                           _segOprefix :: (String)
                           _segOsyn :: (Attributes)
                           ( _segIcomments,_segIisNil,_segIsemDom,_segIwrapDecls) =
                               (seg_ (_segOinh) (_segOnr) (_segOnt) (_segOo_case) (_segOo_cata) (_segOo_data) (_segOo_newtypes) (_segOo_pretty) (_segOo_rename) (_segOo_sem) (_segOo_sig) (_segOo_strictwrap) (_segOo_unbox) (_segOprefix) (_segOsyn))
                           -- "GenerateCode.ag"(line 98, column 17)
                           (_segOnr@_) =
                               0
                           -- "GenerateCode.ag"(line 226, column 18)
                           (_lhsOsemDom@_) =
                               Comment "semantic domain" : _segIsemDom
                           -- use rule
                           (_lhsOcomments@_) =
                               _segIcomments
                           -- use rule
                           (_lhsOwrapDecls@_) =
                               _segIwrapDecls
                           -- copy rule (down)
                           (_segOinh@_) =
                               _lhsIinh
                           -- copy rule (down)
                           (_segOnt@_) =
                               _lhsInt
                           -- copy rule (down)
                           (_segOo_case@_) =
                               _lhsIo_case
                           -- copy rule (down)
                           (_segOo_cata@_) =
                               _lhsIo_cata
                           -- copy rule (down)
                           (_segOo_data@_) =
                               _lhsIo_data
                           -- copy rule (down)
                           (_segOo_newtypes@_) =
                               _lhsIo_newtypes
                           -- copy rule (down)
                           (_segOo_pretty@_) =
                               _lhsIo_pretty
                           -- copy rule (down)
                           (_segOo_rename@_) =
                               _lhsIo_rename
                           -- copy rule (down)
                           (_segOo_sem@_) =
                               _lhsIo_sem
                           -- copy rule (down)
                           (_segOo_sig@_) =
                               _lhsIo_sig
                           -- copy rule (down)
                           (_segOo_strictwrap@_) =
                               _lhsIo_strictwrap
                           -- copy rule (down)
                           (_segOo_unbox@_) =
                               _lhsIo_unbox
                           -- copy rule (down)
                           (_segOprefix@_) =
                               _lhsIprefix
                           -- copy rule (down)
                           (_segOsyn@_) =
                               _lhsIsyn
                       in  ( _lhsOcomments,_lhsOsemDom,_lhsOwrapDecls)))
-- CProduction -------------------------------------------------
{-
   inherited attributes:
      derivings            : Derivings
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      typeSyns             : TypeSyns
      with_sig             : Bool
      wrappers             : Set Nonterminal

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      decls                : Decls

-}
{-
   local variables for CProduction.CProduction:
      semWrapper
      comment
      dataDef
      cataFun

-}
-- semantic domain
newtype T_CProduction = T_CProduction ((Derivings) ->
                                       (Seq Error) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Maybe Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (String) ->
                                       (TypeSyns) ->
                                       (Bool) ->
                                       (Set Nonterminal) ->
                                       ( (Bool),(Decls),(Seq Error)))
-- cata
sem_CProduction :: (CProduction) ->
                   (T_CProduction)
sem_CProduction ((CProduction (_nt) (_inh) (_syn) (_alts) (_inter))) =
    (sem_CProduction_CProduction (_nt) (_inh) (_syn) ((sem_CAlternatives (_alts))) ((sem_CInterface (_inter))))
data Inh_CProduction = Inh_CProduction {derivings_Inh_CProduction :: Derivings
                                       ,errors_Inh_CProduction :: Seq Error
                                       ,o_case_Inh_CProduction :: Bool
                                       ,o_cata_Inh_CProduction :: Bool
                                       ,o_data_Inh_CProduction :: Maybe Bool
                                       ,o_newtypes_Inh_CProduction :: Bool
                                       ,o_pretty_Inh_CProduction :: Bool
                                       ,o_rename_Inh_CProduction :: Bool
                                       ,o_sem_Inh_CProduction :: Bool
                                       ,o_sig_Inh_CProduction :: Bool
                                       ,o_strictwrap_Inh_CProduction :: Bool
                                       ,o_unbox_Inh_CProduction :: Bool
                                       ,prefix_Inh_CProduction :: String
                                       ,typeSyns_Inh_CProduction :: TypeSyns
                                       ,with_sig_Inh_CProduction :: Bool
                                       ,wrappers_Inh_CProduction :: Set Nonterminal
                                       }
data Syn_CProduction = Syn_CProduction {allTpsFound_Syn_CProduction :: Bool,decls_Syn_CProduction :: Decls,errors_Syn_CProduction :: Seq Error}
wrap_CProduction :: (T_CProduction) ->
                    (Inh_CProduction) ->
                    (Syn_CProduction)
wrap_CProduction ((T_CProduction (sem))) ((Inh_CProduction (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_CProduction (s1) (s2) (s3))
sem_CProduction_CProduction :: (Nonterminal) ->
                               (Attributes) ->
                               (Attributes) ->
                               (T_CAlternatives) ->
                               (T_CInterface) ->
                               (T_CProduction)
sem_CProduction_CProduction (nt_) (inh_) (syn_) ((T_CAlternatives (alts_))) ((T_CInterface (inter_))) =
    (T_CProduction (\ _lhsIderivings
                      _lhsIerrors
                      _lhsIo_case
                      _lhsIo_cata
                      _lhsIo_data
                      _lhsIo_newtypes
                      _lhsIo_pretty
                      _lhsIo_rename
                      _lhsIo_sem
                      _lhsIo_sig
                      _lhsIo_strictwrap
                      _lhsIo_unbox
                      _lhsIprefix
                      _lhsItypeSyns
                      _lhsIwith_sig
                      _lhsIwrappers ->
                        let _lhsOallTpsFound :: (Bool)
                            _lhsOdecls :: (Decls)
                            _lhsOerrors :: (Seq Error)
                            _altsIallTpsFound :: (Bool)
                            _altsIcataAlts :: (Decls)
                            _altsIcomments :: ([String])
                            _altsIdataAlts :: (DataAlts)
                            _altsIdecls :: (Decls)
                            _altsIerrors :: (Seq Error)
                            _altsOerrors :: (Seq Error)
                            _altsOinh :: (Attributes)
                            _altsOnt :: (Nonterminal)
                            _altsOo_case :: (Bool)
                            _altsOo_cata :: (Bool)
                            _altsOo_data :: (Maybe Bool)
                            _altsOo_newtypes :: (Bool)
                            _altsOo_pretty :: (Bool)
                            _altsOo_rename :: (Bool)
                            _altsOo_sem :: (Bool)
                            _altsOo_sig :: (Bool)
                            _altsOo_strictwrap :: (Bool)
                            _altsOo_unbox :: (Bool)
                            _altsOprefix :: (String)
                            _altsOsyn :: (Attributes)
                            _altsOwith_sig :: (Bool)
                            _interIcomments :: ([String])
                            _interIsemDom :: ([Decl])
                            _interIwrapDecls :: (Decls)
                            _interOinh :: (Attributes)
                            _interOnt :: (Nonterminal)
                            _interOo_case :: (Bool)
                            _interOo_cata :: (Bool)
                            _interOo_data :: (Maybe Bool)
                            _interOo_newtypes :: (Bool)
                            _interOo_pretty :: (Bool)
                            _interOo_rename :: (Bool)
                            _interOo_sem :: (Bool)
                            _interOo_sig :: (Bool)
                            _interOo_strictwrap :: (Bool)
                            _interOo_unbox :: (Bool)
                            _interOprefix :: (String)
                            _interOsyn :: (Attributes)
                            ( _altsIallTpsFound,_altsIcataAlts,_altsIcomments,_altsIdataAlts,_altsIdecls,_altsIerrors) =
                                (alts_ (_altsOerrors) (_altsOinh) (_altsOnt) (_altsOo_case) (_altsOo_cata) (_altsOo_data) (_altsOo_newtypes) (_altsOo_pretty) (_altsOo_rename) (_altsOo_sem) (_altsOo_sig) (_altsOo_strictwrap) (_altsOo_unbox) (_altsOprefix) (_altsOsyn) (_altsOwith_sig))
                            ( _interIcomments,_interIsemDom,_interIwrapDecls) =
                                (inter_ (_interOinh) (_interOnt) (_interOo_case) (_interOo_cata) (_interOo_data) (_interOo_newtypes) (_interOo_pretty) (_interOo_rename) (_interOo_sem) (_interOo_sig) (_interOo_strictwrap) (_interOo_unbox) (_interOprefix) (_interOsyn))
                            -- "GenerateCode.ag"(line 60, column 24)
                            ((_altsOinh@_,_altsOsyn@_,_altsOnt@_)) =
                                (inh_,syn_,nt_)
                            -- "GenerateCode.ag"(line 59, column 25)
                            ((_interOinh@_,_interOsyn@_,_interOnt@_)) =
                                (inh_,syn_,nt_)
                            -- "GenerateCode.ag"(line 245, column 17)
                            (_semWrapper@_) =
                                let inhAttrs = Map.toList inh_
                                    synAttrs = Map.toList syn_
                                    inhVars = [ SimpleExpr (attrname True _LHS a) | (a,_) <- inhAttrs ]
                                    synVars = [ SimpleExpr (attrname False _LHS a) | (a,_) <- synAttrs ]
                                    var = "sem"
                                    wrapNT = "wrap" ++ "_" ++ getName nt_
                                    inhNT = "Inh" ++ "_" ++ getName nt_
                                    synNT = "Syn" ++ "_" ++ getName nt_
                                    varPat = if  _lhsIo_newtypes
                                                 then App (sdtype nt_) [SimpleExpr var]
                                                 else SimpleExpr var
                                    typeSig = TSig wrapNT (SimpleType (sdtype nt_) `Arr` (SimpleType inhNT `Arr` SimpleType synNT))
                                    mkstrict = if _lhsIo_strictwrap then (\x -> "!(" ++ x ++ ")") else id
                                    mkdata n attrs = Data n [Record n [(getName f++"_"++n,mkstrict $ typeToString nt_ t) | (f,t) <- attrs]] False []
                                    datas = [mkdata inhNT inhAttrs, mkdata synNT synAttrs]
                                in datas ++ [Decl (Fun wrapNT [varPat, App inhNT inhVars])
                                                  (Let _interIwrapDecls (App synNT synVars))]
                            -- "GenerateCode.ag"(line 307, column 17)
                            (_comment@_) =
                                Comment . unlines . map ind $ ( _interIcomments ++ ("alternatives:" : map ind _altsIcomments) )
                            -- "GenerateCode.ag"(line 347, column 18)
                            (_lhsOdecls@_) =
                                Comment (getName nt_ ++ " " ++ replicate (60 - length (getName nt_)) '-')
                                :  (if _lhsIo_pretty                  then [_comment    ]   else [])
                                ++ (if isJust _lhsIo_data             then [_dataDef    ]   else [])
                                ++ (if _lhsIo_cata                    then  _cataFun        else [])
                                ++ (if _lhsIo_sig                     then  _interIsemDom   else [])
                                ++ (if nt_ `Set.member` _lhsIwrappers then  _semWrapper     else [])
                                ++ (if _lhsIo_sem                     then  _altsIdecls     else [])
                            -- "GenerateCode.ag"(line 395, column 17)
                            (_dataDef@_) =
                                let typeSyn tp = let theType =
                                                      case tp of
                                                        CommonTypes.Maybe t  -> SimpleType ("Maybe (" ++ typeToString nt_ t ++")")
                                                        CommonTypes.List t   -> Code.List $ SimpleType (typeToString nt_ t)
                                                        CommonTypes.Tuple ts -> Code.TupleType [SimpleType (typeToString nt_ t)
                                                                                               | (_,t) <- ts
                                                                                               ]
                                                 in Code.Type (getName nt_) theType
                                    derivings  = maybe [] (map getName . Set.toList) (Map.lookup nt_ _lhsIderivings)
                                    dataDef    = Data (getName nt_) _altsIdataAlts (maybe False id _lhsIo_data) derivings
                                in maybe dataDef typeSyn $ lookup nt_ _lhsItypeSyns
                            -- "GenerateCode.ag"(line 422, column 17)
                            (_cataFun@_) =
                                let tSig = TSig (cataname _lhsIprefix nt_)
                                                (SimpleType (getName nt_) `Arr` SimpleType (sdtype nt_))
                                    special typ = case typ of
                                                  CommonTypes.List tp ->
                                                      let cons = SimpleExpr (semname _lhsIprefix nt_ (identifier "Cons"))
                                                          nil  = SimpleExpr (semname _lhsIprefix nt_ (identifier "Nil" ))
                                                          arg  = SimpleExpr "list"
                                                          rarg = case tp of
                                                                   NT t  -> SimpleExpr ("(Prelude.map " ++ (cataname _lhsIprefix t) ++ " list)")
                                                                   _     -> arg
                                                          lhs = Fun (cataname _lhsIprefix nt_) [arg]
                                                          rhs = (App "Prelude.foldr" [cons,nil,rarg])
                                                      in  [Decl lhs rhs]
                                                  CommonTypes.Maybe tp ->
                                                      let just    = semname _lhsIprefix nt_ (identifier "Just")
                                                          nothing = semname _lhsIprefix nt_ (identifier "Nothing" )
                                                          arg  = SimpleExpr "x"
                                                          rarg = case tp of
                                                                   NT t  -> App (cataname _lhsIprefix t) [arg]
                                                                   _     -> arg
                                                          lhs a = Fun (cataname _lhsIprefix nt_) [a]
                                                      in  [Decl (lhs (App "Prelude.Just" [arg]))     (App just [rarg])
                                                          ,Decl (lhs (SimpleExpr "Prelude.Nothing")) (SimpleExpr nothing)
                                                          ]
                                                  CommonTypes.Tuple tps ->
                                                      let con  = semname _lhsIprefix nt_ (identifier "Tuple")
                                                          tps' = [ (SimpleExpr (getName x),y) | (x,y) <- tps]
                                                          rargs = map rarg tps'
                                                          rarg (n, tp) = case tp of
                                                                   NT t  -> App (cataname _lhsIprefix t) [n]
                                                                   _     -> n
                                                          lhs = Fun (cataname _lhsIprefix nt_) [TupleExpr (map fst tps')]
                                                          rhs = App con rargs
                                                      in  [Decl lhs rhs]
                                in  Comment "cata" :
                                    (if _lhsIo_sig then [tSig] else []) ++
                                    maybe _altsIcataAlts special (lookup nt_ _lhsItypeSyns)
                            -- use rule
                            (_lhsOallTpsFound@_) =
                                _altsIallTpsFound
                            -- use rule
                            (_lhsOerrors@_) =
                                _altsIerrors
                            -- copy rule (down)
                            (_altsOerrors@_) =
                                _lhsIerrors
                            -- copy rule (down)
                            (_altsOo_case@_) =
                                _lhsIo_case
                            -- copy rule (down)
                            (_altsOo_cata@_) =
                                _lhsIo_cata
                            -- copy rule (down)
                            (_altsOo_data@_) =
                                _lhsIo_data
                            -- copy rule (down)
                            (_altsOo_newtypes@_) =
                                _lhsIo_newtypes
                            -- copy rule (down)
                            (_altsOo_pretty@_) =
                                _lhsIo_pretty
                            -- copy rule (down)
                            (_altsOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_altsOo_sem@_) =
                                _lhsIo_sem
                            -- copy rule (down)
                            (_altsOo_sig@_) =
                                _lhsIo_sig
                            -- copy rule (down)
                            (_altsOo_strictwrap@_) =
                                _lhsIo_strictwrap
                            -- copy rule (down)
                            (_altsOo_unbox@_) =
                                _lhsIo_unbox
                            -- copy rule (down)
                            (_altsOprefix@_) =
                                _lhsIprefix
                            -- copy rule (down)
                            (_altsOwith_sig@_) =
                                _lhsIwith_sig
                            -- copy rule (down)
                            (_interOo_case@_) =
                                _lhsIo_case
                            -- copy rule (down)
                            (_interOo_cata@_) =
                                _lhsIo_cata
                            -- copy rule (down)
                            (_interOo_data@_) =
                                _lhsIo_data
                            -- copy rule (down)
                            (_interOo_newtypes@_) =
                                _lhsIo_newtypes
                            -- copy rule (down)
                            (_interOo_pretty@_) =
                                _lhsIo_pretty
                            -- copy rule (down)
                            (_interOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_interOo_sem@_) =
                                _lhsIo_sem
                            -- copy rule (down)
                            (_interOo_sig@_) =
                                _lhsIo_sig
                            -- copy rule (down)
                            (_interOo_strictwrap@_) =
                                _lhsIo_strictwrap
                            -- copy rule (down)
                            (_interOo_unbox@_) =
                                _lhsIo_unbox
                            -- copy rule (down)
                            (_interOprefix@_) =
                                _lhsIprefix
                        in  ( _lhsOallTpsFound,_lhsOdecls,_lhsOerrors)))
-- CProductions ------------------------------------------------
{-
   inherited attributes:
      derivings            : Derivings
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      typeSyns             : TypeSyns
      with_sig             : Bool
      wrappers             : Set Nonterminal

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      decls                : Decls

-}
{-
   local variables for CProductions.Cons:

-}
{-
   local variables for CProductions.Nil:

-}
-- semantic domain
newtype T_CProductions = T_CProductions ((Derivings) ->
                                         (Seq Error) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Maybe Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (String) ->
                                         (TypeSyns) ->
                                         (Bool) ->
                                         (Set Nonterminal) ->
                                         ( (Bool),(Decls),(Seq Error)))
-- cata
sem_CProductions :: (CProductions) ->
                    (T_CProductions)
sem_CProductions (list) =
    (Prelude.foldr (sem_CProductions_Cons) (sem_CProductions_Nil) ((Prelude.map sem_CProduction list)))
data Inh_CProductions = Inh_CProductions {derivings_Inh_CProductions :: Derivings
                                         ,errors_Inh_CProductions :: Seq Error
                                         ,o_case_Inh_CProductions :: Bool
                                         ,o_cata_Inh_CProductions :: Bool
                                         ,o_data_Inh_CProductions :: Maybe Bool
                                         ,o_newtypes_Inh_CProductions :: Bool
                                         ,o_pretty_Inh_CProductions :: Bool
                                         ,o_rename_Inh_CProductions :: Bool
                                         ,o_sem_Inh_CProductions :: Bool
                                         ,o_sig_Inh_CProductions :: Bool
                                         ,o_strictwrap_Inh_CProductions :: Bool
                                         ,o_unbox_Inh_CProductions :: Bool
                                         ,prefix_Inh_CProductions :: String
                                         ,typeSyns_Inh_CProductions :: TypeSyns
                                         ,with_sig_Inh_CProductions :: Bool
                                         ,wrappers_Inh_CProductions :: Set Nonterminal
                                         }
data Syn_CProductions = Syn_CProductions {allTpsFound_Syn_CProductions :: Bool,decls_Syn_CProductions :: Decls,errors_Syn_CProductions :: Seq Error}
wrap_CProductions :: (T_CProductions) ->
                     (Inh_CProductions) ->
                     (Syn_CProductions)
wrap_CProductions ((T_CProductions (sem))) ((Inh_CProductions (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_CProductions (s1) (s2) (s3))
sem_CProductions_Cons :: (T_CProduction) ->
                         (T_CProductions) ->
                         (T_CProductions)
sem_CProductions_Cons ((T_CProduction (hd_))) ((T_CProductions (tl_))) =
    (T_CProductions (\ _lhsIderivings
                       _lhsIerrors
                       _lhsIo_case
                       _lhsIo_cata
                       _lhsIo_data
                       _lhsIo_newtypes
                       _lhsIo_pretty
                       _lhsIo_rename
                       _lhsIo_sem
                       _lhsIo_sig
                       _lhsIo_strictwrap
                       _lhsIo_unbox
                       _lhsIprefix
                       _lhsItypeSyns
                       _lhsIwith_sig
                       _lhsIwrappers ->
                         let _lhsOallTpsFound :: (Bool)
                             _lhsOdecls :: (Decls)
                             _lhsOerrors :: (Seq Error)
                             _hdIallTpsFound :: (Bool)
                             _hdIdecls :: (Decls)
                             _hdIerrors :: (Seq Error)
                             _hdOderivings :: (Derivings)
                             _hdOerrors :: (Seq Error)
                             _hdOo_case :: (Bool)
                             _hdOo_cata :: (Bool)
                             _hdOo_data :: (Maybe Bool)
                             _hdOo_newtypes :: (Bool)
                             _hdOo_pretty :: (Bool)
                             _hdOo_rename :: (Bool)
                             _hdOo_sem :: (Bool)
                             _hdOo_sig :: (Bool)
                             _hdOo_strictwrap :: (Bool)
                             _hdOo_unbox :: (Bool)
                             _hdOprefix :: (String)
                             _hdOtypeSyns :: (TypeSyns)
                             _hdOwith_sig :: (Bool)
                             _hdOwrappers :: (Set Nonterminal)
                             _tlIallTpsFound :: (Bool)
                             _tlIdecls :: (Decls)
                             _tlIerrors :: (Seq Error)
                             _tlOderivings :: (Derivings)
                             _tlOerrors :: (Seq Error)
                             _tlOo_case :: (Bool)
                             _tlOo_cata :: (Bool)
                             _tlOo_data :: (Maybe Bool)
                             _tlOo_newtypes :: (Bool)
                             _tlOo_pretty :: (Bool)
                             _tlOo_rename :: (Bool)
                             _tlOo_sem :: (Bool)
                             _tlOo_sig :: (Bool)
                             _tlOo_strictwrap :: (Bool)
                             _tlOo_unbox :: (Bool)
                             _tlOprefix :: (String)
                             _tlOtypeSyns :: (TypeSyns)
                             _tlOwith_sig :: (Bool)
                             _tlOwrappers :: (Set Nonterminal)
                             ( _hdIallTpsFound,_hdIdecls,_hdIerrors) =
                                 (hd_ (_hdOderivings) (_hdOerrors) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_newtypes) (_hdOo_pretty) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_strictwrap) (_hdOo_unbox) (_hdOprefix) (_hdOtypeSyns) (_hdOwith_sig) (_hdOwrappers))
                             ( _tlIallTpsFound,_tlIdecls,_tlIerrors) =
                                 (tl_ (_tlOderivings) (_tlOerrors) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_newtypes) (_tlOo_pretty) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_strictwrap) (_tlOo_unbox) (_tlOprefix) (_tlOtypeSyns) (_tlOwith_sig) (_tlOwrappers))
                             -- use rule
                             (_lhsOallTpsFound@_) =
                                 _hdIallTpsFound && _tlIallTpsFound
                             -- use rule
                             (_lhsOdecls@_) =
                                 _hdIdecls ++ _tlIdecls
                             -- use rule
                             (_lhsOerrors@_) =
                                 _hdIerrors Seq.<> _tlIerrors
                             -- copy rule (down)
                             (_hdOderivings@_) =
                                 _lhsIderivings
                             -- copy rule (down)
                             (_hdOerrors@_) =
                                 _lhsIerrors
                             -- copy rule (down)
                             (_hdOo_case@_) =
                                 _lhsIo_case
                             -- copy rule (down)
                             (_hdOo_cata@_) =
                                 _lhsIo_cata
                             -- copy rule (down)
                             (_hdOo_data@_) =
                                 _lhsIo_data
                             -- copy rule (down)
                             (_hdOo_newtypes@_) =
                                 _lhsIo_newtypes
                             -- copy rule (down)
                             (_hdOo_pretty@_) =
                                 _lhsIo_pretty
                             -- copy rule (down)
                             (_hdOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_hdOo_sem@_) =
                                 _lhsIo_sem
                             -- copy rule (down)
                             (_hdOo_sig@_) =
                                 _lhsIo_sig
                             -- copy rule (down)
                             (_hdOo_strictwrap@_) =
                                 _lhsIo_strictwrap
                             -- copy rule (down)
                             (_hdOo_unbox@_) =
                                 _lhsIo_unbox
                             -- copy rule (down)
                             (_hdOprefix@_) =
                                 _lhsIprefix
                             -- copy rule (down)
                             (_hdOtypeSyns@_) =
                                 _lhsItypeSyns
                             -- copy rule (down)
                             (_hdOwith_sig@_) =
                                 _lhsIwith_sig
                             -- copy rule (down)
                             (_hdOwrappers@_) =
                                 _lhsIwrappers
                             -- copy rule (down)
                             (_tlOderivings@_) =
                                 _lhsIderivings
                             -- copy rule (chain)
                             (_tlOerrors@_) =
                                 _hdIerrors
                             -- copy rule (down)
                             (_tlOo_case@_) =
                                 _lhsIo_case
                             -- copy rule (down)
                             (_tlOo_cata@_) =
                                 _lhsIo_cata
                             -- copy rule (down)
                             (_tlOo_data@_) =
                                 _lhsIo_data
                             -- copy rule (down)
                             (_tlOo_newtypes@_) =
                                 _lhsIo_newtypes
                             -- copy rule (down)
                             (_tlOo_pretty@_) =
                                 _lhsIo_pretty
                             -- copy rule (down)
                             (_tlOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_tlOo_sem@_) =
                                 _lhsIo_sem
                             -- copy rule (down)
                             (_tlOo_sig@_) =
                                 _lhsIo_sig
                             -- copy rule (down)
                             (_tlOo_strictwrap@_) =
                                 _lhsIo_strictwrap
                             -- copy rule (down)
                             (_tlOo_unbox@_) =
                                 _lhsIo_unbox
                             -- copy rule (down)
                             (_tlOprefix@_) =
                                 _lhsIprefix
                             -- copy rule (down)
                             (_tlOtypeSyns@_) =
                                 _lhsItypeSyns
                             -- copy rule (down)
                             (_tlOwith_sig@_) =
                                 _lhsIwith_sig
                             -- copy rule (down)
                             (_tlOwrappers@_) =
                                 _lhsIwrappers
                         in  ( _lhsOallTpsFound,_lhsOdecls,_lhsOerrors)))
sem_CProductions_Nil :: (T_CProductions)
sem_CProductions_Nil  =
    (T_CProductions (\ _lhsIderivings
                       _lhsIerrors
                       _lhsIo_case
                       _lhsIo_cata
                       _lhsIo_data
                       _lhsIo_newtypes
                       _lhsIo_pretty
                       _lhsIo_rename
                       _lhsIo_sem
                       _lhsIo_sig
                       _lhsIo_strictwrap
                       _lhsIo_unbox
                       _lhsIprefix
                       _lhsItypeSyns
                       _lhsIwith_sig
                       _lhsIwrappers ->
                         let _lhsOallTpsFound :: (Bool)
                             _lhsOdecls :: (Decls)
                             _lhsOerrors :: (Seq Error)
                             -- use rule
                             (_lhsOallTpsFound@_) =
                                 True
                             -- use rule
                             (_lhsOdecls@_) =
                                 []
                             -- use rule
                             (_lhsOerrors@_) =
                                 Seq.empty
                         in  ( _lhsOallTpsFound,_lhsOdecls,_lhsOerrors)))
-- CRule -------------------------------------------------------
{-
   inherited attributes:
      children             : [(Name,Type)]
      con                  : Constructor
      inh                  : Attributes
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      terminals            : [Name]

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      comments             : [String]
      decls                : Decls
      exprs                : Exprs
      tSigs                : [Decl]
      tps                  : [Type]

-}
{-
   local variables for CRule.CChildVisit:
      nextTp
      definedTps
      mkTp

-}
{-
   local variables for CRule.CRule:
      originComment
      mkTp

-}
-- semantic domain
newtype T_CRule = T_CRule (([(Name,Type)]) ->
                           (Constructor) ->
                           (Seq Error) ->
                           (Attributes) ->
                           (Nonterminal) ->
                           (Bool) ->
                           (Bool) ->
                           (Maybe Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (String) ->
                           (Attributes) ->
                           ([Name]) ->
                           ( (Bool),([String]),(Decls),(Seq Error),(Exprs),([Decl]),([Type])))
-- cata
sem_CRule :: (CRule) ->
             (T_CRule)
sem_CRule ((CChildVisit (_name) (_nt) (_nr) (_inh) (_syn) (_last))) =
    (sem_CRule_CChildVisit (_name) (_nt) (_nr) (_inh) (_syn) (_last))
sem_CRule ((CRule (_name) (_isIn) (_hasCode) (_nt) (_con) (_field) (_childnt) (_tp) (_pattern) (_rhs) (_defines) (_owrt) (_origin))) =
    (sem_CRule_CRule (_name) (_isIn) (_hasCode) (_nt) (_con) (_field) (_childnt) (_tp) ((sem_Pattern (_pattern))) (_rhs) (_defines) (_owrt) (_origin))
data Inh_CRule = Inh_CRule {children_Inh_CRule :: [(Name,Type)]
                           ,con_Inh_CRule :: Constructor
                           ,errors_Inh_CRule :: Seq Error
                           ,inh_Inh_CRule :: Attributes
                           ,nt_Inh_CRule :: Nonterminal
                           ,o_case_Inh_CRule :: Bool
                           ,o_cata_Inh_CRule :: Bool
                           ,o_data_Inh_CRule :: Maybe Bool
                           ,o_newtypes_Inh_CRule :: Bool
                           ,o_pretty_Inh_CRule :: Bool
                           ,o_rename_Inh_CRule :: Bool
                           ,o_sem_Inh_CRule :: Bool
                           ,o_sig_Inh_CRule :: Bool
                           ,o_strictwrap_Inh_CRule :: Bool
                           ,o_unbox_Inh_CRule :: Bool
                           ,prefix_Inh_CRule :: String
                           ,syn_Inh_CRule :: Attributes
                           ,terminals_Inh_CRule :: [Name]
                           }
data Syn_CRule = Syn_CRule {allTpsFound_Syn_CRule :: Bool,comments_Syn_CRule :: [String],decls_Syn_CRule :: Decls,errors_Syn_CRule :: Seq Error,exprs_Syn_CRule :: Exprs,tSigs_Syn_CRule :: [Decl],tps_Syn_CRule :: [Type]}
wrap_CRule :: (T_CRule) ->
              (Inh_CRule) ->
              (Syn_CRule)
wrap_CRule ((T_CRule (sem))) ((Inh_CRule (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18))) =
    let ( s1,s2,s3,s4,s5,s6,s7) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18))
    in  (Syn_CRule (s1) (s2) (s3) (s4) (s5) (s6) (s7))
sem_CRule_CChildVisit :: (Name) ->
                         (Nonterminal) ->
                         (Int) ->
                         (Attributes) ->
                         (Attributes) ->
                         (Bool) ->
                         (T_CRule)
sem_CRule_CChildVisit (name_) (nt_) (nr_) (inh_) (syn_) (last_) =
    (T_CRule (\ _lhsIchildren
                _lhsIcon
                _lhsIerrors
                _lhsIinh
                _lhsInt
                _lhsIo_case
                _lhsIo_cata
                _lhsIo_data
                _lhsIo_newtypes
                _lhsIo_pretty
                _lhsIo_rename
                _lhsIo_sem
                _lhsIo_sig
                _lhsIo_strictwrap
                _lhsIo_unbox
                _lhsIprefix
                _lhsIsyn
                _lhsIterminals ->
                  let _lhsOallTpsFound :: (Bool)
                      _lhsOcomments :: ([String])
                      _lhsOdecls :: (Decls)
                      _lhsOerrors :: (Seq Error)
                      _lhsOexprs :: (Exprs)
                      _lhsOtSigs :: ([Decl])
                      _lhsOtps :: ([Type])
                      -- "GenerateCode.ag"(line 80, column 18)
                      (_lhsOdecls@_) =
                          let  lhs =  map (attrname True name_) (Map.keys syn_)
                                      ++ if last_ then [] else [unwrap ++ funname name_ (nr_+1)]
                               unwrap = if _lhsIo_newtypes then typeName nt_ (nr_ + 1) ++ " " else ""
                               tuple = mkTupleLhs _lhsIo_unbox (Map.keys inh_) lhs
                               rhs = App (funname name_ nr_) (map (SimpleExpr . attrname False name_) (Map.keys inh_))
                          in [Decl tuple rhs]
                      -- "GenerateCode.ag"(line 139, column 18)
                      (_lhsOexprs@_) =
                          let wrap = if _lhsIo_newtypes then \x -> App (typeName nt_ (nr_ + 1)) [x] else id
                          in [wrap (SimpleExpr (funname name_ (nr_+1)))]
                      -- "GenerateCode.ag"(line 154, column 19)
                      (_lhsOtSigs@_) =
                          (if last_ then id else (TSig (funname name_ (nr_+1)) (SimpleType _nextTp) :)) _definedTps
                      -- "GenerateCode.ag"(line 153, column 19)
                      (_nextTp@_) =
                          typeName nt_ (nr_+1)
                      -- "GenerateCode.ag"(line 152, column 19)
                      (_definedTps@_) =
                          [ TSig (attrname True name_ a) (_mkTp tp) |  (a,tp) <- Map.toList syn_ ]
                      -- "GenerateCode.ag"(line 151, column 19)
                      (_mkTp@_) =
                          SimpleType . typeToString nt_
                      -- "GenerateCode.ag"(line 170, column 19)
                      (_lhsOtps@_) =
                          [Haskell _nextTp]
                      -- use rule
                      (_lhsOallTpsFound@_) =
                          True
                      -- use rule
                      (_lhsOcomments@_) =
                          []
                      -- use rule
                      (_lhsOerrors@_) =
                          Seq.empty
                  in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOexprs,_lhsOtSigs,_lhsOtps)))
sem_CRule_CRule :: (Name) ->
                   (Bool) ->
                   (Bool) ->
                   (Nonterminal) ->
                   (Constructor) ->
                   (Name) ->
                   (Maybe Nonterminal) ->
                   (Maybe Type) ->
                   (T_Pattern) ->
                   ([String]) ->
                   (Map Vertex (Name,Name,Maybe Type)) ->
                   (Bool) ->
                   (String) ->
                   (T_CRule)
sem_CRule_CRule (name_) (isIn_) (hasCode_) (nt_) (con_) (field_) (childnt_) (tp_) ((T_Pattern (pattern_))) (rhs_) (defines_) (owrt_) (origin_) =
    (T_CRule (\ _lhsIchildren
                _lhsIcon
                _lhsIerrors
                _lhsIinh
                _lhsInt
                _lhsIo_case
                _lhsIo_cata
                _lhsIo_data
                _lhsIo_newtypes
                _lhsIo_pretty
                _lhsIo_rename
                _lhsIo_sem
                _lhsIo_sig
                _lhsIo_strictwrap
                _lhsIo_unbox
                _lhsIprefix
                _lhsIsyn
                _lhsIterminals ->
                  let _lhsOallTpsFound :: (Bool)
                      _lhsOcomments :: ([String])
                      _lhsOdecls :: (Decls)
                      _lhsOerrors :: (Seq Error)
                      _lhsOexprs :: (Exprs)
                      _lhsOtSigs :: ([Decl])
                      _lhsOtps :: ([Type])
                      _patternIcopy :: (Pattern)
                      ( _patternIcopy) =
                          (pattern_ )
                      -- "GenerateCode.ag"(line 79, column 12)
                      (_lhsOdecls@_) =
                          if hasCode_ then _originComment [Decl (Pattern3 _patternIcopy) (TextExpr rhs_)] else []
                      -- "GenerateCode.ag"(line 76, column 12)
                      (_originComment@_) =
                          if  _lhsIo_pretty
                              then (Comment origin_:)
                              else id
                      -- "GenerateCode.ag"(line 136, column 12)
                      (_lhsOexprs@_) =
                          if  field_ == _LOC && name_ `elem` _lhsIterminals
                              then [SimpleExpr (funname name_ 0)]
                              else [SimpleExpr (attrname isIn_ field_ name_)]
                      -- "GenerateCode.ag"(line 149, column 19)
                      (_lhsOtSigs@_) =
                          [ TSig (attrname False field attr) (_mkTp (fromJust tp))
                          |  (field,attr,tp) <- Map.elems defines_, isJust tp ]
                      -- "GenerateCode.ag"(line 148, column 19)
                      (_mkTp@_) =
                          SimpleType . typeToString _lhsInt
                      -- "GenerateCode.ag"(line 169, column 23)
                      ((_lhsOtps@_,_lhsOallTpsFound@_)) =
                          maybe ([],False) (\tp -> ([tp],True)) tp_
                      -- "GenerateCode.ag"(line 300, column 12)
                      (_lhsOerrors@_) =
                          maybe (Seq.single (MissingTypeSig _lhsInt _lhsIcon name_)) (const Seq.empty) tp_
                      -- "GenerateCode.ag"(line 324, column 18)
                      (_lhsOcomments@_) =
                          [ makeLocalComment "local" name tp | (field,name,tp) <- Map.elems defines_, field == _LOC ]
                  in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOexprs,_lhsOtSigs,_lhsOtps)))
-- CSegment ----------------------------------------------------
{-
   inherited attributes:
      inh                  : Attributes
      isLast               : Bool
      nr                   : Int
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      comments             : [String]
      semDom               : [Decl]
      wrapDecls            : Decls

-}
{-
   local variables for CSegment.CSegment:

-}
-- semantic domain
newtype T_CSegment = T_CSegment ((Attributes) ->
                                 (Bool) ->
                                 (Int) ->
                                 (Nonterminal) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Maybe Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (String) ->
                                 (Attributes) ->
                                 ( ([String]),([Decl]),(Decls)))
-- cata
sem_CSegment :: (CSegment) ->
                (T_CSegment)
sem_CSegment ((CSegment (_inh) (_syn))) =
    (sem_CSegment_CSegment (_inh) (_syn))
data Inh_CSegment = Inh_CSegment {inh_Inh_CSegment :: Attributes
                                 ,isLast_Inh_CSegment :: Bool
                                 ,nr_Inh_CSegment :: Int
                                 ,nt_Inh_CSegment :: Nonterminal
                                 ,o_case_Inh_CSegment :: Bool
                                 ,o_cata_Inh_CSegment :: Bool
                                 ,o_data_Inh_CSegment :: Maybe Bool
                                 ,o_newtypes_Inh_CSegment :: Bool
                                 ,o_pretty_Inh_CSegment :: Bool
                                 ,o_rename_Inh_CSegment :: Bool
                                 ,o_sem_Inh_CSegment :: Bool
                                 ,o_sig_Inh_CSegment :: Bool
                                 ,o_strictwrap_Inh_CSegment :: Bool
                                 ,o_unbox_Inh_CSegment :: Bool
                                 ,prefix_Inh_CSegment :: String
                                 ,syn_Inh_CSegment :: Attributes
                                 }
data Syn_CSegment = Syn_CSegment {comments_Syn_CSegment :: [String],semDom_Syn_CSegment :: [Decl],wrapDecls_Syn_CSegment :: Decls}
wrap_CSegment :: (T_CSegment) ->
                 (Inh_CSegment) ->
                 (Syn_CSegment)
wrap_CSegment ((T_CSegment (sem))) ((Inh_CSegment (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_CSegment (s1) (s2) (s3))
sem_CSegment_CSegment :: (Attributes) ->
                         (Attributes) ->
                         (T_CSegment)
sem_CSegment_CSegment (inh_) (syn_) =
    (T_CSegment (\ _lhsIinh
                   _lhsIisLast
                   _lhsInr
                   _lhsInt
                   _lhsIo_case
                   _lhsIo_cata
                   _lhsIo_data
                   _lhsIo_newtypes
                   _lhsIo_pretty
                   _lhsIo_rename
                   _lhsIo_sem
                   _lhsIo_sig
                   _lhsIo_strictwrap
                   _lhsIo_unbox
                   _lhsIprefix
                   _lhsIsyn ->
                     let _lhsOcomments :: ([String])
                         _lhsOsemDom :: ([Decl])
                         _lhsOwrapDecls :: (Decls)
                         -- "GenerateCode.ag"(line 229, column 15)
                         (_lhsOsemDom@_) =
                             let name = typeName _lhsInt _lhsInr
                                 tp = foldr Arr synTps inhTps
                                 inhTps = [SimpleType (typeToString _lhsInt tp) |  tp <- Map.elems inh_]
                                 synTps = mkTupleType _lhsIo_unbox inhTps ([SimpleType (typeToString _lhsInt tp) |  tp <- Map.elems syn_] ++ continuation)
                                 continuation = if  _lhsIisLast
                                                    then []
                                                    else [SimpleType (typeName _lhsInt (_lhsInr + 1))]
                             in if _lhsIo_newtypes
                                then [ Code.NewType name name tp ]
                                else [ Code.Type name tp ]
                         -- "GenerateCode.ag"(line 265, column 15)
                         (_lhsOwrapDecls@_) =
                             let rhs = map (SimpleExpr . lhsname True) (Map.keys inh_)
                                 lhs = map (lhsname False) (Map.keys syn_)
                                       ++ if _lhsIisLast then [] else [unwrap ++ sem (_lhsInr+1)]
                                 unwrap = if _lhsIo_newtypes then typeName _lhsInt (_lhsInr + 1) ++ " " else ""
                                 var = "sem"
                                 sem 0 = var
                                 sem n = var ++ "_" ++ show n
                             in [Decl (mkTupleLhs _lhsIo_unbox (Map.keys inh_) lhs) (App (sem _lhsInr) rhs)]
                         -- "GenerateCode.ag"(line 314, column 18)
                         (_lhsOcomments@_) =
                             ("visit " ++ show _lhsInr ++ ":")
                             : map ind (showsSegment (CSegment inh_ syn_))
                     in  ( _lhsOcomments,_lhsOsemDom,_lhsOwrapDecls)))
-- CSegments ---------------------------------------------------
{-
   inherited attributes:
      inh                  : Attributes
      nr                   : Int
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      comments             : [String]
      isNil                : Bool
      semDom               : [Decl]
      wrapDecls            : Decls

-}
{-
   local variables for CSegments.Cons:

-}
{-
   local variables for CSegments.Nil:

-}
-- semantic domain
newtype T_CSegments = T_CSegments ((Attributes) ->
                                   (Int) ->
                                   (Nonterminal) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Maybe Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (Bool) ->
                                   (String) ->
                                   (Attributes) ->
                                   ( ([String]),(Bool),([Decl]),(Decls)))
-- cata
sem_CSegments :: (CSegments) ->
                 (T_CSegments)
sem_CSegments (list) =
    (Prelude.foldr (sem_CSegments_Cons) (sem_CSegments_Nil) ((Prelude.map sem_CSegment list)))
data Inh_CSegments = Inh_CSegments {inh_Inh_CSegments :: Attributes
                                   ,nr_Inh_CSegments :: Int
                                   ,nt_Inh_CSegments :: Nonterminal
                                   ,o_case_Inh_CSegments :: Bool
                                   ,o_cata_Inh_CSegments :: Bool
                                   ,o_data_Inh_CSegments :: Maybe Bool
                                   ,o_newtypes_Inh_CSegments :: Bool
                                   ,o_pretty_Inh_CSegments :: Bool
                                   ,o_rename_Inh_CSegments :: Bool
                                   ,o_sem_Inh_CSegments :: Bool
                                   ,o_sig_Inh_CSegments :: Bool
                                   ,o_strictwrap_Inh_CSegments :: Bool
                                   ,o_unbox_Inh_CSegments :: Bool
                                   ,prefix_Inh_CSegments :: String
                                   ,syn_Inh_CSegments :: Attributes
                                   }
data Syn_CSegments = Syn_CSegments {comments_Syn_CSegments :: [String],isNil_Syn_CSegments :: Bool,semDom_Syn_CSegments :: [Decl],wrapDecls_Syn_CSegments :: Decls}
wrap_CSegments :: (T_CSegments) ->
                  (Inh_CSegments) ->
                  (Syn_CSegments)
wrap_CSegments ((T_CSegments (sem))) ((Inh_CSegments (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15))) =
    let ( s1,s2,s3,s4) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15))
    in  (Syn_CSegments (s1) (s2) (s3) (s4))
sem_CSegments_Cons :: (T_CSegment) ->
                      (T_CSegments) ->
                      (T_CSegments)
sem_CSegments_Cons ((T_CSegment (hd_))) ((T_CSegments (tl_))) =
    (T_CSegments (\ _lhsIinh
                    _lhsInr
                    _lhsInt
                    _lhsIo_case
                    _lhsIo_cata
                    _lhsIo_data
                    _lhsIo_newtypes
                    _lhsIo_pretty
                    _lhsIo_rename
                    _lhsIo_sem
                    _lhsIo_sig
                    _lhsIo_strictwrap
                    _lhsIo_unbox
                    _lhsIprefix
                    _lhsIsyn ->
                      let _lhsOcomments :: ([String])
                          _lhsOisNil :: (Bool)
                          _lhsOsemDom :: ([Decl])
                          _lhsOwrapDecls :: (Decls)
                          _hdIcomments :: ([String])
                          _hdIsemDom :: ([Decl])
                          _hdIwrapDecls :: (Decls)
                          _hdOinh :: (Attributes)
                          _hdOisLast :: (Bool)
                          _hdOnr :: (Int)
                          _hdOnt :: (Nonterminal)
                          _hdOo_case :: (Bool)
                          _hdOo_cata :: (Bool)
                          _hdOo_data :: (Maybe Bool)
                          _hdOo_newtypes :: (Bool)
                          _hdOo_pretty :: (Bool)
                          _hdOo_rename :: (Bool)
                          _hdOo_sem :: (Bool)
                          _hdOo_sig :: (Bool)
                          _hdOo_strictwrap :: (Bool)
                          _hdOo_unbox :: (Bool)
                          _hdOprefix :: (String)
                          _hdOsyn :: (Attributes)
                          _tlIcomments :: ([String])
                          _tlIisNil :: (Bool)
                          _tlIsemDom :: ([Decl])
                          _tlIwrapDecls :: (Decls)
                          _tlOinh :: (Attributes)
                          _tlOnr :: (Int)
                          _tlOnt :: (Nonterminal)
                          _tlOo_case :: (Bool)
                          _tlOo_cata :: (Bool)
                          _tlOo_data :: (Maybe Bool)
                          _tlOo_newtypes :: (Bool)
                          _tlOo_pretty :: (Bool)
                          _tlOo_rename :: (Bool)
                          _tlOo_sem :: (Bool)
                          _tlOo_sig :: (Bool)
                          _tlOo_strictwrap :: (Bool)
                          _tlOo_unbox :: (Bool)
                          _tlOprefix :: (String)
                          _tlOsyn :: (Attributes)
                          ( _hdIcomments,_hdIsemDom,_hdIwrapDecls) =
                              (hd_ (_hdOinh) (_hdOisLast) (_hdOnr) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_newtypes) (_hdOo_pretty) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_strictwrap) (_hdOo_unbox) (_hdOprefix) (_hdOsyn))
                          ( _tlIcomments,_tlIisNil,_tlIsemDom,_tlIwrapDecls) =
                              (tl_ (_tlOinh) (_tlOnr) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_newtypes) (_tlOo_pretty) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_strictwrap) (_tlOo_unbox) (_tlOprefix) (_tlOsyn))
                          -- "GenerateCode.ag"(line 100, column 11)
                          (_tlOnr@_) =
                              _lhsInr + 1
                          -- "GenerateCode.ag"(line 114, column 12)
                          (_hdOisLast@_) =
                              _tlIisNil
                          -- "GenerateCode.ag"(line 113, column 12)
                          (_lhsOisNil@_) =
                              False
                          -- use rule
                          (_lhsOcomments@_) =
                              _hdIcomments ++ _tlIcomments
                          -- use rule
                          (_lhsOsemDom@_) =
                              _hdIsemDom ++ _tlIsemDom
                          -- use rule
                          (_lhsOwrapDecls@_) =
                              _hdIwrapDecls ++ _tlIwrapDecls
                          -- copy rule (down)
                          (_hdOinh@_) =
                              _lhsIinh
                          -- copy rule (down)
                          (_hdOnr@_) =
                              _lhsInr
                          -- copy rule (down)
                          (_hdOnt@_) =
                              _lhsInt
                          -- copy rule (down)
                          (_hdOo_case@_) =
                              _lhsIo_case
                          -- copy rule (down)
                          (_hdOo_cata@_) =
                              _lhsIo_cata
                          -- copy rule (down)
                          (_hdOo_data@_) =
                              _lhsIo_data
                          -- copy rule (down)
                          (_hdOo_newtypes@_) =
                              _lhsIo_newtypes
                          -- copy rule (down)
                          (_hdOo_pretty@_) =
                              _lhsIo_pretty
                          -- copy rule (down)
                          (_hdOo_rename@_) =
                              _lhsIo_rename
                          -- copy rule (down)
                          (_hdOo_sem@_) =
                              _lhsIo_sem
                          -- copy rule (down)
                          (_hdOo_sig@_) =
                              _lhsIo_sig
                          -- copy rule (down)
                          (_hdOo_strictwrap@_) =
                              _lhsIo_strictwrap
                          -- copy rule (down)
                          (_hdOo_unbox@_) =
                              _lhsIo_unbox
                          -- copy rule (down)
                          (_hdOprefix@_) =
                              _lhsIprefix
                          -- copy rule (down)
                          (_hdOsyn@_) =
                              _lhsIsyn
                          -- copy rule (down)
                          (_tlOinh@_) =
                              _lhsIinh
                          -- copy rule (down)
                          (_tlOnt@_) =
                              _lhsInt
                          -- copy rule (down)
                          (_tlOo_case@_) =
                              _lhsIo_case
                          -- copy rule (down)
                          (_tlOo_cata@_) =
                              _lhsIo_cata
                          -- copy rule (down)
                          (_tlOo_data@_) =
                              _lhsIo_data
                          -- copy rule (down)
                          (_tlOo_newtypes@_) =
                              _lhsIo_newtypes
                          -- copy rule (down)
                          (_tlOo_pretty@_) =
                              _lhsIo_pretty
                          -- copy rule (down)
                          (_tlOo_rename@_) =
                              _lhsIo_rename
                          -- copy rule (down)
                          (_tlOo_sem@_) =
                              _lhsIo_sem
                          -- copy rule (down)
                          (_tlOo_sig@_) =
                              _lhsIo_sig
                          -- copy rule (down)
                          (_tlOo_strictwrap@_) =
                              _lhsIo_strictwrap
                          -- copy rule (down)
                          (_tlOo_unbox@_) =
                              _lhsIo_unbox
                          -- copy rule (down)
                          (_tlOprefix@_) =
                              _lhsIprefix
                          -- copy rule (down)
                          (_tlOsyn@_) =
                              _lhsIsyn
                      in  ( _lhsOcomments,_lhsOisNil,_lhsOsemDom,_lhsOwrapDecls)))
sem_CSegments_Nil :: (T_CSegments)
sem_CSegments_Nil  =
    (T_CSegments (\ _lhsIinh
                    _lhsInr
                    _lhsInt
                    _lhsIo_case
                    _lhsIo_cata
                    _lhsIo_data
                    _lhsIo_newtypes
                    _lhsIo_pretty
                    _lhsIo_rename
                    _lhsIo_sem
                    _lhsIo_sig
                    _lhsIo_strictwrap
                    _lhsIo_unbox
                    _lhsIprefix
                    _lhsIsyn ->
                      let _lhsOcomments :: ([String])
                          _lhsOisNil :: (Bool)
                          _lhsOsemDom :: ([Decl])
                          _lhsOwrapDecls :: (Decls)
                          -- "GenerateCode.ag"(line 115, column 10)
                          (_lhsOisNil@_) =
                              True
                          -- use rule
                          (_lhsOcomments@_) =
                              []
                          -- use rule
                          (_lhsOsemDom@_) =
                              []
                          -- use rule
                          (_lhsOwrapDecls@_) =
                              []
                      in  ( _lhsOcomments,_lhsOisNil,_lhsOsemDom,_lhsOwrapDecls)))
-- CVisit ------------------------------------------------------
{-
   inherited attributes:
      children             : [(Name,Type)]
      con                  : Constructor
      inh                  : Attributes
      isLast               : Bool
      nextIntra            : Exprs
      nr                   : Int
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      terminals            : [Name]
      with_sig             : Bool

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      comments             : [String]
      decls                : Decls
      intra                : Exprs

-}
{-
   local variables for CVisit.CVisit:
      o_case
      typeSigs
      semType
      tsig
      semFun
      decls
      nextVisitDecl
      nextVisitName
      funcname

-}
-- semantic domain
newtype T_CVisit = T_CVisit (([(Name,Type)]) ->
                             (Constructor) ->
                             (Seq Error) ->
                             (Attributes) ->
                             (Bool) ->
                             (Exprs) ->
                             (Int) ->
                             (Nonterminal) ->
                             (Bool) ->
                             (Bool) ->
                             (Maybe Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (Bool) ->
                             (String) ->
                             (Attributes) ->
                             ([Name]) ->
                             (Bool) ->
                             ( (Bool),([String]),(Decls),(Seq Error),(Exprs)))
-- cata
sem_CVisit :: (CVisit) ->
              (T_CVisit)
sem_CVisit ((CVisit (_inh) (_syn) (_vss) (_intra) (_ordered))) =
    (sem_CVisit_CVisit (_inh) (_syn) ((sem_Sequence (_vss))) ((sem_Sequence (_intra))) (_ordered))
data Inh_CVisit = Inh_CVisit {children_Inh_CVisit :: [(Name,Type)]
                             ,con_Inh_CVisit :: Constructor
                             ,errors_Inh_CVisit :: Seq Error
                             ,inh_Inh_CVisit :: Attributes
                             ,isLast_Inh_CVisit :: Bool
                             ,nextIntra_Inh_CVisit :: Exprs
                             ,nr_Inh_CVisit :: Int
                             ,nt_Inh_CVisit :: Nonterminal
                             ,o_case_Inh_CVisit :: Bool
                             ,o_cata_Inh_CVisit :: Bool
                             ,o_data_Inh_CVisit :: Maybe Bool
                             ,o_newtypes_Inh_CVisit :: Bool
                             ,o_pretty_Inh_CVisit :: Bool
                             ,o_rename_Inh_CVisit :: Bool
                             ,o_sem_Inh_CVisit :: Bool
                             ,o_sig_Inh_CVisit :: Bool
                             ,o_strictwrap_Inh_CVisit :: Bool
                             ,o_unbox_Inh_CVisit :: Bool
                             ,prefix_Inh_CVisit :: String
                             ,syn_Inh_CVisit :: Attributes
                             ,terminals_Inh_CVisit :: [Name]
                             ,with_sig_Inh_CVisit :: Bool
                             }
data Syn_CVisit = Syn_CVisit {allTpsFound_Syn_CVisit :: Bool,comments_Syn_CVisit :: [String],decls_Syn_CVisit :: Decls,errors_Syn_CVisit :: Seq Error,intra_Syn_CVisit :: Exprs}
wrap_CVisit :: (T_CVisit) ->
               (Inh_CVisit) ->
               (Syn_CVisit)
wrap_CVisit ((T_CVisit (sem))) ((Inh_CVisit (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20) (i21) (i22))) =
    let ( s1,s2,s3,s4,s5) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20) (i21) (i22))
    in  (Syn_CVisit (s1) (s2) (s3) (s4) (s5))
sem_CVisit_CVisit :: (Attributes) ->
                     (Attributes) ->
                     (T_Sequence) ->
                     (T_Sequence) ->
                     (Bool) ->
                     (T_CVisit)
sem_CVisit_CVisit (inh_) (syn_) ((T_Sequence (vss_))) ((T_Sequence (intra_))) (ordered_) =
    (T_CVisit (\ _lhsIchildren
                 _lhsIcon
                 _lhsIerrors
                 _lhsIinh
                 _lhsIisLast
                 _lhsInextIntra
                 _lhsInr
                 _lhsInt
                 _lhsIo_case
                 _lhsIo_cata
                 _lhsIo_data
                 _lhsIo_newtypes
                 _lhsIo_pretty
                 _lhsIo_rename
                 _lhsIo_sem
                 _lhsIo_sig
                 _lhsIo_strictwrap
                 _lhsIo_unbox
                 _lhsIprefix
                 _lhsIsyn
                 _lhsIterminals
                 _lhsIwith_sig ->
                   let _lhsOallTpsFound :: (Bool)
                       _lhsOcomments :: ([String])
                       _lhsOdecls :: (Decls)
                       _lhsOerrors :: (Seq Error)
                       _lhsOintra :: (Exprs)
                       _vssIallTpsFound :: (Bool)
                       _vssIcomments :: ([String])
                       _vssIdecls :: (Decls)
                       _vssIerrors :: (Seq Error)
                       _vssIexprs :: (Exprs)
                       _vssItSigs :: ([Decl])
                       _vssItps :: ([Type])
                       _vssOchildren :: ([(Name,Type)])
                       _vssOcon :: (Constructor)
                       _vssOerrors :: (Seq Error)
                       _vssOinh :: (Attributes)
                       _vssOnt :: (Nonterminal)
                       _vssOo_case :: (Bool)
                       _vssOo_cata :: (Bool)
                       _vssOo_data :: (Maybe Bool)
                       _vssOo_newtypes :: (Bool)
                       _vssOo_pretty :: (Bool)
                       _vssOo_rename :: (Bool)
                       _vssOo_sem :: (Bool)
                       _vssOo_sig :: (Bool)
                       _vssOo_strictwrap :: (Bool)
                       _vssOo_unbox :: (Bool)
                       _vssOprefix :: (String)
                       _vssOsyn :: (Attributes)
                       _vssOterminals :: ([Name])
                       _intraIallTpsFound :: (Bool)
                       _intraIcomments :: ([String])
                       _intraIdecls :: (Decls)
                       _intraIerrors :: (Seq Error)
                       _intraIexprs :: (Exprs)
                       _intraItSigs :: ([Decl])
                       _intraItps :: ([Type])
                       _intraOchildren :: ([(Name,Type)])
                       _intraOcon :: (Constructor)
                       _intraOerrors :: (Seq Error)
                       _intraOinh :: (Attributes)
                       _intraOnt :: (Nonterminal)
                       _intraOo_case :: (Bool)
                       _intraOo_cata :: (Bool)
                       _intraOo_data :: (Maybe Bool)
                       _intraOo_newtypes :: (Bool)
                       _intraOo_pretty :: (Bool)
                       _intraOo_rename :: (Bool)
                       _intraOo_sem :: (Bool)
                       _intraOo_sig :: (Bool)
                       _intraOo_strictwrap :: (Bool)
                       _intraOo_unbox :: (Bool)
                       _intraOprefix :: (String)
                       _intraOsyn :: (Attributes)
                       _intraOterminals :: ([Name])
                       ( _vssIallTpsFound,_vssIcomments,_vssIdecls,_vssIerrors,_vssIexprs,_vssItSigs,_vssItps) =
                           (vss_ (_vssOchildren) (_vssOcon) (_vssOerrors) (_vssOinh) (_vssOnt) (_vssOo_case) (_vssOo_cata) (_vssOo_data) (_vssOo_newtypes) (_vssOo_pretty) (_vssOo_rename) (_vssOo_sem) (_vssOo_sig) (_vssOo_strictwrap) (_vssOo_unbox) (_vssOprefix) (_vssOsyn) (_vssOterminals))
                       ( _intraIallTpsFound,_intraIcomments,_intraIdecls,_intraIerrors,_intraIexprs,_intraItSigs,_intraItps) =
                           (intra_ (_intraOchildren) (_intraOcon) (_intraOerrors) (_intraOinh) (_intraOnt) (_intraOo_case) (_intraOo_cata) (_intraOo_data) (_intraOo_newtypes) (_intraOo_pretty) (_intraOo_rename) (_intraOo_sem) (_intraOo_sig) (_intraOo_strictwrap) (_intraOo_unbox) (_intraOprefix) (_intraOsyn) (_intraOterminals))
                       -- "GenerateCode.ag"(line 124, column 13)
                       (_lhsOintra@_) =
                           _intraIexprs
                       -- "GenerateCode.ag"(line 213, column 13)
                       (_o_case@_) =
                           _lhsIo_case && ordered_
                       -- "GenerateCode.ag"(line 210, column 13)
                       (_typeSigs@_) =
                           if  _lhsIo_sig && not _o_case
                               then  _vssItSigs
                               else  []
                       -- "GenerateCode.ag"(line 207, column 13)
                       (_lhsOdecls@_) =
                           if  _lhsIwith_sig
                               then [_tsig, _semFun]
                               else [_semFun]
                       -- "GenerateCode.ag"(line 201, column 13)
                       (_semType@_) =
                           let argType (NT tp) rec | tp /= _SELF = SimpleType (sdtype tp)               `Arr` rec
                               argType tp      rec               = SimpleType (typeToString _lhsInt tp) `Arr` rec
                           in if  _lhsInr == 0
                                  then foldr argType (SimpleType (sdtype _lhsInt)) (map snd _lhsIchildren)
                                  else foldr argType (SimpleType (typeName _lhsInt _lhsInr)) _intraItps
                       -- "GenerateCode.ag"(line 200, column 13)
                       (_tsig@_) =
                           TSig _funcname _semType
                       -- "GenerateCode.ag"(line 185, column 13)
                       (_semFun@_) =
                           let  lhs = Fun _funcname lhs_args
                                lhs_args = if _lhsInr == 0 then map field _lhsIchildren else _intraIexprs
                                field (name,NT tp) = let unwrap | _lhsIo_newtypes = \x -> App (sdtype tp) [x]
                                                                | otherwise       = id
                                                     in unwrap (SimpleExpr (funname name 0))
                                field (name,_)     =  SimpleExpr (funname name 0)
                                rhs = wrap
                                      . mkLambda (map (lhsname True) (Map.keys inh_))
                                      . mkLet _o_case _decls
                                      . mkTupleExpr _lhsIo_unbox (Map.keys inh_)
                                      $ map (SimpleExpr . lhsname False) (Map.keys syn_) ++ map SimpleExpr _nextVisitName
                                wrap = if  _lhsIo_newtypes
                                           then \x -> App (typeName _lhsInt _lhsInr) [x]
                                           else id
                           in Decl lhs rhs
                       -- "GenerateCode.ag"(line 184, column 13)
                       (_decls@_) =
                           _typeSigs ++ _vssIdecls ++ _nextVisitDecl
                       -- "GenerateCode.ag"(line 180, column 13)
                       (_nextVisitDecl@_) =
                           let  lhs = TupleLhs _nextVisitName
                                rhs = App fun _lhsInextIntra
                                fun = seqSemname _lhsIprefix _lhsInt _lhsIcon (_lhsInr+1)
                           in if _lhsIisLast then [] else [Decl lhs rhs]
                       -- "GenerateCode.ag"(line 179, column 13)
                       (_nextVisitName@_) =
                           if _lhsIisLast then [] else [visitname _lhsIprefix _lhsInt (_lhsInr+1)]
                       -- "GenerateCode.ag"(line 178, column 13)
                       (_funcname@_) =
                           seqSemname _lhsIprefix _lhsInt _lhsIcon _lhsInr
                       -- "GenerateCode.ag"(line 287, column 13)
                       (_lhsOallTpsFound@_) =
                           _intraIallTpsFound
                       -- "GenerateCode.ag"(line 298, column 13)
                       (_lhsOerrors@_) =
                           _intraIerrors
                       -- use rule
                       (_lhsOcomments@_) =
                           _vssIcomments ++ _intraIcomments
                       -- copy rule (down)
                       (_vssOchildren@_) =
                           _lhsIchildren
                       -- copy rule (down)
                       (_vssOcon@_) =
                           _lhsIcon
                       -- copy rule (down)
                       (_vssOerrors@_) =
                           _lhsIerrors
                       -- copy rule (down)
                       (_vssOinh@_) =
                           _lhsIinh
                       -- copy rule (down)
                       (_vssOnt@_) =
                           _lhsInt
                       -- copy rule (from local)
                       (_vssOo_case@_) =
                           _o_case
                       -- copy rule (down)
                       (_vssOo_cata@_) =
                           _lhsIo_cata
                       -- copy rule (down)
                       (_vssOo_data@_) =
                           _lhsIo_data
                       -- copy rule (down)
                       (_vssOo_newtypes@_) =
                           _lhsIo_newtypes
                       -- copy rule (down)
                       (_vssOo_pretty@_) =
                           _lhsIo_pretty
                       -- copy rule (down)
                       (_vssOo_rename@_) =
                           _lhsIo_rename
                       -- copy rule (down)
                       (_vssOo_sem@_) =
                           _lhsIo_sem
                       -- copy rule (down)
                       (_vssOo_sig@_) =
                           _lhsIo_sig
                       -- copy rule (down)
                       (_vssOo_strictwrap@_) =
                           _lhsIo_strictwrap
                       -- copy rule (down)
                       (_vssOo_unbox@_) =
                           _lhsIo_unbox
                       -- copy rule (down)
                       (_vssOprefix@_) =
                           _lhsIprefix
                       -- copy rule (down)
                       (_vssOsyn@_) =
                           _lhsIsyn
                       -- copy rule (down)
                       (_vssOterminals@_) =
                           _lhsIterminals
                       -- copy rule (down)
                       (_intraOchildren@_) =
                           _lhsIchildren
                       -- copy rule (down)
                       (_intraOcon@_) =
                           _lhsIcon
                       -- copy rule (chain)
                       (_intraOerrors@_) =
                           _vssIerrors
                       -- copy rule (down)
                       (_intraOinh@_) =
                           _lhsIinh
                       -- copy rule (down)
                       (_intraOnt@_) =
                           _lhsInt
                       -- copy rule (from local)
                       (_intraOo_case@_) =
                           _o_case
                       -- copy rule (down)
                       (_intraOo_cata@_) =
                           _lhsIo_cata
                       -- copy rule (down)
                       (_intraOo_data@_) =
                           _lhsIo_data
                       -- copy rule (down)
                       (_intraOo_newtypes@_) =
                           _lhsIo_newtypes
                       -- copy rule (down)
                       (_intraOo_pretty@_) =
                           _lhsIo_pretty
                       -- copy rule (down)
                       (_intraOo_rename@_) =
                           _lhsIo_rename
                       -- copy rule (down)
                       (_intraOo_sem@_) =
                           _lhsIo_sem
                       -- copy rule (down)
                       (_intraOo_sig@_) =
                           _lhsIo_sig
                       -- copy rule (down)
                       (_intraOo_strictwrap@_) =
                           _lhsIo_strictwrap
                       -- copy rule (down)
                       (_intraOo_unbox@_) =
                           _lhsIo_unbox
                       -- copy rule (down)
                       (_intraOprefix@_) =
                           _lhsIprefix
                       -- copy rule (down)
                       (_intraOsyn@_) =
                           _lhsIsyn
                       -- copy rule (down)
                       (_intraOterminals@_) =
                           _lhsIterminals
                   in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOintra)))
-- CVisits -----------------------------------------------------
{-
   inherited attributes:
      children             : [(Name,Type)]
      con                  : Constructor
      inh                  : Attributes
      nr                   : Int
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      terminals            : [Name]
      with_sig             : Bool

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      comments             : [String]
      decls                : Decls
      intra                : Exprs
      isNil                : Bool

-}
{-
   local variables for CVisits.Cons:

-}
{-
   local variables for CVisits.Nil:

-}
-- semantic domain
newtype T_CVisits = T_CVisits (([(Name,Type)]) ->
                               (Constructor) ->
                               (Seq Error) ->
                               (Attributes) ->
                               (Int) ->
                               (Nonterminal) ->
                               (Bool) ->
                               (Bool) ->
                               (Maybe Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (Bool) ->
                               (String) ->
                               (Attributes) ->
                               ([Name]) ->
                               (Bool) ->
                               ( (Bool),([String]),(Decls),(Seq Error),(Exprs),(Bool)))
-- cata
sem_CVisits :: (CVisits) ->
               (T_CVisits)
sem_CVisits (list) =
    (Prelude.foldr (sem_CVisits_Cons) (sem_CVisits_Nil) ((Prelude.map sem_CVisit list)))
data Inh_CVisits = Inh_CVisits {children_Inh_CVisits :: [(Name,Type)]
                               ,con_Inh_CVisits :: Constructor
                               ,errors_Inh_CVisits :: Seq Error
                               ,inh_Inh_CVisits :: Attributes
                               ,nr_Inh_CVisits :: Int
                               ,nt_Inh_CVisits :: Nonterminal
                               ,o_case_Inh_CVisits :: Bool
                               ,o_cata_Inh_CVisits :: Bool
                               ,o_data_Inh_CVisits :: Maybe Bool
                               ,o_newtypes_Inh_CVisits :: Bool
                               ,o_pretty_Inh_CVisits :: Bool
                               ,o_rename_Inh_CVisits :: Bool
                               ,o_sem_Inh_CVisits :: Bool
                               ,o_sig_Inh_CVisits :: Bool
                               ,o_strictwrap_Inh_CVisits :: Bool
                               ,o_unbox_Inh_CVisits :: Bool
                               ,prefix_Inh_CVisits :: String
                               ,syn_Inh_CVisits :: Attributes
                               ,terminals_Inh_CVisits :: [Name]
                               ,with_sig_Inh_CVisits :: Bool
                               }
data Syn_CVisits = Syn_CVisits {allTpsFound_Syn_CVisits :: Bool,comments_Syn_CVisits :: [String],decls_Syn_CVisits :: Decls,errors_Syn_CVisits :: Seq Error,intra_Syn_CVisits :: Exprs,isNil_Syn_CVisits :: Bool}
wrap_CVisits :: (T_CVisits) ->
                (Inh_CVisits) ->
                (Syn_CVisits)
wrap_CVisits ((T_CVisits (sem))) ((Inh_CVisits (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))
    in  (Syn_CVisits (s1) (s2) (s3) (s4) (s5) (s6))
sem_CVisits_Cons :: (T_CVisit) ->
                    (T_CVisits) ->
                    (T_CVisits)
sem_CVisits_Cons ((T_CVisit (hd_))) ((T_CVisits (tl_))) =
    (T_CVisits (\ _lhsIchildren
                  _lhsIcon
                  _lhsIerrors
                  _lhsIinh
                  _lhsInr
                  _lhsInt
                  _lhsIo_case
                  _lhsIo_cata
                  _lhsIo_data
                  _lhsIo_newtypes
                  _lhsIo_pretty
                  _lhsIo_rename
                  _lhsIo_sem
                  _lhsIo_sig
                  _lhsIo_strictwrap
                  _lhsIo_unbox
                  _lhsIprefix
                  _lhsIsyn
                  _lhsIterminals
                  _lhsIwith_sig ->
                    let _lhsOallTpsFound :: (Bool)
                        _lhsOcomments :: ([String])
                        _lhsOdecls :: (Decls)
                        _lhsOerrors :: (Seq Error)
                        _lhsOintra :: (Exprs)
                        _lhsOisNil :: (Bool)
                        _hdIallTpsFound :: (Bool)
                        _hdIcomments :: ([String])
                        _hdIdecls :: (Decls)
                        _hdIerrors :: (Seq Error)
                        _hdIintra :: (Exprs)
                        _hdOchildren :: ([(Name,Type)])
                        _hdOcon :: (Constructor)
                        _hdOerrors :: (Seq Error)
                        _hdOinh :: (Attributes)
                        _hdOisLast :: (Bool)
                        _hdOnextIntra :: (Exprs)
                        _hdOnr :: (Int)
                        _hdOnt :: (Nonterminal)
                        _hdOo_case :: (Bool)
                        _hdOo_cata :: (Bool)
                        _hdOo_data :: (Maybe Bool)
                        _hdOo_newtypes :: (Bool)
                        _hdOo_pretty :: (Bool)
                        _hdOo_rename :: (Bool)
                        _hdOo_sem :: (Bool)
                        _hdOo_sig :: (Bool)
                        _hdOo_strictwrap :: (Bool)
                        _hdOo_unbox :: (Bool)
                        _hdOprefix :: (String)
                        _hdOsyn :: (Attributes)
                        _hdOterminals :: ([Name])
                        _hdOwith_sig :: (Bool)
                        _tlIallTpsFound :: (Bool)
                        _tlIcomments :: ([String])
                        _tlIdecls :: (Decls)
                        _tlIerrors :: (Seq Error)
                        _tlIintra :: (Exprs)
                        _tlIisNil :: (Bool)
                        _tlOchildren :: ([(Name,Type)])
                        _tlOcon :: (Constructor)
                        _tlOerrors :: (Seq Error)
                        _tlOinh :: (Attributes)
                        _tlOnr :: (Int)
                        _tlOnt :: (Nonterminal)
                        _tlOo_case :: (Bool)
                        _tlOo_cata :: (Bool)
                        _tlOo_data :: (Maybe Bool)
                        _tlOo_newtypes :: (Bool)
                        _tlOo_pretty :: (Bool)
                        _tlOo_rename :: (Bool)
                        _tlOo_sem :: (Bool)
                        _tlOo_sig :: (Bool)
                        _tlOo_strictwrap :: (Bool)
                        _tlOo_unbox :: (Bool)
                        _tlOprefix :: (String)
                        _tlOsyn :: (Attributes)
                        _tlOterminals :: ([Name])
                        _tlOwith_sig :: (Bool)
                        ( _hdIallTpsFound,_hdIcomments,_hdIdecls,_hdIerrors,_hdIintra) =
                            (hd_ (_hdOchildren) (_hdOcon) (_hdOerrors) (_hdOinh) (_hdOisLast) (_hdOnextIntra) (_hdOnr) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_newtypes) (_hdOo_pretty) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_strictwrap) (_hdOo_unbox) (_hdOprefix) (_hdOsyn) (_hdOterminals) (_hdOwith_sig))
                        ( _tlIallTpsFound,_tlIcomments,_tlIdecls,_tlIerrors,_tlIintra,_tlIisNil) =
                            (tl_ (_tlOchildren) (_tlOcon) (_tlOerrors) (_tlOinh) (_tlOnr) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_newtypes) (_tlOo_pretty) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_strictwrap) (_tlOo_unbox) (_tlOprefix) (_tlOsyn) (_tlOterminals) (_tlOwith_sig))
                        -- "GenerateCode.ag"(line 96, column 11)
                        (_tlOnr@_) =
                            _lhsInr + 1
                        -- "GenerateCode.ag"(line 110, column 12)
                        (_hdOisLast@_) =
                            _tlIisNil
                        -- "GenerateCode.ag"(line 109, column 12)
                        (_lhsOisNil@_) =
                            False
                        -- "GenerateCode.ag"(line 127, column 12)
                        (_lhsOintra@_) =
                            _hdIintra
                        -- "GenerateCode.ag"(line 126, column 12)
                        (_hdOnextIntra@_) =
                            _tlIintra
                        -- use rule
                        (_lhsOallTpsFound@_) =
                            _hdIallTpsFound && _tlIallTpsFound
                        -- use rule
                        (_lhsOcomments@_) =
                            _hdIcomments ++ _tlIcomments
                        -- use rule
                        (_lhsOdecls@_) =
                            _hdIdecls ++ _tlIdecls
                        -- use rule
                        (_lhsOerrors@_) =
                            _hdIerrors Seq.<> _tlIerrors
                        -- copy rule (down)
                        (_hdOchildren@_) =
                            _lhsIchildren
                        -- copy rule (down)
                        (_hdOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_hdOerrors@_) =
                            _lhsIerrors
                        -- copy rule (down)
                        (_hdOinh@_) =
                            _lhsIinh
                        -- copy rule (down)
                        (_hdOnr@_) =
                            _lhsInr
                        -- copy rule (down)
                        (_hdOnt@_) =
                            _lhsInt
                        -- copy rule (down)
                        (_hdOo_case@_) =
                            _lhsIo_case
                        -- copy rule (down)
                        (_hdOo_cata@_) =
                            _lhsIo_cata
                        -- copy rule (down)
                        (_hdOo_data@_) =
                            _lhsIo_data
                        -- copy rule (down)
                        (_hdOo_newtypes@_) =
                            _lhsIo_newtypes
                        -- copy rule (down)
                        (_hdOo_pretty@_) =
                            _lhsIo_pretty
                        -- copy rule (down)
                        (_hdOo_rename@_) =
                            _lhsIo_rename
                        -- copy rule (down)
                        (_hdOo_sem@_) =
                            _lhsIo_sem
                        -- copy rule (down)
                        (_hdOo_sig@_) =
                            _lhsIo_sig
                        -- copy rule (down)
                        (_hdOo_strictwrap@_) =
                            _lhsIo_strictwrap
                        -- copy rule (down)
                        (_hdOo_unbox@_) =
                            _lhsIo_unbox
                        -- copy rule (down)
                        (_hdOprefix@_) =
                            _lhsIprefix
                        -- copy rule (down)
                        (_hdOsyn@_) =
                            _lhsIsyn
                        -- copy rule (down)
                        (_hdOterminals@_) =
                            _lhsIterminals
                        -- copy rule (down)
                        (_hdOwith_sig@_) =
                            _lhsIwith_sig
                        -- copy rule (down)
                        (_tlOchildren@_) =
                            _lhsIchildren
                        -- copy rule (down)
                        (_tlOcon@_) =
                            _lhsIcon
                        -- copy rule (chain)
                        (_tlOerrors@_) =
                            _hdIerrors
                        -- copy rule (down)
                        (_tlOinh@_) =
                            _lhsIinh
                        -- copy rule (down)
                        (_tlOnt@_) =
                            _lhsInt
                        -- copy rule (down)
                        (_tlOo_case@_) =
                            _lhsIo_case
                        -- copy rule (down)
                        (_tlOo_cata@_) =
                            _lhsIo_cata
                        -- copy rule (down)
                        (_tlOo_data@_) =
                            _lhsIo_data
                        -- copy rule (down)
                        (_tlOo_newtypes@_) =
                            _lhsIo_newtypes
                        -- copy rule (down)
                        (_tlOo_pretty@_) =
                            _lhsIo_pretty
                        -- copy rule (down)
                        (_tlOo_rename@_) =
                            _lhsIo_rename
                        -- copy rule (down)
                        (_tlOo_sem@_) =
                            _lhsIo_sem
                        -- copy rule (down)
                        (_tlOo_sig@_) =
                            _lhsIo_sig
                        -- copy rule (down)
                        (_tlOo_strictwrap@_) =
                            _lhsIo_strictwrap
                        -- copy rule (down)
                        (_tlOo_unbox@_) =
                            _lhsIo_unbox
                        -- copy rule (down)
                        (_tlOprefix@_) =
                            _lhsIprefix
                        -- copy rule (down)
                        (_tlOsyn@_) =
                            _lhsIsyn
                        -- copy rule (down)
                        (_tlOterminals@_) =
                            _lhsIterminals
                        -- copy rule (down)
                        (_tlOwith_sig@_) =
                            _lhsIwith_sig
                    in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOintra,_lhsOisNil)))
sem_CVisits_Nil :: (T_CVisits)
sem_CVisits_Nil  =
    (T_CVisits (\ _lhsIchildren
                  _lhsIcon
                  _lhsIerrors
                  _lhsIinh
                  _lhsInr
                  _lhsInt
                  _lhsIo_case
                  _lhsIo_cata
                  _lhsIo_data
                  _lhsIo_newtypes
                  _lhsIo_pretty
                  _lhsIo_rename
                  _lhsIo_sem
                  _lhsIo_sig
                  _lhsIo_strictwrap
                  _lhsIo_unbox
                  _lhsIprefix
                  _lhsIsyn
                  _lhsIterminals
                  _lhsIwith_sig ->
                    let _lhsOallTpsFound :: (Bool)
                        _lhsOcomments :: ([String])
                        _lhsOdecls :: (Decls)
                        _lhsOerrors :: (Seq Error)
                        _lhsOintra :: (Exprs)
                        _lhsOisNil :: (Bool)
                        -- "GenerateCode.ag"(line 111, column 10)
                        (_lhsOisNil@_) =
                            True
                        -- "GenerateCode.ag"(line 128, column 10)
                        (_lhsOintra@_) =
                            []
                        -- use rule
                        (_lhsOallTpsFound@_) =
                            True
                        -- use rule
                        (_lhsOcomments@_) =
                            []
                        -- use rule
                        (_lhsOdecls@_) =
                            []
                        -- use rule
                        (_lhsOerrors@_) =
                            Seq.empty
                    in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOintra,_lhsOisNil)))
-- Pattern -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      copy                 : SELF

-}
{-
   local variables for Pattern.Alias:
      copy

-}
{-
   local variables for Pattern.Constr:
      copy

-}
{-
   local variables for Pattern.Product:
      copy

-}
{-
   local variables for Pattern.Underscore:
      copy

-}
-- semantic domain
newtype T_Pattern = T_Pattern (( (Pattern)))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Alias (_field) (_attr) (_pat))) =
    (sem_Pattern_Alias (_field) (_attr) ((sem_Pattern (_pat))))
sem_Pattern ((Constr (_name) (_pats))) =
    (sem_Pattern_Constr (_name) ((sem_Patterns (_pats))))
sem_Pattern ((Product (_pos) (_pats))) =
    (sem_Pattern_Product (_pos) ((sem_Patterns (_pats))))
sem_Pattern ((Underscore (_pos))) =
    (sem_Pattern_Underscore (_pos))
data Inh_Pattern = Inh_Pattern {}
data Syn_Pattern = Syn_Pattern {copy_Syn_Pattern :: Pattern}
wrap_Pattern :: (T_Pattern) ->
                (Inh_Pattern) ->
                (Syn_Pattern)
wrap_Pattern ((T_Pattern (sem))) ((Inh_Pattern )) =
    let ( s1) =
            (sem )
    in  (Syn_Pattern (s1))
sem_Pattern_Alias :: (Name) ->
                     (Name) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_Alias (field_) (attr_) ((T_Pattern (pat_))) =
    (T_Pattern (let _lhsOcopy :: (Pattern)
                    _patIcopy :: (Pattern)
                    ( _patIcopy) =
                        (pat_ )
                    -- self rule
                    (_copy@_) =
                        Alias field_ attr_ _patIcopy
                    -- self rule
                    (_lhsOcopy@_) =
                        _copy
                in  ( _lhsOcopy)))
sem_Pattern_Constr :: (Constructor) ->
                      (T_Patterns) ->
                      (T_Pattern)
sem_Pattern_Constr (name_) ((T_Patterns (pats_))) =
    (T_Pattern (let _lhsOcopy :: (Pattern)
                    _patsIcopy :: (Patterns)
                    ( _patsIcopy) =
                        (pats_ )
                    -- self rule
                    (_copy@_) =
                        Constr name_ _patsIcopy
                    -- self rule
                    (_lhsOcopy@_) =
                        _copy
                in  ( _lhsOcopy)))
sem_Pattern_Product :: (Pos) ->
                       (T_Patterns) ->
                       (T_Pattern)
sem_Pattern_Product (pos_) ((T_Patterns (pats_))) =
    (T_Pattern (let _lhsOcopy :: (Pattern)
                    _patsIcopy :: (Patterns)
                    ( _patsIcopy) =
                        (pats_ )
                    -- self rule
                    (_copy@_) =
                        Product pos_ _patsIcopy
                    -- self rule
                    (_lhsOcopy@_) =
                        _copy
                in  ( _lhsOcopy)))
sem_Pattern_Underscore :: (Pos) ->
                          (T_Pattern)
sem_Pattern_Underscore (pos_) =
    (T_Pattern (let _lhsOcopy :: (Pattern)
                    -- self rule
                    (_copy@_) =
                        Underscore pos_
                    -- self rule
                    (_lhsOcopy@_) =
                        _copy
                in  ( _lhsOcopy)))
-- Patterns ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      copy                 : SELF

-}
{-
   local variables for Patterns.Cons:
      copy

-}
{-
   local variables for Patterns.Nil:
      copy

-}
-- semantic domain
newtype T_Patterns = T_Patterns (( (Patterns)))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (Prelude.foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((Prelude.map sem_Pattern list)))
data Inh_Patterns = Inh_Patterns {}
data Syn_Patterns = Syn_Patterns {copy_Syn_Patterns :: Patterns}
wrap_Patterns :: (T_Patterns) ->
                 (Inh_Patterns) ->
                 (Syn_Patterns)
wrap_Patterns ((T_Patterns (sem))) ((Inh_Patterns )) =
    let ( s1) =
            (sem )
    in  (Syn_Patterns (s1))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons ((T_Pattern (hd_))) ((T_Patterns (tl_))) =
    (T_Patterns (let _lhsOcopy :: (Patterns)
                     _hdIcopy :: (Pattern)
                     _tlIcopy :: (Patterns)
                     ( _hdIcopy) =
                         (hd_ )
                     ( _tlIcopy) =
                         (tl_ )
                     -- self rule
                     (_copy@_) =
                         (:) _hdIcopy _tlIcopy
                     -- self rule
                     (_lhsOcopy@_) =
                         _copy
                 in  ( _lhsOcopy)))
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    (T_Patterns (let _lhsOcopy :: (Patterns)
                     -- self rule
                     (_copy@_) =
                         []
                     -- self rule
                     (_lhsOcopy@_) =
                         _copy
                 in  ( _lhsOcopy)))
-- Sequence ----------------------------------------------------
{-
   inherited attributes:
      children             : [(Name,Type)]
      con                  : Constructor
      inh                  : Attributes
      nt                   : Nonterminal
      o_case               : Bool
      o_cata               : Bool
      o_data               : Maybe Bool
      o_newtypes           : Bool
      o_pretty             : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_strictwrap         : Bool
      o_unbox              : Bool
      prefix               : String
      syn                  : Attributes
      terminals            : [Name]

   chained attributes:
      errors               : Seq Error

   synthesised attributes:
      allTpsFound          : Bool
      comments             : [String]
      decls                : Decls
      exprs                : Exprs
      tSigs                : [Decl]
      tps                  : [Type]

-}
{-
   local variables for Sequence.Cons:

-}
{-
   local variables for Sequence.Nil:

-}
-- semantic domain
newtype T_Sequence = T_Sequence (([(Name,Type)]) ->
                                 (Constructor) ->
                                 (Seq Error) ->
                                 (Attributes) ->
                                 (Nonterminal) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Maybe Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (Bool) ->
                                 (String) ->
                                 (Attributes) ->
                                 ([Name]) ->
                                 ( (Bool),([String]),(Decls),(Seq Error),(Exprs),([Decl]),([Type])))
-- cata
sem_Sequence :: (Sequence) ->
                (T_Sequence)
sem_Sequence (list) =
    (Prelude.foldr (sem_Sequence_Cons) (sem_Sequence_Nil) ((Prelude.map sem_CRule list)))
data Inh_Sequence = Inh_Sequence {children_Inh_Sequence :: [(Name,Type)]
                                 ,con_Inh_Sequence :: Constructor
                                 ,errors_Inh_Sequence :: Seq Error
                                 ,inh_Inh_Sequence :: Attributes
                                 ,nt_Inh_Sequence :: Nonterminal
                                 ,o_case_Inh_Sequence :: Bool
                                 ,o_cata_Inh_Sequence :: Bool
                                 ,o_data_Inh_Sequence :: Maybe Bool
                                 ,o_newtypes_Inh_Sequence :: Bool
                                 ,o_pretty_Inh_Sequence :: Bool
                                 ,o_rename_Inh_Sequence :: Bool
                                 ,o_sem_Inh_Sequence :: Bool
                                 ,o_sig_Inh_Sequence :: Bool
                                 ,o_strictwrap_Inh_Sequence :: Bool
                                 ,o_unbox_Inh_Sequence :: Bool
                                 ,prefix_Inh_Sequence :: String
                                 ,syn_Inh_Sequence :: Attributes
                                 ,terminals_Inh_Sequence :: [Name]
                                 }
data Syn_Sequence = Syn_Sequence {allTpsFound_Syn_Sequence :: Bool,comments_Syn_Sequence :: [String],decls_Syn_Sequence :: Decls,errors_Syn_Sequence :: Seq Error,exprs_Syn_Sequence :: Exprs,tSigs_Syn_Sequence :: [Decl],tps_Syn_Sequence :: [Type]}
wrap_Sequence :: (T_Sequence) ->
                 (Inh_Sequence) ->
                 (Syn_Sequence)
wrap_Sequence ((T_Sequence (sem))) ((Inh_Sequence (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18))) =
    let ( s1,s2,s3,s4,s5,s6,s7) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18))
    in  (Syn_Sequence (s1) (s2) (s3) (s4) (s5) (s6) (s7))
sem_Sequence_Cons :: (T_CRule) ->
                     (T_Sequence) ->
                     (T_Sequence)
sem_Sequence_Cons ((T_CRule (hd_))) ((T_Sequence (tl_))) =
    (T_Sequence (\ _lhsIchildren
                   _lhsIcon
                   _lhsIerrors
                   _lhsIinh
                   _lhsInt
                   _lhsIo_case
                   _lhsIo_cata
                   _lhsIo_data
                   _lhsIo_newtypes
                   _lhsIo_pretty
                   _lhsIo_rename
                   _lhsIo_sem
                   _lhsIo_sig
                   _lhsIo_strictwrap
                   _lhsIo_unbox
                   _lhsIprefix
                   _lhsIsyn
                   _lhsIterminals ->
                     let _lhsOallTpsFound :: (Bool)
                         _lhsOcomments :: ([String])
                         _lhsOdecls :: (Decls)
                         _lhsOerrors :: (Seq Error)
                         _lhsOexprs :: (Exprs)
                         _lhsOtSigs :: ([Decl])
                         _lhsOtps :: ([Type])
                         _hdIallTpsFound :: (Bool)
                         _hdIcomments :: ([String])
                         _hdIdecls :: (Decls)
                         _hdIerrors :: (Seq Error)
                         _hdIexprs :: (Exprs)
                         _hdItSigs :: ([Decl])
                         _hdItps :: ([Type])
                         _hdOchildren :: ([(Name,Type)])
                         _hdOcon :: (Constructor)
                         _hdOerrors :: (Seq Error)
                         _hdOinh :: (Attributes)
                         _hdOnt :: (Nonterminal)
                         _hdOo_case :: (Bool)
                         _hdOo_cata :: (Bool)
                         _hdOo_data :: (Maybe Bool)
                         _hdOo_newtypes :: (Bool)
                         _hdOo_pretty :: (Bool)
                         _hdOo_rename :: (Bool)
                         _hdOo_sem :: (Bool)
                         _hdOo_sig :: (Bool)
                         _hdOo_strictwrap :: (Bool)
                         _hdOo_unbox :: (Bool)
                         _hdOprefix :: (String)
                         _hdOsyn :: (Attributes)
                         _hdOterminals :: ([Name])
                         _tlIallTpsFound :: (Bool)
                         _tlIcomments :: ([String])
                         _tlIdecls :: (Decls)
                         _tlIerrors :: (Seq Error)
                         _tlIexprs :: (Exprs)
                         _tlItSigs :: ([Decl])
                         _tlItps :: ([Type])
                         _tlOchildren :: ([(Name,Type)])
                         _tlOcon :: (Constructor)
                         _tlOerrors :: (Seq Error)
                         _tlOinh :: (Attributes)
                         _tlOnt :: (Nonterminal)
                         _tlOo_case :: (Bool)
                         _tlOo_cata :: (Bool)
                         _tlOo_data :: (Maybe Bool)
                         _tlOo_newtypes :: (Bool)
                         _tlOo_pretty :: (Bool)
                         _tlOo_rename :: (Bool)
                         _tlOo_sem :: (Bool)
                         _tlOo_sig :: (Bool)
                         _tlOo_strictwrap :: (Bool)
                         _tlOo_unbox :: (Bool)
                         _tlOprefix :: (String)
                         _tlOsyn :: (Attributes)
                         _tlOterminals :: ([Name])
                         ( _hdIallTpsFound,_hdIcomments,_hdIdecls,_hdIerrors,_hdIexprs,_hdItSigs,_hdItps) =
                             (hd_ (_hdOchildren) (_hdOcon) (_hdOerrors) (_hdOinh) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_newtypes) (_hdOo_pretty) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_strictwrap) (_hdOo_unbox) (_hdOprefix) (_hdOsyn) (_hdOterminals))
                         ( _tlIallTpsFound,_tlIcomments,_tlIdecls,_tlIerrors,_tlIexprs,_tlItSigs,_tlItps) =
                             (tl_ (_tlOchildren) (_tlOcon) (_tlOerrors) (_tlOinh) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_newtypes) (_tlOo_pretty) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_strictwrap) (_tlOo_unbox) (_tlOprefix) (_tlOsyn) (_tlOterminals))
                         -- use rule
                         (_lhsOallTpsFound@_) =
                             _hdIallTpsFound && _tlIallTpsFound
                         -- use rule
                         (_lhsOcomments@_) =
                             _hdIcomments ++ _tlIcomments
                         -- use rule
                         (_lhsOdecls@_) =
                             _hdIdecls ++ _tlIdecls
                         -- use rule
                         (_lhsOerrors@_) =
                             _hdIerrors Seq.<> _tlIerrors
                         -- use rule
                         (_lhsOexprs@_) =
                             _hdIexprs ++ _tlIexprs
                         -- use rule
                         (_lhsOtSigs@_) =
                             _hdItSigs ++ _tlItSigs
                         -- use rule
                         (_lhsOtps@_) =
                             _hdItps ++ _tlItps
                         -- copy rule (down)
                         (_hdOchildren@_) =
                             _lhsIchildren
                         -- copy rule (down)
                         (_hdOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_hdOerrors@_) =
                             _lhsIerrors
                         -- copy rule (down)
                         (_hdOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_hdOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_hdOo_case@_) =
                             _lhsIo_case
                         -- copy rule (down)
                         (_hdOo_cata@_) =
                             _lhsIo_cata
                         -- copy rule (down)
                         (_hdOo_data@_) =
                             _lhsIo_data
                         -- copy rule (down)
                         (_hdOo_newtypes@_) =
                             _lhsIo_newtypes
                         -- copy rule (down)
                         (_hdOo_pretty@_) =
                             _lhsIo_pretty
                         -- copy rule (down)
                         (_hdOo_rename@_) =
                             _lhsIo_rename
                         -- copy rule (down)
                         (_hdOo_sem@_) =
                             _lhsIo_sem
                         -- copy rule (down)
                         (_hdOo_sig@_) =
                             _lhsIo_sig
                         -- copy rule (down)
                         (_hdOo_strictwrap@_) =
                             _lhsIo_strictwrap
                         -- copy rule (down)
                         (_hdOo_unbox@_) =
                             _lhsIo_unbox
                         -- copy rule (down)
                         (_hdOprefix@_) =
                             _lhsIprefix
                         -- copy rule (down)
                         (_hdOsyn@_) =
                             _lhsIsyn
                         -- copy rule (down)
                         (_hdOterminals@_) =
                             _lhsIterminals
                         -- copy rule (down)
                         (_tlOchildren@_) =
                             _lhsIchildren
                         -- copy rule (down)
                         (_tlOcon@_) =
                             _lhsIcon
                         -- copy rule (chain)
                         (_tlOerrors@_) =
                             _hdIerrors
                         -- copy rule (down)
                         (_tlOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_tlOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_tlOo_case@_) =
                             _lhsIo_case
                         -- copy rule (down)
                         (_tlOo_cata@_) =
                             _lhsIo_cata
                         -- copy rule (down)
                         (_tlOo_data@_) =
                             _lhsIo_data
                         -- copy rule (down)
                         (_tlOo_newtypes@_) =
                             _lhsIo_newtypes
                         -- copy rule (down)
                         (_tlOo_pretty@_) =
                             _lhsIo_pretty
                         -- copy rule (down)
                         (_tlOo_rename@_) =
                             _lhsIo_rename
                         -- copy rule (down)
                         (_tlOo_sem@_) =
                             _lhsIo_sem
                         -- copy rule (down)
                         (_tlOo_sig@_) =
                             _lhsIo_sig
                         -- copy rule (down)
                         (_tlOo_strictwrap@_) =
                             _lhsIo_strictwrap
                         -- copy rule (down)
                         (_tlOo_unbox@_) =
                             _lhsIo_unbox
                         -- copy rule (down)
                         (_tlOprefix@_) =
                             _lhsIprefix
                         -- copy rule (down)
                         (_tlOsyn@_) =
                             _lhsIsyn
                         -- copy rule (down)
                         (_tlOterminals@_) =
                             _lhsIterminals
                     in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOexprs,_lhsOtSigs,_lhsOtps)))
sem_Sequence_Nil :: (T_Sequence)
sem_Sequence_Nil  =
    (T_Sequence (\ _lhsIchildren
                   _lhsIcon
                   _lhsIerrors
                   _lhsIinh
                   _lhsInt
                   _lhsIo_case
                   _lhsIo_cata
                   _lhsIo_data
                   _lhsIo_newtypes
                   _lhsIo_pretty
                   _lhsIo_rename
                   _lhsIo_sem
                   _lhsIo_sig
                   _lhsIo_strictwrap
                   _lhsIo_unbox
                   _lhsIprefix
                   _lhsIsyn
                   _lhsIterminals ->
                     let _lhsOallTpsFound :: (Bool)
                         _lhsOcomments :: ([String])
                         _lhsOdecls :: (Decls)
                         _lhsOerrors :: (Seq Error)
                         _lhsOexprs :: (Exprs)
                         _lhsOtSigs :: ([Decl])
                         _lhsOtps :: ([Type])
                         -- use rule
                         (_lhsOallTpsFound@_) =
                             True
                         -- use rule
                         (_lhsOcomments@_) =
                             []
                         -- use rule
                         (_lhsOdecls@_) =
                             []
                         -- use rule
                         (_lhsOerrors@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOexprs@_) =
                             []
                         -- use rule
                         (_lhsOtSigs@_) =
                             []
                         -- use rule
                         (_lhsOtps@_) =
                             []
                     in  ( _lhsOallTpsFound,_lhsOcomments,_lhsOdecls,_lhsOerrors,_lhsOexprs,_lhsOtSigs,_lhsOtps)))


