-- do not edit; automatically generated by UU.AG
module InterfacesRules where

import Interfaces
import SequentialTypes
import CodeSyntax
import GrammarInfo

import UU.DData.Seq as Seq
import qualified UU.DData.Map as Map
import UU.DData.Map(Map)
import qualified UU.DData.Set as Set
import UU.DData.Set(Set)
import Data.Graph
import Data.Maybe (fromJust)
import Data.List (partition,transpose,(\\),nub,intersect)
import Data.Array ((!),inRange,bounds,assocs)

import CommonTypes
import Data.Graph

type VisitSS = [Vertex]

gather :: Info -> [Vertex] -> [[Vertex]]
gather info =  eqClasses comp
               where comp a b = isEqualField (ruleTable info ! a) (ruleTable info ! b)

-- Only non-empty syn will ever be forced, because visits with empty syn are never performed
-- Right hand side synthesized attributes always have a field
cv :: (Vertex -> CRule) -> Int -> Vertex -> ([Vertex],[Vertex]) -> (Vertex,ChildVisit)
cv look n v (inh,syn) =  let  fld = getField (look (head syn))
                              rnt = fromJust (getRhsNt (look (head syn)))
                              d = ChildVisit fld rnt n inh syn
                         in (v,d)

ed v (inh,syn) = map (\i -> (i,v)) inh ++ map (\s -> (v,s)) syn

postorder (Node a ts) = postorderF ts ++ [a]
postorderF = concatMap postorder
postOrd g = postorderF . dfs g
topSort' g = postOrd g

type IntraVisit = [Vertex]

swap (a,b) = (b,a)

ccv :: Name -> Nonterminal -> Int -> CInterfaceMap -> CRule
ccv name nt n table
  =  CChildVisit name nt n inh syn last
     where  CInterface segs = Map.find nt table
            (seg:remain) = drop n segs
            CSegment inh syn = seg           
            last = null remain
-- IRoot -------------------------------------------------------
{-
   inherited attributes:
      dpr                  : [Edge]
      info                 : Info
      tdp                  : Graph

   chained attributes:

   synthesised attributes:
      edp                  : [Edge]
      inters               : CInterfaceMap
      visits               : CVisitsMap

-}
{-
   local variables for IRoot.IRoot:
      visitssGraph
      newedges
      descr

-}
-- semantic domain
newtype T_IRoot = T_IRoot (([Edge]) ->
                           (Info) ->
                           (Graph) ->
                           ( ([Edge]),(CInterfaceMap),(CVisitsMap)))
-- cata
sem_IRoot :: (IRoot) ->
             (T_IRoot)
sem_IRoot ((IRoot (_inters))) =
    (sem_IRoot_IRoot ((sem_Interfaces (_inters))))
data Inh_IRoot = Inh_IRoot {dpr_Inh_IRoot :: [Edge],info_Inh_IRoot :: Info,tdp_Inh_IRoot :: Graph}
data Syn_IRoot = Syn_IRoot {edp_Syn_IRoot :: [Edge],inters_Syn_IRoot :: CInterfaceMap,visits_Syn_IRoot :: CVisitsMap}
wrap_IRoot :: (T_IRoot) ->
              (Inh_IRoot) ->
              (Syn_IRoot)
wrap_IRoot ((T_IRoot (sem))) ((Inh_IRoot (i1) (i2) (i3))) =
    let ( s1,s2,s3) =
            (sem (i1) (i2) (i3))
    in  (Syn_IRoot (s1) (s2) (s3))
sem_IRoot_IRoot :: (T_Interfaces) ->
                   (T_IRoot)
sem_IRoot_IRoot ((T_Interfaces (inters_))) =
    (T_IRoot (\ _lhsIdpr
                _lhsIinfo
                _lhsItdp ->
                  let _lhsOedp :: ([Edge])
                      _lhsOinters :: (CInterfaceMap)
                      _lhsOvisits :: (CVisitsMap)
                      _intersIdescr :: (Seq (Vertex,ChildVisit))
                      _intersIedp :: (Seq Edge)
                      _intersIfirstvisitvertices :: ([Vertex])
                      _intersIinters :: (CInterfaceMap)
                      _intersInewedges :: (Seq Edge )
                      _intersIv :: (Vertex)
                      _intersIvisits :: (CVisitsMap)
                      _intersOallInters :: (CInterfaceMap)
                      _intersOddp :: (Graph)
                      _intersOinfo :: (Info)
                      _intersOprev :: ([Vertex])
                      _intersOv :: (Vertex)
                      _intersOvisitDescr :: (Map Vertex ChildVisit)
                      _intersOvssGraph :: (Graph)
                      ( _intersIdescr,_intersIedp,_intersIfirstvisitvertices,_intersIinters,_intersInewedges,_intersIv,_intersIvisits) =
                          (inters_ (_intersOallInters) (_intersOddp) (_intersOinfo) (_intersOprev) (_intersOv) (_intersOvisitDescr) (_intersOvssGraph))
                      -- "InterfacesRules.lag"(line 62, column 12)
                      (_visitssGraph@_) =
                          let graph = buildG (0,_intersIv-1) es
                              es = _newedges ++ edges _lhsItdp
                          in transposeG graph
                      -- "InterfacesRules.lag"(line 61, column 12)
                      (_newedges@_) =
                          Seq.toList _intersInewedges
                      -- "InterfacesRules.lag"(line 75, column 12)
                      (_intersOv@_) =
                          snd (bounds _lhsItdp) + 1
                      -- "InterfacesRules.lag"(line 112, column 13)
                      (_intersOvisitDescr@_) =
                          Map.fromList _descr
                      -- "InterfacesRules.lag"(line 132, column 12)
                      (_descr@_) =
                          Seq.toList _intersIdescr
                      -- "InterfacesRules.lag"(line 201, column 12)
                      (_intersOvssGraph@_) =
                          _visitssGraph
                      -- "InterfacesRules.lag"(line 243, column 12)
                      (_intersOprev@_) =
                          let terminals = [ v | (v,cr) <- assocs (ruleTable _lhsIinfo), not (getHasCode cr), isLocal cr ]
                          in _intersIfirstvisitvertices ++ terminals
                      -- "InterfacesRules.lag"(line 322, column 12)
                      (_intersOddp@_) =
                          buildG (0,_intersIv-1) (map swap (_lhsIdpr ++ _newedges))
                      -- "InterfacesRules.lag"(line 359, column 13)
                      (_intersOallInters@_) =
                          _intersIinters
                      -- "InterfacesRules.lag"(line 419, column 13)
                      (_lhsOedp@_) =
                          Seq.toList _intersIedp
                      -- copy rule (up)
                      (_lhsOinters@_) =
                          _intersIinters
                      -- copy rule (up)
                      (_lhsOvisits@_) =
                          _intersIvisits
                      -- copy rule (down)
                      (_intersOinfo@_) =
                          _lhsIinfo
                  in  ( _lhsOedp,_lhsOinters,_lhsOvisits)))
-- Interface ---------------------------------------------------
{-
   inherited attributes:
      allInters            : CInterfaceMap
      ddp                  : Graph
      info                 : Info
      prev                 : [Vertex]
      visitDescr           : Map Vertex ChildVisit
      vssGraph             : Graph

   chained attributes:
      v                    : Vertex

   synthesised attributes:
      descr                : Seq (Vertex,ChildVisit)
      edp                  : Seq Edge
      firstvisitvertices   : [Vertex]
      inter                : CInterface
      newedges             : Seq Edge 
      nt                   : Nonterminal
      visits               : Map Constructor CVisits

-}
{-
   local variables for Interface.Interface:
      descr
      look
      newedges
      firstvisitvertices
      v

-}
-- semantic domain
newtype T_Interface = T_Interface ((CInterfaceMap) ->
                                   (Graph) ->
                                   (Info) ->
                                   ([Vertex]) ->
                                   (Vertex) ->
                                   (Map Vertex ChildVisit) ->
                                   (Graph) ->
                                   ( (Seq (Vertex,ChildVisit)),(Seq Edge),([Vertex]),(CInterface),(Seq Edge ),(Nonterminal),(Vertex),(Map Constructor CVisits)))
-- cata
sem_Interface :: (Interface) ->
                 (T_Interface)
sem_Interface ((Interface (_nt) (_cons) (_seg))) =
    (sem_Interface_Interface (_nt) (_cons) ((sem_Segments (_seg))))
data Inh_Interface = Inh_Interface {allInters_Inh_Interface :: CInterfaceMap,ddp_Inh_Interface :: Graph,info_Inh_Interface :: Info,prev_Inh_Interface :: [Vertex],v_Inh_Interface :: Vertex,visitDescr_Inh_Interface :: Map Vertex ChildVisit,vssGraph_Inh_Interface :: Graph}
data Syn_Interface = Syn_Interface {descr_Syn_Interface :: Seq (Vertex,ChildVisit),edp_Syn_Interface :: Seq Edge,firstvisitvertices_Syn_Interface :: [Vertex],inter_Syn_Interface :: CInterface,newedges_Syn_Interface :: Seq Edge ,nt_Syn_Interface :: Nonterminal,v_Syn_Interface :: Vertex,visits_Syn_Interface :: Map Constructor CVisits}
wrap_Interface :: (T_Interface) ->
                  (Inh_Interface) ->
                  (Syn_Interface)
wrap_Interface ((T_Interface (sem))) ((Inh_Interface (i1) (i2) (i3) (i4) (i5) (i6) (i7))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7))
    in  (Syn_Interface (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8))
sem_Interface_Interface :: (Nonterminal) ->
                           ([Constructor]) ->
                           (T_Segments) ->
                           (T_Interface)
sem_Interface_Interface (nt_) (cons_) ((T_Segments (seg_))) =
    (T_Interface (\ _lhsIallInters
                    _lhsIddp
                    _lhsIinfo
                    _lhsIprev
                    _lhsIv
                    _lhsIvisitDescr
                    _lhsIvssGraph ->
                      let _lhsOdescr :: (Seq (Vertex,ChildVisit))
                          _lhsOedp :: (Seq Edge)
                          _lhsOfirstvisitvertices :: ([Vertex])
                          _lhsOinter :: (CInterface)
                          _lhsOnewedges :: (Seq Edge )
                          _lhsOnt :: (Nonterminal)
                          _lhsOv :: (Vertex)
                          _lhsOvisits :: (Map Constructor CVisits)
                          _segIcvisits :: ([[CVisit]])
                          _segIdescr :: (Seq (Vertex,ChildVisit))
                          _segIedp :: (Seq Edge)
                          _segIfirstInh :: ([Vertex])
                          _segIgroups :: ([([Vertex],[Vertex])])
                          _segIhdIntravisits :: ([IntraVisit])
                          _segInewedges :: (Seq Edge )
                          _segInewvertices :: ([Vertex])
                          _segIprev :: ([Vertex])
                          _segIsegs :: (CSegments)
                          _segIv :: (Vertex)
                          _segOallInters :: (CInterfaceMap)
                          _segOcons :: ([Constructor])
                          _segOddp :: (Graph)
                          _segOfromLhs :: ([Vertex])
                          _segOinfo :: (Info)
                          _segOisFirst :: (Bool)
                          _segOn :: (Int)
                          _segOprev :: ([Vertex])
                          _segOv :: (Vertex)
                          _segOvisitDescr :: (Map Vertex ChildVisit)
                          _segOvssGraph :: (Graph)
                          ( _segIcvisits,_segIdescr,_segIedp,_segIfirstInh,_segIgroups,_segIhdIntravisits,_segInewedges,_segInewvertices,_segIprev,_segIsegs,_segIv) =
                              (seg_ (_segOallInters) (_segOcons) (_segOddp) (_segOfromLhs) (_segOinfo) (_segOisFirst) (_segOn) (_segOprev) (_segOv) (_segOvisitDescr) (_segOvssGraph))
                          -- "InterfacesRules.lag"(line 180, column 17)
                          (_lhsOdescr@_) =
                              _segIdescr Seq.<> Seq.fromList _descr
                          -- "InterfacesRules.lag"(line 179, column 17)
                          (_descr@_) =
                              zipWith (cv _look (-1)) _firstvisitvertices _segIgroups
                          -- "InterfacesRules.lag"(line 178, column 17)
                          (_look@_) =
                              \a -> ruleTable _lhsIinfo ! a
                          -- "InterfacesRules.lag"(line 177, column 17)
                          (_lhsOnewedges@_) =
                              _segInewedges Seq.<> Seq.fromList _newedges
                          -- "InterfacesRules.lag"(line 176, column 17)
                          (_newedges@_) =
                              zip _firstvisitvertices _segInewvertices
                          -- "InterfacesRules.lag"(line 175, column 17)
                          (_firstvisitvertices@_) =
                              [_segIv .. _v-1]
                          -- "InterfacesRules.lag"(line 174, column 17)
                          (_lhsOv@_) =
                              _v
                          -- "InterfacesRules.lag"(line 173, column 17)
                          (_v@_) =
                              _segIv + length _segInewvertices
                          -- "InterfacesRules.lag"(line 172, column 17)
                          (_segOv@_) =
                              _lhsIv
                          -- "InterfacesRules.lag"(line 188, column 16)
                          (_segOn@_) =
                              0
                          -- "InterfacesRules.lag"(line 220, column 16)
                          (_segOcons@_) =
                              cons_
                          -- "InterfacesRules.lag"(line 293, column 16)
                          (_segOisFirst@_) =
                              True
                          -- "InterfacesRules.lag"(line 330, column 16)
                          (_segOfromLhs@_) =
                              _lhsIprev
                          -- "InterfacesRules.lag"(line 370, column 16)
                          (_lhsOnt@_) =
                              nt_
                          -- "InterfacesRules.lag"(line 375, column 17)
                          (_lhsOvisits@_) =
                              Map.fromList (zip cons_ (transpose _segIcvisits))
                          -- "InterfacesRules.lag"(line 374, column 17)
                          (_lhsOinter@_) =
                              CInterface _segIsegs
                          -- use rule
                          (_lhsOedp@_) =
                              _segIedp
                          -- use rule
                          (_lhsOfirstvisitvertices@_) =
                              _firstvisitvertices
                          -- copy rule (down)
                          (_segOallInters@_) =
                              _lhsIallInters
                          -- copy rule (down)
                          (_segOddp@_) =
                              _lhsIddp
                          -- copy rule (down)
                          (_segOinfo@_) =
                              _lhsIinfo
                          -- copy rule (down)
                          (_segOprev@_) =
                              _lhsIprev
                          -- copy rule (down)
                          (_segOvisitDescr@_) =
                              _lhsIvisitDescr
                          -- copy rule (down)
                          (_segOvssGraph@_) =
                              _lhsIvssGraph
                      in  ( _lhsOdescr,_lhsOedp,_lhsOfirstvisitvertices,_lhsOinter,_lhsOnewedges,_lhsOnt,_lhsOv,_lhsOvisits)))
-- Interfaces --------------------------------------------------
{-
   inherited attributes:
      allInters            : CInterfaceMap
      ddp                  : Graph
      info                 : Info
      prev                 : [Vertex]
      visitDescr           : Map Vertex ChildVisit
      vssGraph             : Graph

   chained attributes:
      v                    : Vertex

   synthesised attributes:
      descr                : Seq (Vertex,ChildVisit)
      edp                  : Seq Edge
      firstvisitvertices   : [Vertex]
      inters               : CInterfaceMap
      newedges             : Seq Edge 
      visits               : CVisitsMap

-}
{-
   local variables for Interfaces.Cons:

-}
{-
   local variables for Interfaces.Nil:

-}
-- semantic domain
newtype T_Interfaces = T_Interfaces ((CInterfaceMap) ->
                                     (Graph) ->
                                     (Info) ->
                                     ([Vertex]) ->
                                     (Vertex) ->
                                     (Map Vertex ChildVisit) ->
                                     (Graph) ->
                                     ( (Seq (Vertex,ChildVisit)),(Seq Edge),([Vertex]),(CInterfaceMap),(Seq Edge ),(Vertex),(CVisitsMap)))
-- cata
sem_Interfaces :: (Interfaces) ->
                  (T_Interfaces)
sem_Interfaces (list) =
    (Prelude.foldr (sem_Interfaces_Cons) (sem_Interfaces_Nil) ((Prelude.map sem_Interface list)))
data Inh_Interfaces = Inh_Interfaces {allInters_Inh_Interfaces :: CInterfaceMap,ddp_Inh_Interfaces :: Graph,info_Inh_Interfaces :: Info,prev_Inh_Interfaces :: [Vertex],v_Inh_Interfaces :: Vertex,visitDescr_Inh_Interfaces :: Map Vertex ChildVisit,vssGraph_Inh_Interfaces :: Graph}
data Syn_Interfaces = Syn_Interfaces {descr_Syn_Interfaces :: Seq (Vertex,ChildVisit),edp_Syn_Interfaces :: Seq Edge,firstvisitvertices_Syn_Interfaces :: [Vertex],inters_Syn_Interfaces :: CInterfaceMap,newedges_Syn_Interfaces :: Seq Edge ,v_Syn_Interfaces :: Vertex,visits_Syn_Interfaces :: CVisitsMap}
wrap_Interfaces :: (T_Interfaces) ->
                   (Inh_Interfaces) ->
                   (Syn_Interfaces)
wrap_Interfaces ((T_Interfaces (sem))) ((Inh_Interfaces (i1) (i2) (i3) (i4) (i5) (i6) (i7))) =
    let ( s1,s2,s3,s4,s5,s6,s7) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7))
    in  (Syn_Interfaces (s1) (s2) (s3) (s4) (s5) (s6) (s7))
sem_Interfaces_Cons :: (T_Interface) ->
                       (T_Interfaces) ->
                       (T_Interfaces)
sem_Interfaces_Cons ((T_Interface (hd_))) ((T_Interfaces (tl_))) =
    (T_Interfaces (\ _lhsIallInters
                     _lhsIddp
                     _lhsIinfo
                     _lhsIprev
                     _lhsIv
                     _lhsIvisitDescr
                     _lhsIvssGraph ->
                       let _lhsOdescr :: (Seq (Vertex,ChildVisit))
                           _lhsOedp :: (Seq Edge)
                           _lhsOfirstvisitvertices :: ([Vertex])
                           _lhsOinters :: (CInterfaceMap)
                           _lhsOnewedges :: (Seq Edge )
                           _lhsOv :: (Vertex)
                           _lhsOvisits :: (CVisitsMap)
                           _hdIdescr :: (Seq (Vertex,ChildVisit))
                           _hdIedp :: (Seq Edge)
                           _hdIfirstvisitvertices :: ([Vertex])
                           _hdIinter :: (CInterface)
                           _hdInewedges :: (Seq Edge )
                           _hdInt :: (Nonterminal)
                           _hdIv :: (Vertex)
                           _hdIvisits :: (Map Constructor CVisits)
                           _hdOallInters :: (CInterfaceMap)
                           _hdOddp :: (Graph)
                           _hdOinfo :: (Info)
                           _hdOprev :: ([Vertex])
                           _hdOv :: (Vertex)
                           _hdOvisitDescr :: (Map Vertex ChildVisit)
                           _hdOvssGraph :: (Graph)
                           _tlIdescr :: (Seq (Vertex,ChildVisit))
                           _tlIedp :: (Seq Edge)
                           _tlIfirstvisitvertices :: ([Vertex])
                           _tlIinters :: (CInterfaceMap)
                           _tlInewedges :: (Seq Edge )
                           _tlIv :: (Vertex)
                           _tlIvisits :: (CVisitsMap)
                           _tlOallInters :: (CInterfaceMap)
                           _tlOddp :: (Graph)
                           _tlOinfo :: (Info)
                           _tlOprev :: ([Vertex])
                           _tlOv :: (Vertex)
                           _tlOvisitDescr :: (Map Vertex ChildVisit)
                           _tlOvssGraph :: (Graph)
                           ( _hdIdescr,_hdIedp,_hdIfirstvisitvertices,_hdIinter,_hdInewedges,_hdInt,_hdIv,_hdIvisits) =
                               (hd_ (_hdOallInters) (_hdOddp) (_hdOinfo) (_hdOprev) (_hdOv) (_hdOvisitDescr) (_hdOvssGraph))
                           ( _tlIdescr,_tlIedp,_tlIfirstvisitvertices,_tlIinters,_tlInewedges,_tlIv,_tlIvisits) =
                               (tl_ (_tlOallInters) (_tlOddp) (_tlOinfo) (_tlOprev) (_tlOv) (_tlOvisitDescr) (_tlOvssGraph))
                           -- "InterfacesRules.lag"(line 365, column 12)
                           (_lhsOvisits@_) =
                               Map.insert _hdInt _hdIvisits _tlIvisits
                           -- "InterfacesRules.lag"(line 364, column 12)
                           (_lhsOinters@_) =
                               Map.insert _hdInt _hdIinter _tlIinters
                           -- use rule
                           (_lhsOdescr@_) =
                               _hdIdescr Seq.<> _tlIdescr
                           -- use rule
                           (_lhsOedp@_) =
                               _hdIedp Seq.<> _tlIedp
                           -- use rule
                           (_lhsOfirstvisitvertices@_) =
                               _hdIfirstvisitvertices ++ _tlIfirstvisitvertices
                           -- use rule
                           (_lhsOnewedges@_) =
                               _hdInewedges Seq.<> _tlInewedges
                           -- copy rule (up)
                           (_lhsOv@_) =
                               _tlIv
                           -- copy rule (down)
                           (_hdOallInters@_) =
                               _lhsIallInters
                           -- copy rule (down)
                           (_hdOddp@_) =
                               _lhsIddp
                           -- copy rule (down)
                           (_hdOinfo@_) =
                               _lhsIinfo
                           -- copy rule (down)
                           (_hdOprev@_) =
                               _lhsIprev
                           -- copy rule (down)
                           (_hdOv@_) =
                               _lhsIv
                           -- copy rule (down)
                           (_hdOvisitDescr@_) =
                               _lhsIvisitDescr
                           -- copy rule (down)
                           (_hdOvssGraph@_) =
                               _lhsIvssGraph
                           -- copy rule (down)
                           (_tlOallInters@_) =
                               _lhsIallInters
                           -- copy rule (down)
                           (_tlOddp@_) =
                               _lhsIddp
                           -- copy rule (down)
                           (_tlOinfo@_) =
                               _lhsIinfo
                           -- copy rule (down)
                           (_tlOprev@_) =
                               _lhsIprev
                           -- copy rule (chain)
                           (_tlOv@_) =
                               _hdIv
                           -- copy rule (down)
                           (_tlOvisitDescr@_) =
                               _lhsIvisitDescr
                           -- copy rule (down)
                           (_tlOvssGraph@_) =
                               _lhsIvssGraph
                       in  ( _lhsOdescr,_lhsOedp,_lhsOfirstvisitvertices,_lhsOinters,_lhsOnewedges,_lhsOv,_lhsOvisits)))
sem_Interfaces_Nil :: (T_Interfaces)
sem_Interfaces_Nil  =
    (T_Interfaces (\ _lhsIallInters
                     _lhsIddp
                     _lhsIinfo
                     _lhsIprev
                     _lhsIv
                     _lhsIvisitDescr
                     _lhsIvssGraph ->
                       let _lhsOdescr :: (Seq (Vertex,ChildVisit))
                           _lhsOedp :: (Seq Edge)
                           _lhsOfirstvisitvertices :: ([Vertex])
                           _lhsOinters :: (CInterfaceMap)
                           _lhsOnewedges :: (Seq Edge )
                           _lhsOv :: (Vertex)
                           _lhsOvisits :: (CVisitsMap)
                           -- "InterfacesRules.lag"(line 367, column 12)
                           (_lhsOvisits@_) =
                               Map.empty
                           -- "InterfacesRules.lag"(line 366, column 12)
                           (_lhsOinters@_) =
                               Map.empty
                           -- use rule
                           (_lhsOdescr@_) =
                               Seq.empty
                           -- use rule
                           (_lhsOedp@_) =
                               Seq.empty
                           -- use rule
                           (_lhsOfirstvisitvertices@_) =
                               []
                           -- use rule
                           (_lhsOnewedges@_) =
                               Seq.empty
                           -- copy rule (chain)
                           (_lhsOv@_) =
                               _lhsIv
                       in  ( _lhsOdescr,_lhsOedp,_lhsOfirstvisitvertices,_lhsOinters,_lhsOnewedges,_lhsOv,_lhsOvisits)))
-- Segment -----------------------------------------------------
{-
   inherited attributes:
      allInters            : CInterfaceMap
      cons                 : [Constructor]
      ddp                  : Graph
      fromLhs              : [Vertex]
      info                 : Info
      isFirst              : Bool
      n                    : Int
      nextInh              : [Vertex]
      nextIntravisits      : [IntraVisit]
      nextNewvertices      : [Vertex]
      visitDescr           : Map Vertex ChildVisit
      vssGraph             : Graph

   chained attributes:
      prev                 : [Vertex]
      v                    : Vertex

   synthesised attributes:
      cvisits              : [CVisit]
      descr                : Seq (Vertex,ChildVisit)
      edp                  : Seq Edge
      groups               : [([Vertex],[Vertex])]
      inh                  : [Vertex]
      intravisits          : [IntraVisit]
      newedges             : Seq Edge 
      newvertices          : [Vertex]
      seg                  : CSegment
      visitss              : [VisitSS]

-}
{-
   local variables for Segment.Segment:
      newvertices
      v
      groups
      occurAs
      look
      attredges
      visitedges
      vss
      synOccur
      defined
      visitss'
      visitss
      iv
      intravisits
      computed
      fromLhs
      inhmap
      synmap

-}
-- semantic domain
newtype T_Segment = T_Segment ((CInterfaceMap) ->
                               ([Constructor]) ->
                               (Graph) ->
                               ([Vertex]) ->
                               (Info) ->
                               (Bool) ->
                               (Int) ->
                               ([Vertex]) ->
                               ([IntraVisit]) ->
                               ([Vertex]) ->
                               ([Vertex]) ->
                               (Vertex) ->
                               (Map Vertex ChildVisit) ->
                               (Graph) ->
                               ( ([CVisit]),(Seq (Vertex,ChildVisit)),(Seq Edge),([([Vertex],[Vertex])]),([Vertex]),([IntraVisit]),(Seq Edge ),([Vertex]),([Vertex]),(CSegment),(Vertex),([VisitSS])))
-- cata
sem_Segment :: (Segment) ->
               (T_Segment)
sem_Segment ((Segment (_inh) (_syn))) =
    (sem_Segment_Segment (_inh) (_syn))
data Inh_Segment = Inh_Segment {allInters_Inh_Segment :: CInterfaceMap
                               ,cons_Inh_Segment :: [Constructor]
                               ,ddp_Inh_Segment :: Graph
                               ,fromLhs_Inh_Segment :: [Vertex]
                               ,info_Inh_Segment :: Info
                               ,isFirst_Inh_Segment :: Bool
                               ,n_Inh_Segment :: Int
                               ,nextInh_Inh_Segment :: [Vertex]
                               ,nextIntravisits_Inh_Segment :: [IntraVisit]
                               ,nextNewvertices_Inh_Segment :: [Vertex]
                               ,prev_Inh_Segment :: [Vertex]
                               ,v_Inh_Segment :: Vertex
                               ,visitDescr_Inh_Segment :: Map Vertex ChildVisit
                               ,vssGraph_Inh_Segment :: Graph
                               }
data Syn_Segment = Syn_Segment {cvisits_Syn_Segment :: [CVisit],descr_Syn_Segment :: Seq (Vertex,ChildVisit),edp_Syn_Segment :: Seq Edge,groups_Syn_Segment :: [([Vertex],[Vertex])],inh_Syn_Segment :: [Vertex],intravisits_Syn_Segment :: [IntraVisit],newedges_Syn_Segment :: Seq Edge ,newvertices_Syn_Segment :: [Vertex],prev_Syn_Segment :: [Vertex],seg_Syn_Segment :: CSegment,v_Syn_Segment :: Vertex,visitss_Syn_Segment :: [VisitSS]}
wrap_Segment :: (T_Segment) ->
                (Inh_Segment) ->
                (Syn_Segment)
wrap_Segment ((T_Segment (sem))) ((Inh_Segment (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14))
    in  (Syn_Segment (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9) (s10) (s11) (s12))
sem_Segment_Segment :: ([Vertex]) ->
                       ([Vertex]) ->
                       (T_Segment)
sem_Segment_Segment (inh_) (syn_) =
    (T_Segment (\ _lhsIallInters
                  _lhsIcons
                  _lhsIddp
                  _lhsIfromLhs
                  _lhsIinfo
                  _lhsIisFirst
                  _lhsIn
                  _lhsInextInh
                  _lhsInextIntravisits
                  _lhsInextNewvertices
                  _lhsIprev
                  _lhsIv
                  _lhsIvisitDescr
                  _lhsIvssGraph ->
                    let _lhsOcvisits :: ([CVisit])
                        _lhsOdescr :: (Seq (Vertex,ChildVisit))
                        _lhsOedp :: (Seq Edge)
                        _lhsOgroups :: ([([Vertex],[Vertex])])
                        _lhsOinh :: ([Vertex])
                        _lhsOintravisits :: ([IntraVisit])
                        _lhsOnewedges :: (Seq Edge )
                        _lhsOnewvertices :: ([Vertex])
                        _lhsOprev :: ([Vertex])
                        _lhsOseg :: (CSegment)
                        _lhsOv :: (Vertex)
                        _lhsOvisitss :: ([VisitSS])
                        -- "InterfacesRules.lag"(line 102, column 15)
                        (_newvertices@_) =
                            [_lhsIv .. _v    -1]
                        -- "InterfacesRules.lag"(line 101, column 15)
                        (_v@_) =
                            _lhsIv + length _groups
                        -- "InterfacesRules.lag"(line 99, column 15)
                        (_groups@_) =
                            let group as = gather _lhsIinfo (_occurAs isRhs as)
                            in map (partition (isInh . _look)) (group (inh_ ++ syn_))
                        -- "InterfacesRules.lag"(line 96, column 15)
                        (_occurAs@_) =
                            \p us -> [ a  |  u <- us
                                          ,  a <- tdsToTdp _lhsIinfo ! u
                                          ,  p (_look a)]
                        -- "InterfacesRules.lag"(line 95, column 15)
                        (_look@_) =
                            \a -> ruleTable _lhsIinfo ! a
                        -- "InterfacesRules.lag"(line 117, column 14)
                        (_lhsOdescr@_) =
                            Seq.fromList $ zipWith (cv _look _lhsIn) _newvertices _groups
                        -- "InterfacesRules.lag"(line 140, column 14)
                        (_attredges@_) =
                            concat (zipWith ed _newvertices _groups)
                        -- "InterfacesRules.lag"(line 160, column 15)
                        (_lhsOnewedges@_) =
                            Seq.fromList _attredges Seq.<> Seq.fromList _visitedges
                        -- "InterfacesRules.lag"(line 159, column 15)
                        (_visitedges@_) =
                            zip _newvertices _lhsInextNewvertices
                        -- "InterfacesRules.lag"(line 213, column 15)
                        (_vss@_) =
                            let hasCode v | inRange (bounds (ruleTable _lhsIinfo)) v =  getHasCode (ruleTable _lhsIinfo ! v)
                                          | otherwise = True
                            in if  null syn_
                                   then replicate (length _lhsIcons) []
                                   else map (filter hasCode . topSort' _lhsIvssGraph) _synOccur
                        -- "InterfacesRules.lag"(line 212, column 15)
                        (_synOccur@_) =
                            gather _lhsIinfo (_occurAs isLhs syn_)
                        -- "InterfacesRules.lag"(line 258, column 15)
                        (_lhsOprev@_) =
                            _lhsIprev ++ _defined
                        -- "InterfacesRules.lag"(line 254, column 15)
                        (_defined@_) =
                            let defines v = case Map.lookup v _lhsIvisitDescr of
                                              Nothing -> [v]
                                              Just (ChildVisit _ _ _ inh _) -> v:inh
                            in concatMap (concatMap defines) _visitss
                        -- "InterfacesRules.lag"(line 253, column 15)
                        (_visitss'@_) =
                            map (\\ _lhsIprev) _vss
                        -- "InterfacesRules.lag"(line 266, column 15)
                        (_visitss@_) =
                            let  rem :: [(Name,Name,Maybe Type)] -> [Vertex] -> [Vertex]
                                 rem prev [] = []
                                 rem prev (v:vs)
                                   | inRange (bounds table) v
                                       = let  cr = table ! v
                                              addV = if  (getField cr,getAttr cr,getType cr) `elem` prev
                                                         then id
                                                         else (v:)
                                              def = Map.elems (getDefines cr)
                                         in addV (rem (def ++ prev) vs)
                                   | otherwise = v:rem prev vs
                                 table = ruleTable _lhsIinfo
                            in map (rem []) _visitss'
                        -- "InterfacesRules.lag"(line 341, column 15)
                        (_iv@_) =
                            \vs next ->
                              let needed = concatMap (_lhsIddp !) vs
                              in nub (needed ++ next) \\ (_fromLhs ++ _computed)
                        -- "InterfacesRules.lag"(line 340, column 15)
                        (_intravisits@_) =
                            zipWith _iv _visitss _lhsInextIntravisits
                        -- "InterfacesRules.lag"(line 336, column 15)
                        (_computed@_) =
                            let computes v = case Map.lookup v _lhsIvisitDescr of
                                               Nothing -> Map.keys (getDefines (ruleTable _lhsIinfo ! v))
                                               Just (ChildVisit _ _ _ _ syn) -> v:syn
                            in concatMap (concatMap computes) _visitss
                        -- "InterfacesRules.lag"(line 335, column 15)
                        (_fromLhs@_) =
                            _occurAs isLhs inh_ ++ _lhsIfromLhs
                        -- "InterfacesRules.lag"(line 389, column 15)
                        (_lhsOcvisits@_) =
                            let  mkVisit vss intra = CVisit _inhmap _synmap (mkSequence vss) (mkSequence intra) True
                                 mkSequence = map mkRule
                                 mkRule v = case Map.lookup v _lhsIvisitDescr of
                                              Nothing -> ruleTable _lhsIinfo ! v
                                              Just (ChildVisit name nt n _ _) -> ccv name nt n _lhsIallInters
                            in zipWith mkVisit _visitss _intravisits
                        -- "InterfacesRules.lag"(line 386, column 19)
                        ((_inhmap@_,_synmap@_)) =
                            let makemap = Map.fromList . map findType
                                findType v = getNtaNameType (attrTable _lhsIinfo ! v)
                            in (makemap inh_,makemap syn_)
                        -- "InterfacesRules.lag"(line 384, column 15)
                        (_lhsOseg@_) =
                            if False then undefined _lhsIvssGraph _lhsIvisitDescr _lhsIprev else CSegment _inhmap _synmap
                        -- "InterfacesRules.lag"(line 416, column 14)
                        (_lhsOedp@_) =
                            Seq.fromList [(i,s) | i <- inh_, s <- syn_]
                            Seq.<> Seq.fromList [(s,i) | s <- syn_, i <- _lhsInextInh ]
                        -- "InterfacesRules.lag"(line 421, column 14)
                        (_lhsOinh@_) =
                            inh_
                        -- copy rule (from local)
                        (_lhsOgroups@_) =
                            _groups
                        -- copy rule (from local)
                        (_lhsOintravisits@_) =
                            _intravisits
                        -- copy rule (from local)
                        (_lhsOnewvertices@_) =
                            _newvertices
                        -- copy rule (from local)
                        (_lhsOv@_) =
                            _v
                        -- copy rule (from local)
                        (_lhsOvisitss@_) =
                            _visitss
                    in  ( _lhsOcvisits,_lhsOdescr,_lhsOedp,_lhsOgroups,_lhsOinh,_lhsOintravisits,_lhsOnewedges,_lhsOnewvertices,_lhsOprev,_lhsOseg,_lhsOv,_lhsOvisitss)))
-- Segments ----------------------------------------------------
{-
   inherited attributes:
      allInters            : CInterfaceMap
      cons                 : [Constructor]
      ddp                  : Graph
      fromLhs              : [Vertex]
      info                 : Info
      isFirst              : Bool
      n                    : Int
      visitDescr           : Map Vertex ChildVisit
      vssGraph             : Graph

   chained attributes:
      prev                 : [Vertex]
      v                    : Vertex

   synthesised attributes:
      cvisits              : [[CVisit]]
      descr                : Seq (Vertex,ChildVisit)
      edp                  : Seq Edge
      firstInh             : [Vertex]
      groups               : [([Vertex],[Vertex])]
      hdIntravisits        : [IntraVisit]
      newedges             : Seq Edge 
      newvertices          : [Vertex]
      segs                 : CSegments

-}
{-
   local variables for Segments.Cons:

-}
{-
   local variables for Segments.Nil:

-}
-- semantic domain
newtype T_Segments = T_Segments ((CInterfaceMap) ->
                                 ([Constructor]) ->
                                 (Graph) ->
                                 ([Vertex]) ->
                                 (Info) ->
                                 (Bool) ->
                                 (Int) ->
                                 ([Vertex]) ->
                                 (Vertex) ->
                                 (Map Vertex ChildVisit) ->
                                 (Graph) ->
                                 ( ([[CVisit]]),(Seq (Vertex,ChildVisit)),(Seq Edge),([Vertex]),([([Vertex],[Vertex])]),([IntraVisit]),(Seq Edge ),([Vertex]),([Vertex]),(CSegments),(Vertex)))
-- cata
sem_Segments :: (Segments) ->
                (T_Segments)
sem_Segments (list) =
    (Prelude.foldr (sem_Segments_Cons) (sem_Segments_Nil) ((Prelude.map sem_Segment list)))
data Inh_Segments = Inh_Segments {allInters_Inh_Segments :: CInterfaceMap,cons_Inh_Segments :: [Constructor],ddp_Inh_Segments :: Graph,fromLhs_Inh_Segments :: [Vertex],info_Inh_Segments :: Info,isFirst_Inh_Segments :: Bool,n_Inh_Segments :: Int,prev_Inh_Segments :: [Vertex],v_Inh_Segments :: Vertex,visitDescr_Inh_Segments :: Map Vertex ChildVisit,vssGraph_Inh_Segments :: Graph}
data Syn_Segments = Syn_Segments {cvisits_Syn_Segments :: [[CVisit]],descr_Syn_Segments :: Seq (Vertex,ChildVisit),edp_Syn_Segments :: Seq Edge,firstInh_Syn_Segments :: [Vertex],groups_Syn_Segments :: [([Vertex],[Vertex])],hdIntravisits_Syn_Segments :: [IntraVisit],newedges_Syn_Segments :: Seq Edge ,newvertices_Syn_Segments :: [Vertex],prev_Syn_Segments :: [Vertex],segs_Syn_Segments :: CSegments,v_Syn_Segments :: Vertex}
wrap_Segments :: (T_Segments) ->
                 (Inh_Segments) ->
                 (Syn_Segments)
wrap_Segments ((T_Segments (sem))) ((Inh_Segments (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11))
    in  (Syn_Segments (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9) (s10) (s11))
sem_Segments_Cons :: (T_Segment) ->
                     (T_Segments) ->
                     (T_Segments)
sem_Segments_Cons ((T_Segment (hd_))) ((T_Segments (tl_))) =
    (T_Segments (\ _lhsIallInters
                   _lhsIcons
                   _lhsIddp
                   _lhsIfromLhs
                   _lhsIinfo
                   _lhsIisFirst
                   _lhsIn
                   _lhsIprev
                   _lhsIv
                   _lhsIvisitDescr
                   _lhsIvssGraph ->
                     let _lhsOcvisits :: ([[CVisit]])
                         _lhsOdescr :: (Seq (Vertex,ChildVisit))
                         _lhsOedp :: (Seq Edge)
                         _lhsOfirstInh :: ([Vertex])
                         _lhsOgroups :: ([([Vertex],[Vertex])])
                         _lhsOhdIntravisits :: ([IntraVisit])
                         _lhsOnewedges :: (Seq Edge )
                         _lhsOnewvertices :: ([Vertex])
                         _lhsOprev :: ([Vertex])
                         _lhsOsegs :: (CSegments)
                         _lhsOv :: (Vertex)
                         _hdIcvisits :: ([CVisit])
                         _hdIdescr :: (Seq (Vertex,ChildVisit))
                         _hdIedp :: (Seq Edge)
                         _hdIgroups :: ([([Vertex],[Vertex])])
                         _hdIinh :: ([Vertex])
                         _hdIintravisits :: ([IntraVisit])
                         _hdInewedges :: (Seq Edge )
                         _hdInewvertices :: ([Vertex])
                         _hdIprev :: ([Vertex])
                         _hdIseg :: (CSegment)
                         _hdIv :: (Vertex)
                         _hdIvisitss :: ([VisitSS])
                         _hdOallInters :: (CInterfaceMap)
                         _hdOcons :: ([Constructor])
                         _hdOddp :: (Graph)
                         _hdOfromLhs :: ([Vertex])
                         _hdOinfo :: (Info)
                         _hdOisFirst :: (Bool)
                         _hdOn :: (Int)
                         _hdOnextInh :: ([Vertex])
                         _hdOnextIntravisits :: ([IntraVisit])
                         _hdOnextNewvertices :: ([Vertex])
                         _hdOprev :: ([Vertex])
                         _hdOv :: (Vertex)
                         _hdOvisitDescr :: (Map Vertex ChildVisit)
                         _hdOvssGraph :: (Graph)
                         _tlIcvisits :: ([[CVisit]])
                         _tlIdescr :: (Seq (Vertex,ChildVisit))
                         _tlIedp :: (Seq Edge)
                         _tlIfirstInh :: ([Vertex])
                         _tlIgroups :: ([([Vertex],[Vertex])])
                         _tlIhdIntravisits :: ([IntraVisit])
                         _tlInewedges :: (Seq Edge )
                         _tlInewvertices :: ([Vertex])
                         _tlIprev :: ([Vertex])
                         _tlIsegs :: (CSegments)
                         _tlIv :: (Vertex)
                         _tlOallInters :: (CInterfaceMap)
                         _tlOcons :: ([Constructor])
                         _tlOddp :: (Graph)
                         _tlOfromLhs :: ([Vertex])
                         _tlOinfo :: (Info)
                         _tlOisFirst :: (Bool)
                         _tlOn :: (Int)
                         _tlOprev :: ([Vertex])
                         _tlOv :: (Vertex)
                         _tlOvisitDescr :: (Map Vertex ChildVisit)
                         _tlOvssGraph :: (Graph)
                         ( _hdIcvisits,_hdIdescr,_hdIedp,_hdIgroups,_hdIinh,_hdIintravisits,_hdInewedges,_hdInewvertices,_hdIprev,_hdIseg,_hdIv,_hdIvisitss) =
                             (hd_ (_hdOallInters) (_hdOcons) (_hdOddp) (_hdOfromLhs) (_hdOinfo) (_hdOisFirst) (_hdOn) (_hdOnextInh) (_hdOnextIntravisits) (_hdOnextNewvertices) (_hdOprev) (_hdOv) (_hdOvisitDescr) (_hdOvssGraph))
                         ( _tlIcvisits,_tlIdescr,_tlIedp,_tlIfirstInh,_tlIgroups,_tlIhdIntravisits,_tlInewedges,_tlInewvertices,_tlIprev,_tlIsegs,_tlIv) =
                             (tl_ (_tlOallInters) (_tlOcons) (_tlOddp) (_tlOfromLhs) (_tlOinfo) (_tlOisFirst) (_tlOn) (_tlOprev) (_tlOv) (_tlOvisitDescr) (_tlOvssGraph))
                         -- "InterfacesRules.lag"(line 155, column 12)
                         (_lhsOnewvertices@_) =
                             _hdInewvertices
                         -- "InterfacesRules.lag"(line 154, column 12)
                         (_hdOnextNewvertices@_) =
                             _tlInewvertices
                         -- "InterfacesRules.lag"(line 169, column 11)
                         (_lhsOgroups@_) =
                             _hdIgroups
                         -- "InterfacesRules.lag"(line 190, column 11)
                         (_tlOn@_) =
                             _lhsIn + 1
                         -- "InterfacesRules.lag"(line 295, column 11)
                         (_tlOisFirst@_) =
                             False
                         -- "InterfacesRules.lag"(line 309, column 12)
                         (_lhsOhdIntravisits@_) =
                             _hdIintravisits
                         -- "InterfacesRules.lag"(line 308, column 12)
                         (_hdOnextIntravisits@_) =
                             _tlIhdIntravisits
                         -- "InterfacesRules.lag"(line 333, column 12)
                         (_tlOfromLhs@_) =
                             []
                         -- "InterfacesRules.lag"(line 332, column 12)
                         (_hdOfromLhs@_) =
                             _lhsIfromLhs
                         -- "InterfacesRules.lag"(line 379, column 12)
                         (_lhsOsegs@_) =
                             _hdIseg : _tlIsegs
                         -- "InterfacesRules.lag"(line 424, column 12)
                         (_lhsOfirstInh@_) =
                             _hdIinh
                         -- "InterfacesRules.lag"(line 423, column 12)
                         (_hdOnextInh@_) =
                             _tlIfirstInh
                         -- use rule
                         (_lhsOcvisits@_) =
                             _hdIcvisits : _tlIcvisits
                         -- use rule
                         (_lhsOdescr@_) =
                             _hdIdescr Seq.<> _tlIdescr
                         -- use rule
                         (_lhsOedp@_) =
                             _hdIedp Seq.<> _tlIedp
                         -- use rule
                         (_lhsOnewedges@_) =
                             _hdInewedges Seq.<> _tlInewedges
                         -- copy rule (up)
                         (_lhsOprev@_) =
                             _tlIprev
                         -- copy rule (up)
                         (_lhsOv@_) =
                             _tlIv
                         -- copy rule (down)
                         (_hdOallInters@_) =
                             _lhsIallInters
                         -- copy rule (down)
                         (_hdOcons@_) =
                             _lhsIcons
                         -- copy rule (down)
                         (_hdOddp@_) =
                             _lhsIddp
                         -- copy rule (down)
                         (_hdOinfo@_) =
                             _lhsIinfo
                         -- copy rule (down)
                         (_hdOisFirst@_) =
                             _lhsIisFirst
                         -- copy rule (down)
                         (_hdOn@_) =
                             _lhsIn
                         -- copy rule (down)
                         (_hdOprev@_) =
                             _lhsIprev
                         -- copy rule (down)
                         (_hdOv@_) =
                             _lhsIv
                         -- copy rule (down)
                         (_hdOvisitDescr@_) =
                             _lhsIvisitDescr
                         -- copy rule (down)
                         (_hdOvssGraph@_) =
                             _lhsIvssGraph
                         -- copy rule (down)
                         (_tlOallInters@_) =
                             _lhsIallInters
                         -- copy rule (down)
                         (_tlOcons@_) =
                             _lhsIcons
                         -- copy rule (down)
                         (_tlOddp@_) =
                             _lhsIddp
                         -- copy rule (down)
                         (_tlOinfo@_) =
                             _lhsIinfo
                         -- copy rule (chain)
                         (_tlOprev@_) =
                             _hdIprev
                         -- copy rule (chain)
                         (_tlOv@_) =
                             _hdIv
                         -- copy rule (down)
                         (_tlOvisitDescr@_) =
                             _lhsIvisitDescr
                         -- copy rule (down)
                         (_tlOvssGraph@_) =
                             _lhsIvssGraph
                     in  ( _lhsOcvisits,_lhsOdescr,_lhsOedp,_lhsOfirstInh,_lhsOgroups,_lhsOhdIntravisits,_lhsOnewedges,_lhsOnewvertices,_lhsOprev,_lhsOsegs,_lhsOv)))
sem_Segments_Nil :: (T_Segments)
sem_Segments_Nil  =
    (T_Segments (\ _lhsIallInters
                   _lhsIcons
                   _lhsIddp
                   _lhsIfromLhs
                   _lhsIinfo
                   _lhsIisFirst
                   _lhsIn
                   _lhsIprev
                   _lhsIv
                   _lhsIvisitDescr
                   _lhsIvssGraph ->
                     let _lhsOcvisits :: ([[CVisit]])
                         _lhsOdescr :: (Seq (Vertex,ChildVisit))
                         _lhsOedp :: (Seq Edge)
                         _lhsOfirstInh :: ([Vertex])
                         _lhsOgroups :: ([([Vertex],[Vertex])])
                         _lhsOhdIntravisits :: ([IntraVisit])
                         _lhsOnewedges :: (Seq Edge )
                         _lhsOnewvertices :: ([Vertex])
                         _lhsOprev :: ([Vertex])
                         _lhsOsegs :: (CSegments)
                         _lhsOv :: (Vertex)
                         -- "InterfacesRules.lag"(line 156, column 12)
                         (_lhsOnewvertices@_) =
                             []
                         -- "InterfacesRules.lag"(line 170, column 11)
                         (_lhsOgroups@_) =
                             []
                         -- "InterfacesRules.lag"(line 310, column 10)
                         (_lhsOhdIntravisits@_) =
                             repeat []
                         -- "InterfacesRules.lag"(line 380, column 12)
                         (_lhsOsegs@_) =
                             []
                         -- "InterfacesRules.lag"(line 425, column 11)
                         (_lhsOfirstInh@_) =
                             []
                         -- use rule
                         (_lhsOcvisits@_) =
                             []
                         -- use rule
                         (_lhsOdescr@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOedp@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOnewedges@_) =
                             Seq.empty
                         -- copy rule (chain)
                         (_lhsOprev@_) =
                             _lhsIprev
                         -- copy rule (chain)
                         (_lhsOv@_) =
                             _lhsIv
                     in  ( _lhsOcvisits,_lhsOdescr,_lhsOedp,_lhsOfirstInh,_lhsOgroups,_lhsOhdIntravisits,_lhsOnewedges,_lhsOnewvertices,_lhsOprev,_lhsOsegs,_lhsOv)))


