-- do not edit; automatically generated by UU.AG
module Order where

-- From uuagc
import CommonTypes
import Patterns
import ErrorMessages
import AbstractSyntax
import Code hiding (Type)
import qualified Code
import Expression
import Options
import SequentialComputation
import SequentialTypes
import CodeSyntax
import GrammarInfo
import HsToken(HsTokensRoot(HsTokensRoot))
import HsTokenScanner(lexTokens)
import SemHsTokens(sem_HsTokensRoot,wrap_HsTokensRoot, Syn_HsTokensRoot(..),Inh_HsTokensRoot(..))

-- From uulib
import qualified UU.DData.Map as Map
import qualified UU.DData.Seq as Seq
import qualified UU.DData.Set as Set
import UU.DData.Map(Map) 
import UU.DData.Set(Set) 
import UU.DData.Seq(Seq, (<>)) 
import UU.Util.Utils

-- From haskell libraries
import Control.Monad(liftM)
import qualified Data.Array as Array
import Data.Array((!),bounds,inRange)
import Data.Graph
import Data.List(elemIndex,partition,sort,mapAccumL,find,nubBy)
import qualified Data.Tree as Tree
import Maybe

-- Patterns.ag imports
import UU.Scanner.Position(Pos)
import CommonTypes (Constructor,Name)

import UU.Scanner.Position(Pos)

-- AbstractSyntax.ag imports
import UU.DData.Set(Set)
import Patterns    (Pattern(..),Patterns)
import Expression  (Expression(..))
import CommonTypes

getNtName :: Type -> Nonterminal
getNtName (NT nt) = nt
getNtName _       = nullIdent

data AltAttr = AltAttr Name Name Bool 
               deriving (Eq, Ord)

swap (a,b) = (b,a)

showPath :: Table CRule -> [Vertex] -> [String]
showPath ruleTable path
  =  let  look a | inRange (bounds ruleTable) a = [showOrigin (ruleTable ! a)]
                 | otherwise = []
          showOrigin cr  | getHasCode cr && getName (getAttr cr) /= "self" = prettyCRule cr ++ " (" ++ show (getPos (getAttr cr)) ++ ")"
                         | otherwise = prettyCRule cr
     in concatMap look path

loclocCycleErr :: Table CRule -> Bool -> (Vertex,[Vertex]) -> Error
loclocCycleErr ruleTable o_visit (s,path)
  =  let cr = ruleTable ! s
         attr = getAttr cr
         nt = getLhsNt cr
         con = getCon cr
     in LocLocCirc nt con attr o_visit (showPath ruleTable path)

directCycleErr :: Table NTAttr -> Table CRule -> Bool -> (Edge,[Vertex]) -> Error
directCycleErr attrTable ruleTable o_visit ((v1,v2), cp)
  = let (NTASyn nt a1 _) = attrTable ! v1
        (NTAInh _  a2 _) = attrTable ! v2
        path = showPath ruleTable cp
    in DirectCirc nt a2 a1 o_visit path

inducedCycleErr :: Table NTAttr -> CInterfaceMap -> Edge -> Error
inducedCycleErr attrTable cim (v1,v2)
  = let (NTASyn nt a1 _) = attrTable ! v1
        (NTAInh _  a2 _) = attrTable ! v2
        cinter = Map.find nt cim
    in InducedCirc nt a2 a1 cinter
-- Alternative -------------------------------------------------
{-
   inherited attributes:
      allnts               : [Name]
      cVisitsMap           : CVisitsMap
      inh                  : Attributes
      nt                   : Identifier
      o_case               : Bool
      o_cata               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_unbox              : Bool
      o_wantvisit          : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:
      vcount               : Int

   synthesised attributes:
      cAlternative         : CAlternative
      cons                 : [Constructor]
      directDep            : Seq Edge
      errors               : Seq Error
      rules                : Seq (Vertex,CRule)

-}
{-
   local variables for Alternative.Alternative:
      gathAltAttrs
      gathRules
      inhRules
      cVisits
      synnames
      inhnames
      attrs
      allfields

-}
-- semantic domain
newtype T_Alternative = T_Alternative (([Name]) ->
                                       (CVisitsMap) ->
                                       (Attributes) ->
                                       (Identifier) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (String) ->
                                       (Attributes) ->
                                       (Int) ->
                                       ( (CAlternative),([Constructor]),(Seq Edge),(Seq Error),(Seq (Vertex,CRule)),(Int)))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative (_con) (_children) (_rules) (_typeSigs))) =
    (sem_Alternative_Alternative (_con) ((sem_Children (_children))) ((sem_Rules (_rules))) ((sem_TypeSigs (_typeSigs))))
data Inh_Alternative = Inh_Alternative {allnts_Inh_Alternative :: [Name]
                                       ,cVisitsMap_Inh_Alternative :: CVisitsMap
                                       ,inh_Inh_Alternative :: Attributes
                                       ,nt_Inh_Alternative :: Identifier
                                       ,o_case_Inh_Alternative :: Bool
                                       ,o_cata_Inh_Alternative :: Bool
                                       ,o_dovisit_Inh_Alternative :: Bool
                                       ,o_newtypes_Inh_Alternative :: Bool
                                       ,o_rename_Inh_Alternative :: Bool
                                       ,o_sem_Inh_Alternative :: Bool
                                       ,o_sig_Inh_Alternative :: Bool
                                       ,o_unbox_Inh_Alternative :: Bool
                                       ,o_wantvisit_Inh_Alternative :: Bool
                                       ,prefix_Inh_Alternative :: String
                                       ,syn_Inh_Alternative :: Attributes
                                       ,vcount_Inh_Alternative :: Int
                                       }
data Syn_Alternative = Syn_Alternative {cAlternative_Syn_Alternative :: CAlternative,cons_Syn_Alternative :: [Constructor],directDep_Syn_Alternative :: Seq Edge,errors_Syn_Alternative :: Seq Error,rules_Syn_Alternative :: Seq (Vertex,CRule),vcount_Syn_Alternative :: Int}
wrap_Alternative :: (T_Alternative) ->
                    (Inh_Alternative) ->
                    (Syn_Alternative)
wrap_Alternative ((T_Alternative (sem))) ((Inh_Alternative (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_Alternative (s1) (s2) (s3) (s4) (s5) (s6))
sem_Alternative_Alternative :: (Constructor) ->
                               (T_Children) ->
                               (T_Rules) ->
                               (T_TypeSigs) ->
                               (T_Alternative)
sem_Alternative_Alternative (con_) ((T_Children (children_))) ((T_Rules (rules_))) ((T_TypeSigs (typeSigs_))) =
    (T_Alternative (\ _lhsIallnts
                      _lhsIcVisitsMap
                      _lhsIinh
                      _lhsInt
                      _lhsIo_case
                      _lhsIo_cata
                      _lhsIo_dovisit
                      _lhsIo_newtypes
                      _lhsIo_rename
                      _lhsIo_sem
                      _lhsIo_sig
                      _lhsIo_unbox
                      _lhsIo_wantvisit
                      _lhsIprefix
                      _lhsIsyn
                      _lhsIvcount ->
                        let _lhsOcAlternative :: (CAlternative)
                            _lhsOcons :: ([Constructor])
                            _lhsOdirectDep :: (Seq Edge)
                            _lhsOerrors :: (Seq Error)
                            _lhsOrules :: (Seq (Vertex,CRule))
                            _lhsOvcount :: (Int)
                            _childrenIattributes :: ([(Name,Attributes,Attributes)])
                            _childrenIerrors :: (Seq Error)
                            _childrenIfields :: ([(Name,Type)])
                            _childrenIgathAltAttrs :: ([AltAttr])
                            _childrenIgathRules :: (Seq CRule)
                            _childrenIinhs :: (Seq (Name,Attributes))
                            _childrenInts :: (Seq (Name,Nonterminal))
                            _childrenIsinglevisits :: ([CRule])
                            _childrenIterminals :: ([Name])
                            _childrenOallfields :: ([(Name,Type)])
                            _childrenOallnts :: ([Name])
                            _childrenOattrs :: ([(Name,Name)])
                            _childrenOcon :: (Identifier)
                            _childrenOinh :: (Attributes)
                            _childrenOnt :: (Identifier)
                            _childrenOo_unbox :: (Bool)
                            _childrenOsyn :: (Attributes)
                            _rulesIdirectDep :: (Seq Edge)
                            _rulesIerrors :: (Seq Error)
                            _rulesIgathAltAttrs :: ([AltAttr])
                            _rulesIgathRules :: (Seq CRule)
                            _rulesIlocVars :: ([Name])
                            _rulesOallTypeSigs :: (Map Name Type)
                            _rulesOallfields :: ([(Name,Type)])
                            _rulesOallnts :: ([Name])
                            _rulesOaltAttrs :: (Map AltAttr Vertex)
                            _rulesOattrs :: ([(Name,Name)])
                            _rulesOchildInhs :: (Map Name Attributes)
                            _rulesOchildNts :: (Map Name Nonterminal)
                            _rulesOcon :: (Identifier)
                            _rulesOinh :: (Attributes)
                            _rulesOnt :: (Identifier)
                            _rulesOo_case :: (Bool)
                            _rulesOo_cata :: (Bool)
                            _rulesOo_dovisit :: (Bool)
                            _rulesOo_newtypes :: (Bool)
                            _rulesOo_rename :: (Bool)
                            _rulesOo_sem :: (Bool)
                            _rulesOo_sig :: (Bool)
                            _rulesOo_wantvisit :: (Bool)
                            _rulesOprefix :: (String)
                            _rulesOsyn :: (Attributes)
                            _typeSigsItypeSigs :: (Map Name Type)
                            _typeSigsOtypeSigs :: (Map Name Type)
                            ( _childrenIattributes,_childrenIerrors,_childrenIfields,_childrenIgathAltAttrs,_childrenIgathRules,_childrenIinhs,_childrenInts,_childrenIsinglevisits,_childrenIterminals) =
                                (children_ (_childrenOallfields) (_childrenOallnts) (_childrenOattrs) (_childrenOcon) (_childrenOinh) (_childrenOnt) (_childrenOo_unbox) (_childrenOsyn))
                            ( _rulesIdirectDep,_rulesIerrors,_rulesIgathAltAttrs,_rulesIgathRules,_rulesIlocVars) =
                                (rules_ (_rulesOallTypeSigs) (_rulesOallfields) (_rulesOallnts) (_rulesOaltAttrs) (_rulesOattrs) (_rulesOchildInhs) (_rulesOchildNts) (_rulesOcon) (_rulesOinh) (_rulesOnt) (_rulesOo_case) (_rulesOo_cata) (_rulesOo_dovisit) (_rulesOo_newtypes) (_rulesOo_rename) (_rulesOo_sem) (_rulesOo_sig) (_rulesOo_wantvisit) (_rulesOprefix) (_rulesOsyn))
                            ( _typeSigsItypeSigs) =
                                (typeSigs_ (_typeSigsOtypeSigs))
                            -- "Order.ag"(line 59, column 17)
                            (_childrenOcon@_) =
                                con_
                            -- "Order.ag"(line 61, column 17)
                            (_rulesOcon@_) =
                                con_
                            -- "Order.ag"(line 117, column 19)
                            (_gathAltAttrs@_) =
                                [ AltAttr _LHS inh True | inh <- Map.keys _lhsIinh ]
                                ++ _childrenIgathAltAttrs ++ _rulesIgathAltAttrs
                            -- "Order.ag"(line 132, column 18)
                            (_rulesOaltAttrs@_) =
                                Map.fromList (zip _gathAltAttrs [_lhsIvcount..])
                            -- "Order.ag"(line 146, column 19)
                            (_rulesOchildInhs@_) =
                                Map.fromList (Seq.toList _childrenIinhs)
                            -- "Order.ag"(line 145, column 19)
                            (_rulesOchildNts@_) =
                                Map.fromList (Seq.toList _childrenInts)
                            -- "Order.ag"(line 153, column 19)
                            (_gathRules@_) =
                                _inhRules ++ Seq.toList (_childrenIgathRules Seq.<> _rulesIgathRules)
                            -- "Order.ag"(line 152, column 19)
                            (_inhRules@_) =
                                [ cRuleLhsInh inh _lhsInt con_ tp | (inh,tp) <- Map.assocs _lhsIinh ]
                            -- "Order.ag"(line 177, column 19)
                            (_lhsOvcount@_) =
                                _lhsIvcount + length _gathRules
                            -- "Order.ag"(line 176, column 19)
                            (_lhsOrules@_) =
                                Seq.fromList (zip [_lhsIvcount..] _gathRules)
                            -- "Order.ag"(line 251, column 19)
                            (_lhsOcons@_) =
                                [con_]
                            -- "Order.ag"(line 258, column 17)
                            (_typeSigsOtypeSigs@_) =
                                Map.empty
                            -- "Order.ag"(line 264, column 18)
                            (_rulesOallTypeSigs@_) =
                                _typeSigsItypeSigs
                            -- "Order.ag"(line 319, column 18)
                            (_cVisits@_) =
                                if  _lhsIo_dovisit
                                    then Map.find con_ (Map.find _lhsInt _lhsIcVisitsMap)
                                    else  let  vss = nubBy eqCRuleDefines _gathRules ++ _childrenIsinglevisits
                                          in  [CVisit _lhsIinh _lhsIsyn vss [] False]
                            -- "Order.ag"(line 343, column 19)
                            (_lhsOcAlternative@_) =
                                CAlternative con_ _cVisits _childrenIfields _childrenIterminals
                            -- "Order.ag"(line 365, column 17)
                            (_synnames@_) =
                                Map.keys _lhsIsyn
                            -- "Order.ag"(line 365, column 17)
                            (_inhnames@_) =
                                Map.keys _lhsIinh
                            -- "Order.ag"(line 365, column 17)
                            (_attrs@_) =
                                map ((,) _LOC) _rulesIlocVars ++
                                map ((,) _LHS) _inhnames ++
                                concat [map ((,) nm) (Map.keys as) | (nm,_,as) <- _childrenIattributes]
                            -- "Order.ag"(line 365, column 17)
                            (_allfields@_) =
                                _childrenIfields
                            -- use rule
                            (_lhsOdirectDep@_) =
                                _rulesIdirectDep
                            -- use rule
                            (_lhsOerrors@_) =
                                _childrenIerrors Seq.<> _rulesIerrors
                            -- copy rule (from local)
                            (_childrenOallfields@_) =
                                _allfields
                            -- copy rule (down)
                            (_childrenOallnts@_) =
                                _lhsIallnts
                            -- copy rule (from local)
                            (_childrenOattrs@_) =
                                _attrs
                            -- copy rule (down)
                            (_childrenOinh@_) =
                                _lhsIinh
                            -- copy rule (down)
                            (_childrenOnt@_) =
                                _lhsInt
                            -- copy rule (down)
                            (_childrenOo_unbox@_) =
                                _lhsIo_unbox
                            -- copy rule (down)
                            (_childrenOsyn@_) =
                                _lhsIsyn
                            -- copy rule (from local)
                            (_rulesOallfields@_) =
                                _allfields
                            -- copy rule (down)
                            (_rulesOallnts@_) =
                                _lhsIallnts
                            -- copy rule (from local)
                            (_rulesOattrs@_) =
                                _attrs
                            -- copy rule (down)
                            (_rulesOinh@_) =
                                _lhsIinh
                            -- copy rule (down)
                            (_rulesOnt@_) =
                                _lhsInt
                            -- copy rule (down)
                            (_rulesOo_case@_) =
                                _lhsIo_case
                            -- copy rule (down)
                            (_rulesOo_cata@_) =
                                _lhsIo_cata
                            -- copy rule (down)
                            (_rulesOo_dovisit@_) =
                                _lhsIo_dovisit
                            -- copy rule (down)
                            (_rulesOo_newtypes@_) =
                                _lhsIo_newtypes
                            -- copy rule (down)
                            (_rulesOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_rulesOo_sem@_) =
                                _lhsIo_sem
                            -- copy rule (down)
                            (_rulesOo_sig@_) =
                                _lhsIo_sig
                            -- copy rule (down)
                            (_rulesOo_wantvisit@_) =
                                _lhsIo_wantvisit
                            -- copy rule (down)
                            (_rulesOprefix@_) =
                                _lhsIprefix
                            -- copy rule (down)
                            (_rulesOsyn@_) =
                                _lhsIsyn
                        in  ( _lhsOcAlternative,_lhsOcons,_lhsOdirectDep,_lhsOerrors,_lhsOrules,_lhsOvcount)))
-- Alternatives ------------------------------------------------
{-
   inherited attributes:
      allnts               : [Name]
      cVisitsMap           : CVisitsMap
      inh                  : Attributes
      nt                   : Identifier
      o_case               : Bool
      o_cata               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_unbox              : Bool
      o_wantvisit          : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:
      vcount               : Int

   synthesised attributes:
      cAlternatives        : CAlternatives
      cons                 : [Constructor]
      directDep            : Seq Edge
      errors               : Seq Error
      rules                : Seq (Vertex,CRule)

-}
{-
   local variables for Alternatives.Cons:

-}
{-
   local variables for Alternatives.Nil:

-}
-- semantic domain
newtype T_Alternatives = T_Alternatives (([Name]) ->
                                         (CVisitsMap) ->
                                         (Attributes) ->
                                         (Identifier) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (Bool) ->
                                         (String) ->
                                         (Attributes) ->
                                         (Int) ->
                                         ( (CAlternatives),([Constructor]),(Seq Edge),(Seq Error),(Seq (Vertex,CRule)),(Int)))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (Prelude.foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((Prelude.map sem_Alternative list)))
data Inh_Alternatives = Inh_Alternatives {allnts_Inh_Alternatives :: [Name]
                                         ,cVisitsMap_Inh_Alternatives :: CVisitsMap
                                         ,inh_Inh_Alternatives :: Attributes
                                         ,nt_Inh_Alternatives :: Identifier
                                         ,o_case_Inh_Alternatives :: Bool
                                         ,o_cata_Inh_Alternatives :: Bool
                                         ,o_dovisit_Inh_Alternatives :: Bool
                                         ,o_newtypes_Inh_Alternatives :: Bool
                                         ,o_rename_Inh_Alternatives :: Bool
                                         ,o_sem_Inh_Alternatives :: Bool
                                         ,o_sig_Inh_Alternatives :: Bool
                                         ,o_unbox_Inh_Alternatives :: Bool
                                         ,o_wantvisit_Inh_Alternatives :: Bool
                                         ,prefix_Inh_Alternatives :: String
                                         ,syn_Inh_Alternatives :: Attributes
                                         ,vcount_Inh_Alternatives :: Int
                                         }
data Syn_Alternatives = Syn_Alternatives {cAlternatives_Syn_Alternatives :: CAlternatives,cons_Syn_Alternatives :: [Constructor],directDep_Syn_Alternatives :: Seq Edge,errors_Syn_Alternatives :: Seq Error,rules_Syn_Alternatives :: Seq (Vertex,CRule),vcount_Syn_Alternatives :: Int}
wrap_Alternatives :: (T_Alternatives) ->
                     (Inh_Alternatives) ->
                     (Syn_Alternatives)
wrap_Alternatives ((T_Alternatives (sem))) ((Inh_Alternatives (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_Alternatives (s1) (s2) (s3) (s4) (s5) (s6))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons ((T_Alternative (hd_))) ((T_Alternatives (tl_))) =
    (T_Alternatives (\ _lhsIallnts
                       _lhsIcVisitsMap
                       _lhsIinh
                       _lhsInt
                       _lhsIo_case
                       _lhsIo_cata
                       _lhsIo_dovisit
                       _lhsIo_newtypes
                       _lhsIo_rename
                       _lhsIo_sem
                       _lhsIo_sig
                       _lhsIo_unbox
                       _lhsIo_wantvisit
                       _lhsIprefix
                       _lhsIsyn
                       _lhsIvcount ->
                         let _lhsOcAlternatives :: (CAlternatives)
                             _lhsOcons :: ([Constructor])
                             _lhsOdirectDep :: (Seq Edge)
                             _lhsOerrors :: (Seq Error)
                             _lhsOrules :: (Seq (Vertex,CRule))
                             _lhsOvcount :: (Int)
                             _hdIcAlternative :: (CAlternative)
                             _hdIcons :: ([Constructor])
                             _hdIdirectDep :: (Seq Edge)
                             _hdIerrors :: (Seq Error)
                             _hdIrules :: (Seq (Vertex,CRule))
                             _hdIvcount :: (Int)
                             _hdOallnts :: ([Name])
                             _hdOcVisitsMap :: (CVisitsMap)
                             _hdOinh :: (Attributes)
                             _hdOnt :: (Identifier)
                             _hdOo_case :: (Bool)
                             _hdOo_cata :: (Bool)
                             _hdOo_dovisit :: (Bool)
                             _hdOo_newtypes :: (Bool)
                             _hdOo_rename :: (Bool)
                             _hdOo_sem :: (Bool)
                             _hdOo_sig :: (Bool)
                             _hdOo_unbox :: (Bool)
                             _hdOo_wantvisit :: (Bool)
                             _hdOprefix :: (String)
                             _hdOsyn :: (Attributes)
                             _hdOvcount :: (Int)
                             _tlIcAlternatives :: (CAlternatives)
                             _tlIcons :: ([Constructor])
                             _tlIdirectDep :: (Seq Edge)
                             _tlIerrors :: (Seq Error)
                             _tlIrules :: (Seq (Vertex,CRule))
                             _tlIvcount :: (Int)
                             _tlOallnts :: ([Name])
                             _tlOcVisitsMap :: (CVisitsMap)
                             _tlOinh :: (Attributes)
                             _tlOnt :: (Identifier)
                             _tlOo_case :: (Bool)
                             _tlOo_cata :: (Bool)
                             _tlOo_dovisit :: (Bool)
                             _tlOo_newtypes :: (Bool)
                             _tlOo_rename :: (Bool)
                             _tlOo_sem :: (Bool)
                             _tlOo_sig :: (Bool)
                             _tlOo_unbox :: (Bool)
                             _tlOo_wantvisit :: (Bool)
                             _tlOprefix :: (String)
                             _tlOsyn :: (Attributes)
                             _tlOvcount :: (Int)
                             ( _hdIcAlternative,_hdIcons,_hdIdirectDep,_hdIerrors,_hdIrules,_hdIvcount) =
                                 (hd_ (_hdOallnts) (_hdOcVisitsMap) (_hdOinh) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_dovisit) (_hdOo_newtypes) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_unbox) (_hdOo_wantvisit) (_hdOprefix) (_hdOsyn) (_hdOvcount))
                             ( _tlIcAlternatives,_tlIcons,_tlIdirectDep,_tlIerrors,_tlIrules,_tlIvcount) =
                                 (tl_ (_tlOallnts) (_tlOcVisitsMap) (_tlOinh) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_dovisit) (_tlOo_newtypes) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_unbox) (_tlOo_wantvisit) (_tlOprefix) (_tlOsyn) (_tlOvcount))
                             -- "Order.ag"(line 340, column 12)
                             (_lhsOcAlternatives@_) =
                                 _hdIcAlternative : _tlIcAlternatives
                             -- use rule
                             (_lhsOcons@_) =
                                 _hdIcons ++ _tlIcons
                             -- use rule
                             (_lhsOdirectDep@_) =
                                 _hdIdirectDep Seq.<> _tlIdirectDep
                             -- use rule
                             (_lhsOerrors@_) =
                                 _hdIerrors Seq.<> _tlIerrors
                             -- use rule
                             (_lhsOrules@_) =
                                 _hdIrules Seq.<> _tlIrules
                             -- copy rule (up)
                             (_lhsOvcount@_) =
                                 _tlIvcount
                             -- copy rule (down)
                             (_hdOallnts@_) =
                                 _lhsIallnts
                             -- copy rule (down)
                             (_hdOcVisitsMap@_) =
                                 _lhsIcVisitsMap
                             -- copy rule (down)
                             (_hdOinh@_) =
                                 _lhsIinh
                             -- copy rule (down)
                             (_hdOnt@_) =
                                 _lhsInt
                             -- copy rule (down)
                             (_hdOo_case@_) =
                                 _lhsIo_case
                             -- copy rule (down)
                             (_hdOo_cata@_) =
                                 _lhsIo_cata
                             -- copy rule (down)
                             (_hdOo_dovisit@_) =
                                 _lhsIo_dovisit
                             -- copy rule (down)
                             (_hdOo_newtypes@_) =
                                 _lhsIo_newtypes
                             -- copy rule (down)
                             (_hdOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_hdOo_sem@_) =
                                 _lhsIo_sem
                             -- copy rule (down)
                             (_hdOo_sig@_) =
                                 _lhsIo_sig
                             -- copy rule (down)
                             (_hdOo_unbox@_) =
                                 _lhsIo_unbox
                             -- copy rule (down)
                             (_hdOo_wantvisit@_) =
                                 _lhsIo_wantvisit
                             -- copy rule (down)
                             (_hdOprefix@_) =
                                 _lhsIprefix
                             -- copy rule (down)
                             (_hdOsyn@_) =
                                 _lhsIsyn
                             -- copy rule (down)
                             (_hdOvcount@_) =
                                 _lhsIvcount
                             -- copy rule (down)
                             (_tlOallnts@_) =
                                 _lhsIallnts
                             -- copy rule (down)
                             (_tlOcVisitsMap@_) =
                                 _lhsIcVisitsMap
                             -- copy rule (down)
                             (_tlOinh@_) =
                                 _lhsIinh
                             -- copy rule (down)
                             (_tlOnt@_) =
                                 _lhsInt
                             -- copy rule (down)
                             (_tlOo_case@_) =
                                 _lhsIo_case
                             -- copy rule (down)
                             (_tlOo_cata@_) =
                                 _lhsIo_cata
                             -- copy rule (down)
                             (_tlOo_dovisit@_) =
                                 _lhsIo_dovisit
                             -- copy rule (down)
                             (_tlOo_newtypes@_) =
                                 _lhsIo_newtypes
                             -- copy rule (down)
                             (_tlOo_rename@_) =
                                 _lhsIo_rename
                             -- copy rule (down)
                             (_tlOo_sem@_) =
                                 _lhsIo_sem
                             -- copy rule (down)
                             (_tlOo_sig@_) =
                                 _lhsIo_sig
                             -- copy rule (down)
                             (_tlOo_unbox@_) =
                                 _lhsIo_unbox
                             -- copy rule (down)
                             (_tlOo_wantvisit@_) =
                                 _lhsIo_wantvisit
                             -- copy rule (down)
                             (_tlOprefix@_) =
                                 _lhsIprefix
                             -- copy rule (down)
                             (_tlOsyn@_) =
                                 _lhsIsyn
                             -- copy rule (chain)
                             (_tlOvcount@_) =
                                 _hdIvcount
                         in  ( _lhsOcAlternatives,_lhsOcons,_lhsOdirectDep,_lhsOerrors,_lhsOrules,_lhsOvcount)))
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    (T_Alternatives (\ _lhsIallnts
                       _lhsIcVisitsMap
                       _lhsIinh
                       _lhsInt
                       _lhsIo_case
                       _lhsIo_cata
                       _lhsIo_dovisit
                       _lhsIo_newtypes
                       _lhsIo_rename
                       _lhsIo_sem
                       _lhsIo_sig
                       _lhsIo_unbox
                       _lhsIo_wantvisit
                       _lhsIprefix
                       _lhsIsyn
                       _lhsIvcount ->
                         let _lhsOcAlternatives :: (CAlternatives)
                             _lhsOcons :: ([Constructor])
                             _lhsOdirectDep :: (Seq Edge)
                             _lhsOerrors :: (Seq Error)
                             _lhsOrules :: (Seq (Vertex,CRule))
                             _lhsOvcount :: (Int)
                             -- "Order.ag"(line 341, column 12)
                             (_lhsOcAlternatives@_) =
                                 []
                             -- use rule
                             (_lhsOcons@_) =
                                 []
                             -- use rule
                             (_lhsOdirectDep@_) =
                                 Seq.empty
                             -- use rule
                             (_lhsOerrors@_) =
                                 Seq.empty
                             -- use rule
                             (_lhsOrules@_) =
                                 Seq.empty
                             -- copy rule (chain)
                             (_lhsOvcount@_) =
                                 _lhsIvcount
                         in  ( _lhsOcAlternatives,_lhsOcons,_lhsOdirectDep,_lhsOerrors,_lhsOrules,_lhsOvcount)))
-- Child -------------------------------------------------------
{-
   inherited attributes:
      allfields            : [(Name,Type)]
      allnts               : [Name]
      attrs                : [(Name,Name)]
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      o_unbox              : Bool
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      attributes           : [(Name,Attributes,Attributes)]
      errors               : Seq Error
      field                : (Name,Type)
      gathAltAttrs         : [AltAttr]
      gathRules            : Seq CRule
      inhs                 : Seq (Name,Attributes)
      nts                  : Seq (Name,Nonterminal)
      singlevisits         : [CRule]
      terminals            : [Name]

-}
{-
   local variables for Child.Child:
      maptolocal
      gathRules

-}
-- semantic domain
newtype T_Child = T_Child (([(Name,Type)]) ->
                           ([Name]) ->
                           ([(Name,Name)]) ->
                           (Identifier) ->
                           (Attributes) ->
                           (Identifier) ->
                           (Bool) ->
                           (Attributes) ->
                           ( ([(Name,Attributes,Attributes)]),(Seq Error),((Name,Type)),([AltAttr]),(Seq CRule),(Seq (Name,Attributes)),(Seq (Name,Nonterminal)),([CRule]),([Name])))
-- cata
sem_Child :: (Child) ->
             (T_Child)
sem_Child ((Child (_name) (_tp) (_inh) (_syn))) =
    (sem_Child_Child (_name) (_tp) (_inh) (_syn))
data Inh_Child = Inh_Child {allfields_Inh_Child :: [(Name,Type)],allnts_Inh_Child :: [Name],attrs_Inh_Child :: [(Name,Name)],con_Inh_Child :: Identifier,inh_Inh_Child :: Attributes,nt_Inh_Child :: Identifier,o_unbox_Inh_Child :: Bool,syn_Inh_Child :: Attributes}
data Syn_Child = Syn_Child {attributes_Syn_Child :: [(Name,Attributes,Attributes)],errors_Syn_Child :: Seq Error,field_Syn_Child :: (Name,Type),gathAltAttrs_Syn_Child :: [AltAttr],gathRules_Syn_Child :: Seq CRule,inhs_Syn_Child :: Seq (Name,Attributes),nts_Syn_Child :: Seq (Name,Nonterminal),singlevisits_Syn_Child :: [CRule],terminals_Syn_Child :: [Name]}
wrap_Child :: (T_Child) ->
              (Inh_Child) ->
              (Syn_Child)
wrap_Child ((T_Child (sem))) ((Inh_Child (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))
    in  (Syn_Child (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9))
sem_Child_Child :: (Name) ->
                   (Type) ->
                   (Attributes) ->
                   (Attributes) ->
                   (T_Child)
sem_Child_Child (name_) (tp_) (inh_) (syn_) =
    (T_Child (\ _lhsIallfields
                _lhsIallnts
                _lhsIattrs
                _lhsIcon
                _lhsIinh
                _lhsInt
                _lhsIo_unbox
                _lhsIsyn ->
                  let _lhsOattributes :: ([(Name,Attributes,Attributes)])
                      _lhsOerrors :: (Seq Error)
                      _lhsOfield :: ((Name,Type))
                      _lhsOgathAltAttrs :: ([AltAttr])
                      _lhsOgathRules :: (Seq CRule)
                      _lhsOinhs :: (Seq (Name,Attributes))
                      _lhsOnts :: (Seq (Name,Nonterminal))
                      _lhsOsinglevisits :: ([CRule])
                      _lhsOterminals :: ([Name])
                      -- "Order.ag"(line 124, column 13)
                      (_lhsOgathAltAttrs@_) =
                          if  _maptolocal
                              then [ AltAttr _LOC name_ True ]
                              else [ AltAttr name_ syn True | syn <- Map.keys syn_ ]
                      -- "Order.ag"(line 121, column 13)
                      (_maptolocal@_) =
                          case tp_ of
                            NT nt  -> Map.isEmpty syn_
                            _      -> True
                      -- "Order.ag"(line 140, column 13)
                      (_lhsOinhs@_) =
                          Seq.single (name_,inh_)
                      -- "Order.ag"(line 139, column 13)
                      (_lhsOnts@_) =
                          Seq.single (name_,getNtName tp_)
                      -- "Order.ag"(line 156, column 13)
                      (_gathRules@_) =
                          if  _maptolocal
                              then Seq.single (cRuleTerminal name_ _lhsInt _lhsIcon tp_)
                              else Seq.fromList [ cRuleRhsSyn syn _lhsInt _lhsIcon tp name_ (getNtName tp_) | (syn,tp) <- Map.assocs syn_]
                      -- "Order.ag"(line 327, column 11)
                      (_lhsOsinglevisits@_) =
                          if  _maptolocal
                              then []
                              else [CChildVisit name_ (getNtName tp_) 0 inh_ syn_ True]
                      -- "Order.ag"(line 348, column 11)
                      (_lhsOterminals@_) =
                          if _maptolocal then [name_] else []
                      -- "Order.ag"(line 374, column 11)
                      (_lhsOattributes@_) =
                          [(name_, inh_, syn_)]
                      -- "Order.ag"(line 378, column 11)
                      (_lhsOfield@_) =
                          (name_, tp_)
                      -- use rule
                      (_lhsOerrors@_) =
                          Seq.empty
                      -- use rule
                      (_lhsOgathRules@_) =
                          _gathRules
                  in  ( _lhsOattributes,_lhsOerrors,_lhsOfield,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOinhs,_lhsOnts,_lhsOsinglevisits,_lhsOterminals)))
-- Children ----------------------------------------------------
{-
   inherited attributes:
      allfields            : [(Name,Type)]
      allnts               : [Name]
      attrs                : [(Name,Name)]
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      o_unbox              : Bool
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      attributes           : [(Name,Attributes,Attributes)]
      errors               : Seq Error
      fields               : [(Name,Type)]
      gathAltAttrs         : [AltAttr]
      gathRules            : Seq CRule
      inhs                 : Seq (Name,Attributes)
      nts                  : Seq (Name,Nonterminal)
      singlevisits         : [CRule]
      terminals            : [Name]

-}
{-
   local variables for Children.Cons:

-}
{-
   local variables for Children.Nil:

-}
-- semantic domain
newtype T_Children = T_Children (([(Name,Type)]) ->
                                 ([Name]) ->
                                 ([(Name,Name)]) ->
                                 (Identifier) ->
                                 (Attributes) ->
                                 (Identifier) ->
                                 (Bool) ->
                                 (Attributes) ->
                                 ( ([(Name,Attributes,Attributes)]),(Seq Error),([(Name,Type)]),([AltAttr]),(Seq CRule),(Seq (Name,Attributes)),(Seq (Name,Nonterminal)),([CRule]),([Name])))
-- cata
sem_Children :: (Children) ->
                (T_Children)
sem_Children (list) =
    (Prelude.foldr (sem_Children_Cons) (sem_Children_Nil) ((Prelude.map sem_Child list)))
data Inh_Children = Inh_Children {allfields_Inh_Children :: [(Name,Type)],allnts_Inh_Children :: [Name],attrs_Inh_Children :: [(Name,Name)],con_Inh_Children :: Identifier,inh_Inh_Children :: Attributes,nt_Inh_Children :: Identifier,o_unbox_Inh_Children :: Bool,syn_Inh_Children :: Attributes}
data Syn_Children = Syn_Children {attributes_Syn_Children :: [(Name,Attributes,Attributes)],errors_Syn_Children :: Seq Error,fields_Syn_Children :: [(Name,Type)],gathAltAttrs_Syn_Children :: [AltAttr],gathRules_Syn_Children :: Seq CRule,inhs_Syn_Children :: Seq (Name,Attributes),nts_Syn_Children :: Seq (Name,Nonterminal),singlevisits_Syn_Children :: [CRule],terminals_Syn_Children :: [Name]}
wrap_Children :: (T_Children) ->
                 (Inh_Children) ->
                 (Syn_Children)
wrap_Children ((T_Children (sem))) ((Inh_Children (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8))
    in  (Syn_Children (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9))
sem_Children_Cons :: (T_Child) ->
                     (T_Children) ->
                     (T_Children)
sem_Children_Cons ((T_Child (hd_))) ((T_Children (tl_))) =
    (T_Children (\ _lhsIallfields
                   _lhsIallnts
                   _lhsIattrs
                   _lhsIcon
                   _lhsIinh
                   _lhsInt
                   _lhsIo_unbox
                   _lhsIsyn ->
                     let _lhsOattributes :: ([(Name,Attributes,Attributes)])
                         _lhsOerrors :: (Seq Error)
                         _lhsOfields :: ([(Name,Type)])
                         _lhsOgathAltAttrs :: ([AltAttr])
                         _lhsOgathRules :: (Seq CRule)
                         _lhsOinhs :: (Seq (Name,Attributes))
                         _lhsOnts :: (Seq (Name,Nonterminal))
                         _lhsOsinglevisits :: ([CRule])
                         _lhsOterminals :: ([Name])
                         _hdIattributes :: ([(Name,Attributes,Attributes)])
                         _hdIerrors :: (Seq Error)
                         _hdIfield :: ((Name,Type))
                         _hdIgathAltAttrs :: ([AltAttr])
                         _hdIgathRules :: (Seq CRule)
                         _hdIinhs :: (Seq (Name,Attributes))
                         _hdInts :: (Seq (Name,Nonterminal))
                         _hdIsinglevisits :: ([CRule])
                         _hdIterminals :: ([Name])
                         _hdOallfields :: ([(Name,Type)])
                         _hdOallnts :: ([Name])
                         _hdOattrs :: ([(Name,Name)])
                         _hdOcon :: (Identifier)
                         _hdOinh :: (Attributes)
                         _hdOnt :: (Identifier)
                         _hdOo_unbox :: (Bool)
                         _hdOsyn :: (Attributes)
                         _tlIattributes :: ([(Name,Attributes,Attributes)])
                         _tlIerrors :: (Seq Error)
                         _tlIfields :: ([(Name,Type)])
                         _tlIgathAltAttrs :: ([AltAttr])
                         _tlIgathRules :: (Seq CRule)
                         _tlIinhs :: (Seq (Name,Attributes))
                         _tlInts :: (Seq (Name,Nonterminal))
                         _tlIsinglevisits :: ([CRule])
                         _tlIterminals :: ([Name])
                         _tlOallfields :: ([(Name,Type)])
                         _tlOallnts :: ([Name])
                         _tlOattrs :: ([(Name,Name)])
                         _tlOcon :: (Identifier)
                         _tlOinh :: (Attributes)
                         _tlOnt :: (Identifier)
                         _tlOo_unbox :: (Bool)
                         _tlOsyn :: (Attributes)
                         ( _hdIattributes,_hdIerrors,_hdIfield,_hdIgathAltAttrs,_hdIgathRules,_hdIinhs,_hdInts,_hdIsinglevisits,_hdIterminals) =
                             (hd_ (_hdOallfields) (_hdOallnts) (_hdOattrs) (_hdOcon) (_hdOinh) (_hdOnt) (_hdOo_unbox) (_hdOsyn))
                         ( _tlIattributes,_tlIerrors,_tlIfields,_tlIgathAltAttrs,_tlIgathRules,_tlIinhs,_tlInts,_tlIsinglevisits,_tlIterminals) =
                             (tl_ (_tlOallfields) (_tlOallnts) (_tlOattrs) (_tlOcon) (_tlOinh) (_tlOnt) (_tlOo_unbox) (_tlOsyn))
                         -- "Order.ag"(line 381, column 11)
                         (_lhsOfields@_) =
                             _hdIfield : _tlIfields
                         -- use rule
                         (_lhsOattributes@_) =
                             _hdIattributes ++ _tlIattributes
                         -- use rule
                         (_lhsOerrors@_) =
                             _hdIerrors Seq.<> _tlIerrors
                         -- use rule
                         (_lhsOgathAltAttrs@_) =
                             _hdIgathAltAttrs ++ _tlIgathAltAttrs
                         -- use rule
                         (_lhsOgathRules@_) =
                             _hdIgathRules Seq.<> _tlIgathRules
                         -- use rule
                         (_lhsOinhs@_) =
                             _hdIinhs Seq.<> _tlIinhs
                         -- use rule
                         (_lhsOnts@_) =
                             _hdInts Seq.<> _tlInts
                         -- use rule
                         (_lhsOsinglevisits@_) =
                             _hdIsinglevisits ++ _tlIsinglevisits
                         -- use rule
                         (_lhsOterminals@_) =
                             _hdIterminals ++ _tlIterminals
                         -- copy rule (down)
                         (_hdOallfields@_) =
                             _lhsIallfields
                         -- copy rule (down)
                         (_hdOallnts@_) =
                             _lhsIallnts
                         -- copy rule (down)
                         (_hdOattrs@_) =
                             _lhsIattrs
                         -- copy rule (down)
                         (_hdOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_hdOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_hdOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_hdOo_unbox@_) =
                             _lhsIo_unbox
                         -- copy rule (down)
                         (_hdOsyn@_) =
                             _lhsIsyn
                         -- copy rule (down)
                         (_tlOallfields@_) =
                             _lhsIallfields
                         -- copy rule (down)
                         (_tlOallnts@_) =
                             _lhsIallnts
                         -- copy rule (down)
                         (_tlOattrs@_) =
                             _lhsIattrs
                         -- copy rule (down)
                         (_tlOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_tlOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_tlOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_tlOo_unbox@_) =
                             _lhsIo_unbox
                         -- copy rule (down)
                         (_tlOsyn@_) =
                             _lhsIsyn
                     in  ( _lhsOattributes,_lhsOerrors,_lhsOfields,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOinhs,_lhsOnts,_lhsOsinglevisits,_lhsOterminals)))
sem_Children_Nil :: (T_Children)
sem_Children_Nil  =
    (T_Children (\ _lhsIallfields
                   _lhsIallnts
                   _lhsIattrs
                   _lhsIcon
                   _lhsIinh
                   _lhsInt
                   _lhsIo_unbox
                   _lhsIsyn ->
                     let _lhsOattributes :: ([(Name,Attributes,Attributes)])
                         _lhsOerrors :: (Seq Error)
                         _lhsOfields :: ([(Name,Type)])
                         _lhsOgathAltAttrs :: ([AltAttr])
                         _lhsOgathRules :: (Seq CRule)
                         _lhsOinhs :: (Seq (Name,Attributes))
                         _lhsOnts :: (Seq (Name,Nonterminal))
                         _lhsOsinglevisits :: ([CRule])
                         _lhsOterminals :: ([Name])
                         -- "Order.ag"(line 382, column 11)
                         (_lhsOfields@_) =
                             []
                         -- use rule
                         (_lhsOattributes@_) =
                             []
                         -- use rule
                         (_lhsOerrors@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOgathAltAttrs@_) =
                             []
                         -- use rule
                         (_lhsOgathRules@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOinhs@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOnts@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOsinglevisits@_) =
                             []
                         -- use rule
                         (_lhsOterminals@_) =
                             []
                     in  ( _lhsOattributes,_lhsOerrors,_lhsOfields,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOinhs,_lhsOnts,_lhsOsinglevisits,_lhsOterminals)))
-- Expression --------------------------------------------------
{-
   inherited attributes:
      allfields            : [(Name,Type)]
      allnts               : [Name]
      attrs                : [(Name,Name)]
      con                  : Name
      nt                   : Name

   chained attributes:

   synthesised attributes:
      copy                 : SELF
      errors               : Seq Error
      textLines            : [String]
      usedAttrs            : [(Name,Name)]
      usedFields           : [Name]
      usedLocals           : [Name]

-}
{-
   local variables for Expression.Expression:
      errors
      textLines
      usedAttrs
      usedLocals
      usedFields
      copy

-}
-- semantic domain
newtype T_Expression = T_Expression (([(Name,Type)]) ->
                                     ([Name]) ->
                                     ([(Name,Name)]) ->
                                     (Name) ->
                                     (Name) ->
                                     ( (Expression),(Seq Error),([String]),([(Name,Name)]),([Name]),([Name])))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression (_pos) (_txt))) =
    (sem_Expression_Expression (_pos) (_txt))
data Inh_Expression = Inh_Expression {allfields_Inh_Expression :: [(Name,Type)],allnts_Inh_Expression :: [Name],attrs_Inh_Expression :: [(Name,Name)],con_Inh_Expression :: Name,nt_Inh_Expression :: Name}
data Syn_Expression = Syn_Expression {copy_Syn_Expression :: Expression,errors_Syn_Expression :: Seq Error,textLines_Syn_Expression :: [String],usedAttrs_Syn_Expression :: [(Name,Name)],usedFields_Syn_Expression :: [Name],usedLocals_Syn_Expression :: [Name]}
wrap_Expression :: (T_Expression) ->
                   (Inh_Expression) ->
                   (Syn_Expression)
wrap_Expression ((T_Expression (sem))) ((Inh_Expression (i1) (i2) (i3) (i4) (i5))) =
    let ( s1,s2,s3,s4,s5,s6) =
            (sem (i1) (i2) (i3) (i4) (i5))
    in  (Syn_Expression (s1) (s2) (s3) (s4) (s5) (s6))
sem_Expression_Expression :: (Pos) ->
                             (String) ->
                             (T_Expression)
sem_Expression_Expression (pos_) (txt_) =
    (T_Expression (\ _lhsIallfields
                     _lhsIallnts
                     _lhsIattrs
                     _lhsIcon
                     _lhsInt ->
                       let _lhsOcopy :: (Expression)
                           _lhsOerrors :: (Seq Error)
                           _lhsOtextLines :: ([String])
                           _lhsOusedAttrs :: ([(Name,Name)])
                           _lhsOusedFields :: ([Name])
                           _lhsOusedLocals :: ([Name])
                           -- "Order.ag"(line 206, column 21)
                           ((_errors@_,_textLines@_,_usedAttrs@_,_usedLocals@_,_usedFields@_)) =
                               let inherited = Inh_HsTokensRoot
                                               { attrs_Inh_HsTokensRoot   = _lhsIattrs
                                               , con_Inh_HsTokensRoot     = _lhsIcon
                                               , allfields_Inh_HsTokensRoot  = _lhsIallfields
                                               , allnts_Inh_HsTokensRoot  = _lhsIallnts
                                               , nt_Inh_HsTokensRoot      = _lhsInt
                                               }
                                   synthesized = wrap_HsTokensRoot (sem_HsTokensRoot (HsTokensRoot $ lexTokens pos_ txt_)) inherited
                               in case synthesized of
                                    Syn_HsTokensRoot
                                     { errors_Syn_HsTokensRoot     = errors
                                     , textLines_Syn_HsTokensRoot  = textLines
                                     , usedAttrs_Syn_HsTokensRoot  = usedAttrs
                                     , usedLocals_Syn_HsTokensRoot = usedLocals
                                     , usedFields_Syn_HsTokensRoot = usedFields
                                     }  -> (errors,textLines,usedAttrs,usedLocals,usedFields)
                           -- self rule
                           (_copy@_) =
                               Expression pos_ txt_
                           -- self rule
                           (_lhsOcopy@_) =
                               _copy
                           -- copy rule (from local)
                           (_lhsOerrors@_) =
                               _errors
                           -- copy rule (from local)
                           (_lhsOtextLines@_) =
                               _textLines
                           -- copy rule (from local)
                           (_lhsOusedAttrs@_) =
                               _usedAttrs
                           -- copy rule (from local)
                           (_lhsOusedFields@_) =
                               _usedFields
                           -- copy rule (from local)
                           (_lhsOusedLocals@_) =
                               _usedLocals
                       in  ( _lhsOcopy,_lhsOerrors,_lhsOtextLines,_lhsOusedAttrs,_lhsOusedFields,_lhsOusedLocals)))
-- Grammar -----------------------------------------------------
{-
   inherited attributes:
      options              : Options

   chained attributes:

   synthesised attributes:
      errors               : Seq Error
      output               : CGrammar

-}
{-
   local variables for Grammar.Grammar:
      cInterfaceMap
      cVisitsMap
      cyclesErrors
      info
      directDep
      tdsToTdp
      tdpToTds
      attrVertex
      attrTable
      ruleTable

-}
-- semantic domain
newtype T_Grammar = T_Grammar ((Options) ->
                               ( (Seq Error),(CGrammar)))
-- cata
sem_Grammar :: (Grammar) ->
               (T_Grammar)
sem_Grammar ((Grammar (_typeSyns) (_useMap) (_derivings) (_wrappers) (_prods))) =
    (sem_Grammar_Grammar (_typeSyns) (_useMap) (_derivings) (_wrappers) ((sem_Productions (_prods))))
data Inh_Grammar = Inh_Grammar {options_Inh_Grammar :: Options}
data Syn_Grammar = Syn_Grammar {errors_Syn_Grammar :: Seq Error,output_Syn_Grammar :: CGrammar}
wrap_Grammar :: (T_Grammar) ->
                (Inh_Grammar) ->
                (Syn_Grammar)
wrap_Grammar ((T_Grammar (sem))) ((Inh_Grammar (i1))) =
    let ( s1,s2) =
            (sem (i1))
    in  (Syn_Grammar (s1) (s2))
sem_Grammar_Grammar :: (TypeSyns) ->
                       (UseMap) ->
                       (Derivings) ->
                       (Set Nonterminal) ->
                       (T_Productions) ->
                       (T_Grammar)
sem_Grammar_Grammar (typeSyns_) (useMap_) (derivings_) (wrappers_) ((T_Productions (prods_))) =
    (T_Grammar (\ _lhsIoptions ->
                    let _lhsOerrors :: (Seq Error)
                        _lhsOoutput :: (CGrammar)
                        _prodsIacount :: (Int)
                        _prodsIaranges :: (Seq (Int,Int,Int))
                        _prodsIcProductions :: (CProductions)
                        _prodsIdirectDep :: (Seq Edge)
                        _prodsIerrors :: (Seq Error)
                        _prodsIntattrs :: (Seq (Vertex,NTAttr))
                        _prodsIprods :: ([(Nonterminal,[Constructor])])
                        _prodsIrules :: (Seq (Vertex,CRule))
                        _prodsIvcount :: (Int)
                        _prodsOacount :: (Int)
                        _prodsOallnts :: ([Name])
                        _prodsOcInterfaceMap :: (CInterfaceMap)
                        _prodsOcVisitsMap :: (CVisitsMap)
                        _prodsOo_case :: (Bool)
                        _prodsOo_cata :: (Bool)
                        _prodsOo_data :: (Bool)
                        _prodsOo_dovisit :: (Bool)
                        _prodsOo_newtypes :: (Bool)
                        _prodsOo_rename :: (Bool)
                        _prodsOo_sem :: (Bool)
                        _prodsOo_sig :: (Bool)
                        _prodsOo_unbox :: (Bool)
                        _prodsOo_wantvisit :: (Bool)
                        _prodsOprefix :: (String)
                        _prodsOvcount :: (Int)
                        ( _prodsIacount,_prodsIaranges,_prodsIcProductions,_prodsIdirectDep,_prodsIerrors,_prodsIntattrs,_prodsIprods,_prodsIrules,_prodsIvcount) =
                            (prods_ (_prodsOacount) (_prodsOallnts) (_prodsOcInterfaceMap) (_prodsOcVisitsMap) (_prodsOo_case) (_prodsOo_cata) (_prodsOo_data) (_prodsOo_dovisit) (_prodsOo_newtypes) (_prodsOo_rename) (_prodsOo_sem) (_prodsOo_sig) (_prodsOo_unbox) (_prodsOo_wantvisit) (_prodsOprefix) (_prodsOvcount))
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOprefix@_) =
                            prefix    _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_case@_) =
                            cases     _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_unbox@_) =
                            unbox     _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_dovisit@_) =
                            visit     _lhsIoptions && null _cyclesErrors
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_wantvisit@_) =
                            visit   _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_newtypes@_) =
                            newtypes  _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_rename@_) =
                            rename    _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_sem@_) =
                            semfuns   _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_sig@_) =
                            typeSigs  _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_data@_) =
                            dataTypes _lhsIoptions
                        -- "Order.ag"(line 89, column 17)
                        (_prodsOo_cata@_) =
                            folds     _lhsIoptions
                        -- "Order.ag"(line 174, column 15)
                        (_prodsOvcount@_) =
                            0
                        -- "Order.ag"(line 232, column 13)
                        (_prodsOacount@_) =
                            0
                        -- "Order.ag"(line 303, column 13)
                        (_lhsOerrors@_) =
                            (if withCycle _lhsIoptions then Seq.fromList _cyclesErrors else Seq.empty)
                            Seq.<> _prodsIerrors
                        -- "Order.ag"(line 291, column 17)
                        ((_cInterfaceMap@_,_cVisitsMap@_,_cyclesErrors@_)) =
                            case computeSequential _info _directDep of
                                         SeqResult    cim cvm -> (cim,cvm,[])
                                         LocLocCycle  errs ->  (error "No interfaces for cyclic AG"
                                                               ,error "No visit sub-sequences for cyclic AG"
                                                               ,map (loclocCycleErr _ruleTable (visit _lhsIoptions)) errs)
                                         DirectCycle  errs ->  (error "No interfaces for cyclic AG"
                                                               ,error "No visit sub-sequences for cyclic AG"
                                                               ,map (directCycleErr _attrTable _ruleTable (visit _lhsIoptions)) errs)
                                         InducedCycle cim errs ->  (cim
                                                                   ,error "No visit sub-sequences"
                                                                   ,map (inducedCycleErr _attrTable cim) errs)
                        -- "Order.ag"(line 279, column 13)
                        (_info@_) =
                            let def [] = -1
                                def (v:vs) = v
                             in Info { tdsToTdp   = Array.array (0,_prodsIacount-1) _tdsToTdp
                                     , tdpToTds   = Array.array (0,_prodsIvcount-1) _tdpToTds
                                     , attrTable  = _attrTable
                                     , ruleTable  = _ruleTable
                                     , lmh        = Seq.toList _prodsIaranges
                                     , prods      = _prodsIprods
                                     , wraps      = wrappers_
                                     , cyclesOnly = not (visit _lhsIoptions)
                                     }
                        -- "Order.ag"(line 278, column 13)
                        (_directDep@_) =
                            Seq.toList _prodsIdirectDep
                        -- "Order.ag"(line 274, column 13)
                        (_tdsToTdp@_) =
                            let  eq (_,v) (_,v') = v == v'
                                 conv ((s,v):svs)  | v == -1 = Nothing
                                                   | otherwise = Just (v,s:map fst svs)
                            in mapMaybe conv (eqClasses eq _tdpToTds)
                        -- "Order.ag"(line 273, column 13)
                        (_tdpToTds@_) =
                            [ (s, maybe (-1) (\v -> Map.find v _attrVertex) (ntattr cr)) | (s,cr) <- Seq.toList _prodsIrules]
                        -- "Order.ag"(line 272, column 13)
                        (_attrVertex@_) =
                            Map.fromList (map swap (Seq.toList _prodsIntattrs))
                        -- "Order.ag"(line 271, column 13)
                        (_attrTable@_) =
                            Array.array (0,_prodsIacount-1) (Seq.toList _prodsIntattrs)
                        -- "Order.ag"(line 270, column 13)
                        (_ruleTable@_) =
                            Array.array (0,_prodsIvcount-1) (Seq.toList _prodsIrules)
                        -- "Order.ag"(line 333, column 15)
                        (_lhsOoutput@_) =
                            CGrammar typeSyns_ derivings_ wrappers_ _prodsIcProductions
                        -- "Order.ag"(line 358, column 13)
                        (_prodsOallnts@_) =
                            map fst (_prodsIprods)
                        -- copy rule (from local)
                        (_prodsOcInterfaceMap@_) =
                            _cInterfaceMap
                        -- copy rule (from local)
                        (_prodsOcVisitsMap@_) =
                            _cVisitsMap
                    in  ( _lhsOerrors,_lhsOoutput)))
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      allTypeSigs          : Map Name Type
      altAttrs             : Map AltAttr Vertex
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      copy                 : SELF
      errors               : Seq Error
      gathAltAttrs         : [AltAttr]
      locVars              : [Name]

-}
{-
   local variables for Pattern.Alias:
      copy

-}
{-
   local variables for Pattern.Constr:
      copy

-}
{-
   local variables for Pattern.Product:
      copy

-}
{-
   local variables for Pattern.Underscore:
      copy

-}
-- semantic domain
newtype T_Pattern = T_Pattern ((Map Name Type) ->
                               (Map AltAttr Vertex) ->
                               (Identifier) ->
                               (Attributes) ->
                               (Identifier) ->
                               (Attributes) ->
                               ( (Pattern),(Seq Error),([AltAttr]),([Name])))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Alias (_field) (_attr) (_pat))) =
    (sem_Pattern_Alias (_field) (_attr) ((sem_Pattern (_pat))))
sem_Pattern ((Constr (_name) (_pats))) =
    (sem_Pattern_Constr (_name) ((sem_Patterns (_pats))))
sem_Pattern ((Product (_pos) (_pats))) =
    (sem_Pattern_Product (_pos) ((sem_Patterns (_pats))))
sem_Pattern ((Underscore (_pos))) =
    (sem_Pattern_Underscore (_pos))
data Inh_Pattern = Inh_Pattern {allTypeSigs_Inh_Pattern :: Map Name Type,altAttrs_Inh_Pattern :: Map AltAttr Vertex,con_Inh_Pattern :: Identifier,inh_Inh_Pattern :: Attributes,nt_Inh_Pattern :: Identifier,syn_Inh_Pattern :: Attributes}
data Syn_Pattern = Syn_Pattern {copy_Syn_Pattern :: Pattern,errors_Syn_Pattern :: Seq Error,gathAltAttrs_Syn_Pattern :: [AltAttr],locVars_Syn_Pattern :: [Name]}
wrap_Pattern :: (T_Pattern) ->
                (Inh_Pattern) ->
                (Syn_Pattern)
wrap_Pattern ((T_Pattern (sem))) ((Inh_Pattern (i1) (i2) (i3) (i4) (i5) (i6))) =
    let ( s1,s2,s3,s4) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6))
    in  (Syn_Pattern (s1) (s2) (s3) (s4))
sem_Pattern_Alias :: (Name) ->
                     (Name) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_Alias (field_) (attr_) ((T_Pattern (pat_))) =
    (T_Pattern (\ _lhsIallTypeSigs
                  _lhsIaltAttrs
                  _lhsIcon
                  _lhsIinh
                  _lhsInt
                  _lhsIsyn ->
                    let _lhsOcopy :: (Pattern)
                        _lhsOerrors :: (Seq Error)
                        _lhsOgathAltAttrs :: ([AltAttr])
                        _lhsOlocVars :: ([Name])
                        _patIcopy :: (Pattern)
                        _patIerrors :: (Seq Error)
                        _patIgathAltAttrs :: ([AltAttr])
                        _patIlocVars :: ([Name])
                        _patOallTypeSigs :: (Map Name Type)
                        _patOaltAttrs :: (Map AltAttr Vertex)
                        _patOcon :: (Identifier)
                        _patOinh :: (Attributes)
                        _patOnt :: (Identifier)
                        _patOsyn :: (Attributes)
                        ( _patIcopy,_patIerrors,_patIgathAltAttrs,_patIlocVars) =
                            (pat_ (_patOallTypeSigs) (_patOaltAttrs) (_patOcon) (_patOinh) (_patOnt) (_patOsyn))
                        -- "Order.ag"(line 128, column 12)
                        (_lhsOgathAltAttrs@_) =
                            [AltAttr field_ attr_ (field_ == _LOC)]
                        -- "Order.ag"(line 387, column 14)
                        (_lhsOlocVars@_) =
                            if field_ == _LOC
                               then [attr_]
                               else []
                        -- use rule
                        (_lhsOerrors@_) =
                            _patIerrors
                        -- self rule
                        (_copy@_) =
                            Alias field_ attr_ _patIcopy
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- copy rule (down)
                        (_patOallTypeSigs@_) =
                            _lhsIallTypeSigs
                        -- copy rule (down)
                        (_patOaltAttrs@_) =
                            _lhsIaltAttrs
                        -- copy rule (down)
                        (_patOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patOinh@_) =
                            _lhsIinh
                        -- copy rule (down)
                        (_patOnt@_) =
                            _lhsInt
                        -- copy rule (down)
                        (_patOsyn@_) =
                            _lhsIsyn
                    in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
sem_Pattern_Constr :: (Constructor) ->
                      (T_Patterns) ->
                      (T_Pattern)
sem_Pattern_Constr (name_) ((T_Patterns (pats_))) =
    (T_Pattern (\ _lhsIallTypeSigs
                  _lhsIaltAttrs
                  _lhsIcon
                  _lhsIinh
                  _lhsInt
                  _lhsIsyn ->
                    let _lhsOcopy :: (Pattern)
                        _lhsOerrors :: (Seq Error)
                        _lhsOgathAltAttrs :: ([AltAttr])
                        _lhsOlocVars :: ([Name])
                        _patsIcopy :: (Patterns)
                        _patsIerrors :: (Seq Error)
                        _patsIgathAltAttrs :: ([AltAttr])
                        _patsIlocVars :: ([Name])
                        _patsOallTypeSigs :: (Map Name Type)
                        _patsOaltAttrs :: (Map AltAttr Vertex)
                        _patsOcon :: (Identifier)
                        _patsOinh :: (Attributes)
                        _patsOnt :: (Identifier)
                        _patsOsyn :: (Attributes)
                        ( _patsIcopy,_patsIerrors,_patsIgathAltAttrs,_patsIlocVars) =
                            (pats_ (_patsOallTypeSigs) (_patsOaltAttrs) (_patsOcon) (_patsOinh) (_patsOnt) (_patsOsyn))
                        -- use rule
                        (_lhsOerrors@_) =
                            _patsIerrors
                        -- use rule
                        (_lhsOgathAltAttrs@_) =
                            _patsIgathAltAttrs
                        -- use rule
                        (_lhsOlocVars@_) =
                            _patsIlocVars
                        -- self rule
                        (_copy@_) =
                            Constr name_ _patsIcopy
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- copy rule (down)
                        (_patsOallTypeSigs@_) =
                            _lhsIallTypeSigs
                        -- copy rule (down)
                        (_patsOaltAttrs@_) =
                            _lhsIaltAttrs
                        -- copy rule (down)
                        (_patsOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patsOinh@_) =
                            _lhsIinh
                        -- copy rule (down)
                        (_patsOnt@_) =
                            _lhsInt
                        -- copy rule (down)
                        (_patsOsyn@_) =
                            _lhsIsyn
                    in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
sem_Pattern_Product :: (Pos) ->
                       (T_Patterns) ->
                       (T_Pattern)
sem_Pattern_Product (pos_) ((T_Patterns (pats_))) =
    (T_Pattern (\ _lhsIallTypeSigs
                  _lhsIaltAttrs
                  _lhsIcon
                  _lhsIinh
                  _lhsInt
                  _lhsIsyn ->
                    let _lhsOcopy :: (Pattern)
                        _lhsOerrors :: (Seq Error)
                        _lhsOgathAltAttrs :: ([AltAttr])
                        _lhsOlocVars :: ([Name])
                        _patsIcopy :: (Patterns)
                        _patsIerrors :: (Seq Error)
                        _patsIgathAltAttrs :: ([AltAttr])
                        _patsIlocVars :: ([Name])
                        _patsOallTypeSigs :: (Map Name Type)
                        _patsOaltAttrs :: (Map AltAttr Vertex)
                        _patsOcon :: (Identifier)
                        _patsOinh :: (Attributes)
                        _patsOnt :: (Identifier)
                        _patsOsyn :: (Attributes)
                        ( _patsIcopy,_patsIerrors,_patsIgathAltAttrs,_patsIlocVars) =
                            (pats_ (_patsOallTypeSigs) (_patsOaltAttrs) (_patsOcon) (_patsOinh) (_patsOnt) (_patsOsyn))
                        -- use rule
                        (_lhsOerrors@_) =
                            _patsIerrors
                        -- use rule
                        (_lhsOgathAltAttrs@_) =
                            _patsIgathAltAttrs
                        -- use rule
                        (_lhsOlocVars@_) =
                            _patsIlocVars
                        -- self rule
                        (_copy@_) =
                            Product pos_ _patsIcopy
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                        -- copy rule (down)
                        (_patsOallTypeSigs@_) =
                            _lhsIallTypeSigs
                        -- copy rule (down)
                        (_patsOaltAttrs@_) =
                            _lhsIaltAttrs
                        -- copy rule (down)
                        (_patsOcon@_) =
                            _lhsIcon
                        -- copy rule (down)
                        (_patsOinh@_) =
                            _lhsIinh
                        -- copy rule (down)
                        (_patsOnt@_) =
                            _lhsInt
                        -- copy rule (down)
                        (_patsOsyn@_) =
                            _lhsIsyn
                    in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
sem_Pattern_Underscore :: (Pos) ->
                          (T_Pattern)
sem_Pattern_Underscore (pos_) =
    (T_Pattern (\ _lhsIallTypeSigs
                  _lhsIaltAttrs
                  _lhsIcon
                  _lhsIinh
                  _lhsInt
                  _lhsIsyn ->
                    let _lhsOcopy :: (Pattern)
                        _lhsOerrors :: (Seq Error)
                        _lhsOgathAltAttrs :: ([AltAttr])
                        _lhsOlocVars :: ([Name])
                        -- use rule
                        (_lhsOerrors@_) =
                            Seq.empty
                        -- use rule
                        (_lhsOgathAltAttrs@_) =
                            []
                        -- use rule
                        (_lhsOlocVars@_) =
                            []
                        -- self rule
                        (_copy@_) =
                            Underscore pos_
                        -- self rule
                        (_lhsOcopy@_) =
                            _copy
                    in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      allTypeSigs          : Map Name Type
      altAttrs             : Map AltAttr Vertex
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      copy                 : SELF
      errors               : Seq Error
      gathAltAttrs         : [AltAttr]
      locVars              : [Name]

-}
{-
   local variables for Patterns.Cons:
      copy

-}
{-
   local variables for Patterns.Nil:
      copy

-}
-- semantic domain
newtype T_Patterns = T_Patterns ((Map Name Type) ->
                                 (Map AltAttr Vertex) ->
                                 (Identifier) ->
                                 (Attributes) ->
                                 (Identifier) ->
                                 (Attributes) ->
                                 ( (Patterns),(Seq Error),([AltAttr]),([Name])))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (Prelude.foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((Prelude.map sem_Pattern list)))
data Inh_Patterns = Inh_Patterns {allTypeSigs_Inh_Patterns :: Map Name Type,altAttrs_Inh_Patterns :: Map AltAttr Vertex,con_Inh_Patterns :: Identifier,inh_Inh_Patterns :: Attributes,nt_Inh_Patterns :: Identifier,syn_Inh_Patterns :: Attributes}
data Syn_Patterns = Syn_Patterns {copy_Syn_Patterns :: Patterns,errors_Syn_Patterns :: Seq Error,gathAltAttrs_Syn_Patterns :: [AltAttr],locVars_Syn_Patterns :: [Name]}
wrap_Patterns :: (T_Patterns) ->
                 (Inh_Patterns) ->
                 (Syn_Patterns)
wrap_Patterns ((T_Patterns (sem))) ((Inh_Patterns (i1) (i2) (i3) (i4) (i5) (i6))) =
    let ( s1,s2,s3,s4) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6))
    in  (Syn_Patterns (s1) (s2) (s3) (s4))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons ((T_Pattern (hd_))) ((T_Patterns (tl_))) =
    (T_Patterns (\ _lhsIallTypeSigs
                   _lhsIaltAttrs
                   _lhsIcon
                   _lhsIinh
                   _lhsInt
                   _lhsIsyn ->
                     let _lhsOcopy :: (Patterns)
                         _lhsOerrors :: (Seq Error)
                         _lhsOgathAltAttrs :: ([AltAttr])
                         _lhsOlocVars :: ([Name])
                         _hdIcopy :: (Pattern)
                         _hdIerrors :: (Seq Error)
                         _hdIgathAltAttrs :: ([AltAttr])
                         _hdIlocVars :: ([Name])
                         _hdOallTypeSigs :: (Map Name Type)
                         _hdOaltAttrs :: (Map AltAttr Vertex)
                         _hdOcon :: (Identifier)
                         _hdOinh :: (Attributes)
                         _hdOnt :: (Identifier)
                         _hdOsyn :: (Attributes)
                         _tlIcopy :: (Patterns)
                         _tlIerrors :: (Seq Error)
                         _tlIgathAltAttrs :: ([AltAttr])
                         _tlIlocVars :: ([Name])
                         _tlOallTypeSigs :: (Map Name Type)
                         _tlOaltAttrs :: (Map AltAttr Vertex)
                         _tlOcon :: (Identifier)
                         _tlOinh :: (Attributes)
                         _tlOnt :: (Identifier)
                         _tlOsyn :: (Attributes)
                         ( _hdIcopy,_hdIerrors,_hdIgathAltAttrs,_hdIlocVars) =
                             (hd_ (_hdOallTypeSigs) (_hdOaltAttrs) (_hdOcon) (_hdOinh) (_hdOnt) (_hdOsyn))
                         ( _tlIcopy,_tlIerrors,_tlIgathAltAttrs,_tlIlocVars) =
                             (tl_ (_tlOallTypeSigs) (_tlOaltAttrs) (_tlOcon) (_tlOinh) (_tlOnt) (_tlOsyn))
                         -- use rule
                         (_lhsOerrors@_) =
                             _hdIerrors Seq.<> _tlIerrors
                         -- use rule
                         (_lhsOgathAltAttrs@_) =
                             _hdIgathAltAttrs ++ _tlIgathAltAttrs
                         -- use rule
                         (_lhsOlocVars@_) =
                             _hdIlocVars ++ _tlIlocVars
                         -- self rule
                         (_copy@_) =
                             (:) _hdIcopy _tlIcopy
                         -- self rule
                         (_lhsOcopy@_) =
                             _copy
                         -- copy rule (down)
                         (_hdOallTypeSigs@_) =
                             _lhsIallTypeSigs
                         -- copy rule (down)
                         (_hdOaltAttrs@_) =
                             _lhsIaltAttrs
                         -- copy rule (down)
                         (_hdOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_hdOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_hdOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_hdOsyn@_) =
                             _lhsIsyn
                         -- copy rule (down)
                         (_tlOallTypeSigs@_) =
                             _lhsIallTypeSigs
                         -- copy rule (down)
                         (_tlOaltAttrs@_) =
                             _lhsIaltAttrs
                         -- copy rule (down)
                         (_tlOcon@_) =
                             _lhsIcon
                         -- copy rule (down)
                         (_tlOinh@_) =
                             _lhsIinh
                         -- copy rule (down)
                         (_tlOnt@_) =
                             _lhsInt
                         -- copy rule (down)
                         (_tlOsyn@_) =
                             _lhsIsyn
                     in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    (T_Patterns (\ _lhsIallTypeSigs
                   _lhsIaltAttrs
                   _lhsIcon
                   _lhsIinh
                   _lhsInt
                   _lhsIsyn ->
                     let _lhsOcopy :: (Patterns)
                         _lhsOerrors :: (Seq Error)
                         _lhsOgathAltAttrs :: ([AltAttr])
                         _lhsOlocVars :: ([Name])
                         -- use rule
                         (_lhsOerrors@_) =
                             Seq.empty
                         -- use rule
                         (_lhsOgathAltAttrs@_) =
                             []
                         -- use rule
                         (_lhsOlocVars@_) =
                             []
                         -- self rule
                         (_copy@_) =
                             []
                         -- self rule
                         (_lhsOcopy@_) =
                             _copy
                     in  ( _lhsOcopy,_lhsOerrors,_lhsOgathAltAttrs,_lhsOlocVars)))
-- Production --------------------------------------------------
{-
   inherited attributes:
      allnts               : [Name]
      cInterfaceMap        : CInterfaceMap
      cVisitsMap           : CVisitsMap
      o_case               : Bool
      o_cata               : Bool
      o_data               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_unbox              : Bool
      o_wantvisit          : Bool
      prefix               : String

   chained attributes:
      acount               : Int
      vcount               : Int

   synthesised attributes:
      aranges              : Seq (Int,Int,Int)
      cProduction          : CProduction
      directDep            : Seq Edge
      errors               : Seq Error
      ntattrs              : Seq (Vertex,NTAttr)
      prods                : [(Nonterminal,[Constructor])]
      rules                : Seq (Vertex,CRule)

-}
{-
   local variables for Production.Production:
      ntattrs
      cInter

-}
-- semantic domain
newtype T_Production = T_Production ((Int) ->
                                     ([Name]) ->
                                     (CInterfaceMap) ->
                                     (CVisitsMap) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (Bool) ->
                                     (String) ->
                                     (Int) ->
                                     ( (Int),(Seq (Int,Int,Int)),(CProduction),(Seq Edge),(Seq Error),(Seq (Vertex,NTAttr)),([(Nonterminal,[Constructor])]),(Seq (Vertex,CRule)),(Int)))
-- cata
sem_Production :: (Production) ->
                  (T_Production)
sem_Production ((Production (_nt) (_inh) (_syn) (_alts))) =
    (sem_Production_Production (_nt) (_inh) (_syn) ((sem_Alternatives (_alts))))
data Inh_Production = Inh_Production {acount_Inh_Production :: Int
                                     ,allnts_Inh_Production :: [Name]
                                     ,cInterfaceMap_Inh_Production :: CInterfaceMap
                                     ,cVisitsMap_Inh_Production :: CVisitsMap
                                     ,o_case_Inh_Production :: Bool
                                     ,o_cata_Inh_Production :: Bool
                                     ,o_data_Inh_Production :: Bool
                                     ,o_dovisit_Inh_Production :: Bool
                                     ,o_newtypes_Inh_Production :: Bool
                                     ,o_rename_Inh_Production :: Bool
                                     ,o_sem_Inh_Production :: Bool
                                     ,o_sig_Inh_Production :: Bool
                                     ,o_unbox_Inh_Production :: Bool
                                     ,o_wantvisit_Inh_Production :: Bool
                                     ,prefix_Inh_Production :: String
                                     ,vcount_Inh_Production :: Int
                                     }
data Syn_Production = Syn_Production {acount_Syn_Production :: Int,aranges_Syn_Production :: Seq (Int,Int,Int),cProduction_Syn_Production :: CProduction,directDep_Syn_Production :: Seq Edge,errors_Syn_Production :: Seq Error,ntattrs_Syn_Production :: Seq (Vertex,NTAttr),prods_Syn_Production :: [(Nonterminal,[Constructor])],rules_Syn_Production :: Seq (Vertex,CRule),vcount_Syn_Production :: Int}
wrap_Production :: (T_Production) ->
                   (Inh_Production) ->
                   (Syn_Production)
wrap_Production ((T_Production (sem))) ((Inh_Production (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_Production (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9))
sem_Production_Production :: (Nonterminal) ->
                             (Attributes) ->
                             (Attributes) ->
                             (T_Alternatives) ->
                             (T_Production)
sem_Production_Production (nt_) (inh_) (syn_) ((T_Alternatives (alts_))) =
    (T_Production (\ _lhsIacount
                     _lhsIallnts
                     _lhsIcInterfaceMap
                     _lhsIcVisitsMap
                     _lhsIo_case
                     _lhsIo_cata
                     _lhsIo_data
                     _lhsIo_dovisit
                     _lhsIo_newtypes
                     _lhsIo_rename
                     _lhsIo_sem
                     _lhsIo_sig
                     _lhsIo_unbox
                     _lhsIo_wantvisit
                     _lhsIprefix
                     _lhsIvcount ->
                       let _lhsOacount :: (Int)
                           _lhsOaranges :: (Seq (Int,Int,Int))
                           _lhsOcProduction :: (CProduction)
                           _lhsOdirectDep :: (Seq Edge)
                           _lhsOerrors :: (Seq Error)
                           _lhsOntattrs :: (Seq (Vertex,NTAttr))
                           _lhsOprods :: ([(Nonterminal,[Constructor])])
                           _lhsOrules :: (Seq (Vertex,CRule))
                           _lhsOvcount :: (Int)
                           _altsIcAlternatives :: (CAlternatives)
                           _altsIcons :: ([Constructor])
                           _altsIdirectDep :: (Seq Edge)
                           _altsIerrors :: (Seq Error)
                           _altsIrules :: (Seq (Vertex,CRule))
                           _altsIvcount :: (Int)
                           _altsOallnts :: ([Name])
                           _altsOcVisitsMap :: (CVisitsMap)
                           _altsOinh :: (Attributes)
                           _altsOnt :: (Identifier)
                           _altsOo_case :: (Bool)
                           _altsOo_cata :: (Bool)
                           _altsOo_dovisit :: (Bool)
                           _altsOo_newtypes :: (Bool)
                           _altsOo_rename :: (Bool)
                           _altsOo_sem :: (Bool)
                           _altsOo_sig :: (Bool)
                           _altsOo_unbox :: (Bool)
                           _altsOo_wantvisit :: (Bool)
                           _altsOprefix :: (String)
                           _altsOsyn :: (Attributes)
                           _altsOvcount :: (Int)
                           ( _altsIcAlternatives,_altsIcons,_altsIdirectDep,_altsIerrors,_altsIrules,_altsIvcount) =
                               (alts_ (_altsOallnts) (_altsOcVisitsMap) (_altsOinh) (_altsOnt) (_altsOo_case) (_altsOo_cata) (_altsOo_dovisit) (_altsOo_newtypes) (_altsOo_rename) (_altsOo_sem) (_altsOo_sig) (_altsOo_unbox) (_altsOo_wantvisit) (_altsOprefix) (_altsOsyn) (_altsOvcount))
                           -- "Order.ag"(line 63, column 16)
                           (_altsOnt@_) =
                               nt_
                           -- "Order.ag"(line 67, column 16)
                           (_altsOsyn@_) =
                               syn_
                           -- "Order.ag"(line 66, column 16)
                           (_altsOinh@_) =
                               inh_
                           -- "Order.ag"(line 239, column 16)
                           (_lhsOaranges@_) =
                               Seq.single
                                 (_lhsIacount
                                 ,_lhsIacount + Map.size inh_
                                 ,_lhsIacount + Map.size syn_ + Map.size inh_ - 1)
                           -- "Order.ag"(line 238, column 16)
                           (_lhsOacount@_) =
                               _lhsIacount + Map.size inh_ + Map.size syn_
                           -- "Order.ag"(line 237, column 16)
                           (_lhsOntattrs@_) =
                               Seq.fromList (zip [_lhsIacount ..] _ntattrs)
                           -- "Order.ag"(line 235, column 16)
                           (_ntattrs@_) =
                               [ NTAInh nt_ inh tp | (inh,tp) <- Map.assocs inh_ ]
                               ++ [NTASyn nt_ syn tp | (syn,tp) <- Map.assocs syn_ ]
                           -- "Order.ag"(line 248, column 18)
                           (_lhsOprods@_) =
                               [(nt_,_altsIcons)]
                           -- "Order.ag"(line 312, column 18)
                           (_cInter@_) =
                               if  _lhsIo_dovisit
                                       then Map.find nt_ _lhsIcInterfaceMap
                                       else CInterface [CSegment inh_ syn_]
                           -- "Order.ag"(line 338, column 18)
                           (_lhsOcProduction@_) =
                               CProduction nt_ inh_ syn_ _altsIcAlternatives _cInter
                           -- use rule
                           (_lhsOdirectDep@_) =
                               _altsIdirectDep
                           -- use rule
                           (_lhsOerrors@_) =
                               _altsIerrors
                           -- use rule
                           (_lhsOrules@_) =
                               _altsIrules
                           -- copy rule (up)
                           (_lhsOvcount@_) =
                               _altsIvcount
                           -- copy rule (down)
                           (_altsOallnts@_) =
                               _lhsIallnts
                           -- copy rule (down)
                           (_altsOcVisitsMap@_) =
                               _lhsIcVisitsMap
                           -- copy rule (down)
                           (_altsOo_case@_) =
                               _lhsIo_case
                           -- copy rule (down)
                           (_altsOo_cata@_) =
                               _lhsIo_cata
                           -- copy rule (down)
                           (_altsOo_dovisit@_) =
                               _lhsIo_dovisit
                           -- copy rule (down)
                           (_altsOo_newtypes@_) =
                               _lhsIo_newtypes
                           -- copy rule (down)
                           (_altsOo_rename@_) =
                               _lhsIo_rename
                           -- copy rule (down)
                           (_altsOo_sem@_) =
                               _lhsIo_sem
                           -- copy rule (down)
                           (_altsOo_sig@_) =
                               _lhsIo_sig
                           -- copy rule (down)
                           (_altsOo_unbox@_) =
                               _lhsIo_unbox
                           -- copy rule (down)
                           (_altsOo_wantvisit@_) =
                               _lhsIo_wantvisit
                           -- copy rule (down)
                           (_altsOprefix@_) =
                               _lhsIprefix
                           -- copy rule (down)
                           (_altsOvcount@_) =
                               _lhsIvcount
                       in  ( _lhsOacount,_lhsOaranges,_lhsOcProduction,_lhsOdirectDep,_lhsOerrors,_lhsOntattrs,_lhsOprods,_lhsOrules,_lhsOvcount)))
-- Productions -------------------------------------------------
{-
   inherited attributes:
      allnts               : [Name]
      cInterfaceMap        : CInterfaceMap
      cVisitsMap           : CVisitsMap
      o_case               : Bool
      o_cata               : Bool
      o_data               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_unbox              : Bool
      o_wantvisit          : Bool
      prefix               : String

   chained attributes:
      acount               : Int
      vcount               : Int

   synthesised attributes:
      aranges              : Seq (Int,Int,Int)
      cProductions         : CProductions
      directDep            : Seq Edge
      errors               : Seq Error
      ntattrs              : Seq (Vertex,NTAttr)
      prods                : [(Nonterminal,[Constructor])]
      rules                : Seq (Vertex,CRule)

-}
{-
   local variables for Productions.Cons:

-}
{-
   local variables for Productions.Nil:

-}
-- semantic domain
newtype T_Productions = T_Productions ((Int) ->
                                       ([Name]) ->
                                       (CInterfaceMap) ->
                                       (CVisitsMap) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (Bool) ->
                                       (String) ->
                                       (Int) ->
                                       ( (Int),(Seq (Int,Int,Int)),(CProductions),(Seq Edge),(Seq Error),(Seq (Vertex,NTAttr)),([(Nonterminal,[Constructor])]),(Seq (Vertex,CRule)),(Int)))
-- cata
sem_Productions :: (Productions) ->
                   (T_Productions)
sem_Productions (list) =
    (Prelude.foldr (sem_Productions_Cons) (sem_Productions_Nil) ((Prelude.map sem_Production list)))
data Inh_Productions = Inh_Productions {acount_Inh_Productions :: Int
                                       ,allnts_Inh_Productions :: [Name]
                                       ,cInterfaceMap_Inh_Productions :: CInterfaceMap
                                       ,cVisitsMap_Inh_Productions :: CVisitsMap
                                       ,o_case_Inh_Productions :: Bool
                                       ,o_cata_Inh_Productions :: Bool
                                       ,o_data_Inh_Productions :: Bool
                                       ,o_dovisit_Inh_Productions :: Bool
                                       ,o_newtypes_Inh_Productions :: Bool
                                       ,o_rename_Inh_Productions :: Bool
                                       ,o_sem_Inh_Productions :: Bool
                                       ,o_sig_Inh_Productions :: Bool
                                       ,o_unbox_Inh_Productions :: Bool
                                       ,o_wantvisit_Inh_Productions :: Bool
                                       ,prefix_Inh_Productions :: String
                                       ,vcount_Inh_Productions :: Int
                                       }
data Syn_Productions = Syn_Productions {acount_Syn_Productions :: Int,aranges_Syn_Productions :: Seq (Int,Int,Int),cProductions_Syn_Productions :: CProductions,directDep_Syn_Productions :: Seq Edge,errors_Syn_Productions :: Seq Error,ntattrs_Syn_Productions :: Seq (Vertex,NTAttr),prods_Syn_Productions :: [(Nonterminal,[Constructor])],rules_Syn_Productions :: Seq (Vertex,CRule),vcount_Syn_Productions :: Int}
wrap_Productions :: (T_Productions) ->
                    (Inh_Productions) ->
                    (Syn_Productions)
wrap_Productions ((T_Productions (sem))) ((Inh_Productions (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))) =
    let ( s1,s2,s3,s4,s5,s6,s7,s8,s9) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16))
    in  (Syn_Productions (s1) (s2) (s3) (s4) (s5) (s6) (s7) (s8) (s9))
sem_Productions_Cons :: (T_Production) ->
                        (T_Productions) ->
                        (T_Productions)
sem_Productions_Cons ((T_Production (hd_))) ((T_Productions (tl_))) =
    (T_Productions (\ _lhsIacount
                      _lhsIallnts
                      _lhsIcInterfaceMap
                      _lhsIcVisitsMap
                      _lhsIo_case
                      _lhsIo_cata
                      _lhsIo_data
                      _lhsIo_dovisit
                      _lhsIo_newtypes
                      _lhsIo_rename
                      _lhsIo_sem
                      _lhsIo_sig
                      _lhsIo_unbox
                      _lhsIo_wantvisit
                      _lhsIprefix
                      _lhsIvcount ->
                        let _lhsOacount :: (Int)
                            _lhsOaranges :: (Seq (Int,Int,Int))
                            _lhsOcProductions :: (CProductions)
                            _lhsOdirectDep :: (Seq Edge)
                            _lhsOerrors :: (Seq Error)
                            _lhsOntattrs :: (Seq (Vertex,NTAttr))
                            _lhsOprods :: ([(Nonterminal,[Constructor])])
                            _lhsOrules :: (Seq (Vertex,CRule))
                            _lhsOvcount :: (Int)
                            _hdIacount :: (Int)
                            _hdIaranges :: (Seq (Int,Int,Int))
                            _hdIcProduction :: (CProduction)
                            _hdIdirectDep :: (Seq Edge)
                            _hdIerrors :: (Seq Error)
                            _hdIntattrs :: (Seq (Vertex,NTAttr))
                            _hdIprods :: ([(Nonterminal,[Constructor])])
                            _hdIrules :: (Seq (Vertex,CRule))
                            _hdIvcount :: (Int)
                            _hdOacount :: (Int)
                            _hdOallnts :: ([Name])
                            _hdOcInterfaceMap :: (CInterfaceMap)
                            _hdOcVisitsMap :: (CVisitsMap)
                            _hdOo_case :: (Bool)
                            _hdOo_cata :: (Bool)
                            _hdOo_data :: (Bool)
                            _hdOo_dovisit :: (Bool)
                            _hdOo_newtypes :: (Bool)
                            _hdOo_rename :: (Bool)
                            _hdOo_sem :: (Bool)
                            _hdOo_sig :: (Bool)
                            _hdOo_unbox :: (Bool)
                            _hdOo_wantvisit :: (Bool)
                            _hdOprefix :: (String)
                            _hdOvcount :: (Int)
                            _tlIacount :: (Int)
                            _tlIaranges :: (Seq (Int,Int,Int))
                            _tlIcProductions :: (CProductions)
                            _tlIdirectDep :: (Seq Edge)
                            _tlIerrors :: (Seq Error)
                            _tlIntattrs :: (Seq (Vertex,NTAttr))
                            _tlIprods :: ([(Nonterminal,[Constructor])])
                            _tlIrules :: (Seq (Vertex,CRule))
                            _tlIvcount :: (Int)
                            _tlOacount :: (Int)
                            _tlOallnts :: ([Name])
                            _tlOcInterfaceMap :: (CInterfaceMap)
                            _tlOcVisitsMap :: (CVisitsMap)
                            _tlOo_case :: (Bool)
                            _tlOo_cata :: (Bool)
                            _tlOo_data :: (Bool)
                            _tlOo_dovisit :: (Bool)
                            _tlOo_newtypes :: (Bool)
                            _tlOo_rename :: (Bool)
                            _tlOo_sem :: (Bool)
                            _tlOo_sig :: (Bool)
                            _tlOo_unbox :: (Bool)
                            _tlOo_wantvisit :: (Bool)
                            _tlOprefix :: (String)
                            _tlOvcount :: (Int)
                            ( _hdIacount,_hdIaranges,_hdIcProduction,_hdIdirectDep,_hdIerrors,_hdIntattrs,_hdIprods,_hdIrules,_hdIvcount) =
                                (hd_ (_hdOacount) (_hdOallnts) (_hdOcInterfaceMap) (_hdOcVisitsMap) (_hdOo_case) (_hdOo_cata) (_hdOo_data) (_hdOo_dovisit) (_hdOo_newtypes) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_unbox) (_hdOo_wantvisit) (_hdOprefix) (_hdOvcount))
                            ( _tlIacount,_tlIaranges,_tlIcProductions,_tlIdirectDep,_tlIerrors,_tlIntattrs,_tlIprods,_tlIrules,_tlIvcount) =
                                (tl_ (_tlOacount) (_tlOallnts) (_tlOcInterfaceMap) (_tlOcVisitsMap) (_tlOo_case) (_tlOo_cata) (_tlOo_data) (_tlOo_dovisit) (_tlOo_newtypes) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_unbox) (_tlOo_wantvisit) (_tlOprefix) (_tlOvcount))
                            -- "Order.ag"(line 335, column 12)
                            (_lhsOcProductions@_) =
                                _hdIcProduction : _tlIcProductions
                            -- use rule
                            (_lhsOaranges@_) =
                                _hdIaranges Seq.<> _tlIaranges
                            -- use rule
                            (_lhsOdirectDep@_) =
                                _hdIdirectDep Seq.<> _tlIdirectDep
                            -- use rule
                            (_lhsOerrors@_) =
                                _hdIerrors Seq.<> _tlIerrors
                            -- use rule
                            (_lhsOntattrs@_) =
                                _hdIntattrs Seq.<> _tlIntattrs
                            -- use rule
                            (_lhsOprods@_) =
                                _hdIprods ++ _tlIprods
                            -- use rule
                            (_lhsOrules@_) =
                                _hdIrules Seq.<> _tlIrules
                            -- copy rule (up)
                            (_lhsOacount@_) =
                                _tlIacount
                            -- copy rule (up)
                            (_lhsOvcount@_) =
                                _tlIvcount
                            -- copy rule (down)
                            (_hdOacount@_) =
                                _lhsIacount
                            -- copy rule (down)
                            (_hdOallnts@_) =
                                _lhsIallnts
                            -- copy rule (down)
                            (_hdOcInterfaceMap@_) =
                                _lhsIcInterfaceMap
                            -- copy rule (down)
                            (_hdOcVisitsMap@_) =
                                _lhsIcVisitsMap
                            -- copy rule (down)
                            (_hdOo_case@_) =
                                _lhsIo_case
                            -- copy rule (down)
                            (_hdOo_cata@_) =
                                _lhsIo_cata
                            -- copy rule (down)
                            (_hdOo_data@_) =
                                _lhsIo_data
                            -- copy rule (down)
                            (_hdOo_dovisit@_) =
                                _lhsIo_dovisit
                            -- copy rule (down)
                            (_hdOo_newtypes@_) =
                                _lhsIo_newtypes
                            -- copy rule (down)
                            (_hdOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_hdOo_sem@_) =
                                _lhsIo_sem
                            -- copy rule (down)
                            (_hdOo_sig@_) =
                                _lhsIo_sig
                            -- copy rule (down)
                            (_hdOo_unbox@_) =
                                _lhsIo_unbox
                            -- copy rule (down)
                            (_hdOo_wantvisit@_) =
                                _lhsIo_wantvisit
                            -- copy rule (down)
                            (_hdOprefix@_) =
                                _lhsIprefix
                            -- copy rule (down)
                            (_hdOvcount@_) =
                                _lhsIvcount
                            -- copy rule (chain)
                            (_tlOacount@_) =
                                _hdIacount
                            -- copy rule (down)
                            (_tlOallnts@_) =
                                _lhsIallnts
                            -- copy rule (down)
                            (_tlOcInterfaceMap@_) =
                                _lhsIcInterfaceMap
                            -- copy rule (down)
                            (_tlOcVisitsMap@_) =
                                _lhsIcVisitsMap
                            -- copy rule (down)
                            (_tlOo_case@_) =
                                _lhsIo_case
                            -- copy rule (down)
                            (_tlOo_cata@_) =
                                _lhsIo_cata
                            -- copy rule (down)
                            (_tlOo_data@_) =
                                _lhsIo_data
                            -- copy rule (down)
                            (_tlOo_dovisit@_) =
                                _lhsIo_dovisit
                            -- copy rule (down)
                            (_tlOo_newtypes@_) =
                                _lhsIo_newtypes
                            -- copy rule (down)
                            (_tlOo_rename@_) =
                                _lhsIo_rename
                            -- copy rule (down)
                            (_tlOo_sem@_) =
                                _lhsIo_sem
                            -- copy rule (down)
                            (_tlOo_sig@_) =
                                _lhsIo_sig
                            -- copy rule (down)
                            (_tlOo_unbox@_) =
                                _lhsIo_unbox
                            -- copy rule (down)
                            (_tlOo_wantvisit@_) =
                                _lhsIo_wantvisit
                            -- copy rule (down)
                            (_tlOprefix@_) =
                                _lhsIprefix
                            -- copy rule (chain)
                            (_tlOvcount@_) =
                                _hdIvcount
                        in  ( _lhsOacount,_lhsOaranges,_lhsOcProductions,_lhsOdirectDep,_lhsOerrors,_lhsOntattrs,_lhsOprods,_lhsOrules,_lhsOvcount)))
sem_Productions_Nil :: (T_Productions)
sem_Productions_Nil  =
    (T_Productions (\ _lhsIacount
                      _lhsIallnts
                      _lhsIcInterfaceMap
                      _lhsIcVisitsMap
                      _lhsIo_case
                      _lhsIo_cata
                      _lhsIo_data
                      _lhsIo_dovisit
                      _lhsIo_newtypes
                      _lhsIo_rename
                      _lhsIo_sem
                      _lhsIo_sig
                      _lhsIo_unbox
                      _lhsIo_wantvisit
                      _lhsIprefix
                      _lhsIvcount ->
                        let _lhsOacount :: (Int)
                            _lhsOaranges :: (Seq (Int,Int,Int))
                            _lhsOcProductions :: (CProductions)
                            _lhsOdirectDep :: (Seq Edge)
                            _lhsOerrors :: (Seq Error)
                            _lhsOntattrs :: (Seq (Vertex,NTAttr))
                            _lhsOprods :: ([(Nonterminal,[Constructor])])
                            _lhsOrules :: (Seq (Vertex,CRule))
                            _lhsOvcount :: (Int)
                            -- "Order.ag"(line 336, column 12)
                            (_lhsOcProductions@_) =
                                []
                            -- use rule
                            (_lhsOaranges@_) =
                                Seq.empty
                            -- use rule
                            (_lhsOdirectDep@_) =
                                Seq.empty
                            -- use rule
                            (_lhsOerrors@_) =
                                Seq.empty
                            -- use rule
                            (_lhsOntattrs@_) =
                                Seq.empty
                            -- use rule
                            (_lhsOprods@_) =
                                []
                            -- use rule
                            (_lhsOrules@_) =
                                Seq.empty
                            -- copy rule (chain)
                            (_lhsOacount@_) =
                                _lhsIacount
                            -- copy rule (chain)
                            (_lhsOvcount@_) =
                                _lhsIvcount
                        in  ( _lhsOacount,_lhsOaranges,_lhsOcProductions,_lhsOdirectDep,_lhsOerrors,_lhsOntattrs,_lhsOprods,_lhsOrules,_lhsOvcount)))
-- Rule --------------------------------------------------------
{-
   inherited attributes:
      allTypeSigs          : Map Name Type
      allfields            : [(Name,Type)]
      allnts               : [Name]
      altAttrs             : Map AltAttr Vertex
      attrs                : [(Name,Name)]
      childInhs            : Map Name Attributes
      childNts             : Map Name Nonterminal
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      o_case               : Bool
      o_cata               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_wantvisit          : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      directDep            : Seq Edge
      errors               : Seq Error
      gathAltAttrs         : [AltAttr]
      gathRules            : Seq CRule
      locVars              : [Name]

-}
{-
   local variables for Rule.Rule:
      gathRules
      defines

-}
-- semantic domain
newtype T_Rule = T_Rule ((Map Name Type) ->
                         ([(Name,Type)]) ->
                         ([Name]) ->
                         (Map AltAttr Vertex) ->
                         ([(Name,Name)]) ->
                         (Map Name Attributes) ->
                         (Map Name Nonterminal) ->
                         (Identifier) ->
                         (Attributes) ->
                         (Identifier) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (String) ->
                         (Attributes) ->
                         ( (Seq Edge),(Seq Error),([AltAttr]),(Seq CRule),([Name])))
-- cata
sem_Rule :: (Rule) ->
            (T_Rule)
sem_Rule ((Rule (_pattern) (_rhs) (_owrt) (_origin))) =
    (sem_Rule_Rule ((sem_Pattern (_pattern))) ((sem_Expression (_rhs))) (_owrt) (_origin))
data Inh_Rule = Inh_Rule {allTypeSigs_Inh_Rule :: Map Name Type
                         ,allfields_Inh_Rule :: [(Name,Type)]
                         ,allnts_Inh_Rule :: [Name]
                         ,altAttrs_Inh_Rule :: Map AltAttr Vertex
                         ,attrs_Inh_Rule :: [(Name,Name)]
                         ,childInhs_Inh_Rule :: Map Name Attributes
                         ,childNts_Inh_Rule :: Map Name Nonterminal
                         ,con_Inh_Rule :: Identifier
                         ,inh_Inh_Rule :: Attributes
                         ,nt_Inh_Rule :: Identifier
                         ,o_case_Inh_Rule :: Bool
                         ,o_cata_Inh_Rule :: Bool
                         ,o_dovisit_Inh_Rule :: Bool
                         ,o_newtypes_Inh_Rule :: Bool
                         ,o_rename_Inh_Rule :: Bool
                         ,o_sem_Inh_Rule :: Bool
                         ,o_sig_Inh_Rule :: Bool
                         ,o_wantvisit_Inh_Rule :: Bool
                         ,prefix_Inh_Rule :: String
                         ,syn_Inh_Rule :: Attributes
                         }
data Syn_Rule = Syn_Rule {directDep_Syn_Rule :: Seq Edge,errors_Syn_Rule :: Seq Error,gathAltAttrs_Syn_Rule :: [AltAttr],gathRules_Syn_Rule :: Seq CRule,locVars_Syn_Rule :: [Name]}
wrap_Rule :: (T_Rule) ->
             (Inh_Rule) ->
             (Syn_Rule)
wrap_Rule ((T_Rule (sem))) ((Inh_Rule (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))) =
    let ( s1,s2,s3,s4,s5) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))
    in  (Syn_Rule (s1) (s2) (s3) (s4) (s5))
sem_Rule_Rule :: (T_Pattern) ->
                 (T_Expression) ->
                 (Bool) ->
                 (String) ->
                 (T_Rule)
sem_Rule_Rule ((T_Pattern (pattern_))) ((T_Expression (rhs_))) (owrt_) (origin_) =
    (T_Rule (\ _lhsIallTypeSigs
               _lhsIallfields
               _lhsIallnts
               _lhsIaltAttrs
               _lhsIattrs
               _lhsIchildInhs
               _lhsIchildNts
               _lhsIcon
               _lhsIinh
               _lhsInt
               _lhsIo_case
               _lhsIo_cata
               _lhsIo_dovisit
               _lhsIo_newtypes
               _lhsIo_rename
               _lhsIo_sem
               _lhsIo_sig
               _lhsIo_wantvisit
               _lhsIprefix
               _lhsIsyn ->
                 let _lhsOdirectDep :: (Seq Edge)
                     _lhsOerrors :: (Seq Error)
                     _lhsOgathAltAttrs :: ([AltAttr])
                     _lhsOgathRules :: (Seq CRule)
                     _lhsOlocVars :: ([Name])
                     _patternIcopy :: (Pattern)
                     _patternIerrors :: (Seq Error)
                     _patternIgathAltAttrs :: ([AltAttr])
                     _patternIlocVars :: ([Name])
                     _patternOallTypeSigs :: (Map Name Type)
                     _patternOaltAttrs :: (Map AltAttr Vertex)
                     _patternOcon :: (Identifier)
                     _patternOinh :: (Attributes)
                     _patternOnt :: (Identifier)
                     _patternOsyn :: (Attributes)
                     _rhsIcopy :: (Expression)
                     _rhsIerrors :: (Seq Error)
                     _rhsItextLines :: ([String])
                     _rhsIusedAttrs :: ([(Name,Name)])
                     _rhsIusedFields :: ([Name])
                     _rhsIusedLocals :: ([Name])
                     _rhsOallfields :: ([(Name,Type)])
                     _rhsOallnts :: ([Name])
                     _rhsOattrs :: ([(Name,Name)])
                     _rhsOcon :: (Name)
                     _rhsOnt :: (Name)
                     ( _patternIcopy,_patternIerrors,_patternIgathAltAttrs,_patternIlocVars) =
                         (pattern_ (_patternOallTypeSigs) (_patternOaltAttrs) (_patternOcon) (_patternOinh) (_patternOnt) (_patternOsyn))
                     ( _rhsIcopy,_rhsIerrors,_rhsItextLines,_rhsIusedAttrs,_rhsIusedFields,_rhsIusedLocals) =
                         (rhs_ (_rhsOallfields) (_rhsOallnts) (_rhsOattrs) (_rhsOcon) (_rhsOnt))
                     -- "Order.ag"(line 166, column 12)
                     (_gathRules@_) =
                         let childnt field = Map.lookup field _lhsIchildNts
                         in Seq.fromList [ CRule attr False True _lhsInt _lhsIcon field (childnt field) tp _patternIcopy _rhsItextLines _defines owrt_ origin_ | (field,attr,tp) <- Map.elems _defines ]
                     -- "Order.ag"(line 161, column 12)
                     (_defines@_) =
                         let  tp field attr  | field == _LOC = Map.lookup attr _lhsIallTypeSigs
                                             | field == _LHS = Map.lookup attr _lhsIsyn
                                             | otherwise = Map.lookup attr (Map.find field _lhsIchildInhs)
                         in Map.fromList  [  (Map.find aa _lhsIaltAttrs, (field,attr,(tp field attr)))
                                          | aa <- _patternIgathAltAttrs, let AltAttr field attr _ = aa ]
                     -- "Order.ag"(line 184, column 12)
                     (_lhsOdirectDep@_) =
                         let  defined = Map.keys _defines
                              used =  [ Map.lookup (AltAttr field attr True) _lhsIaltAttrs | (field,attr) <- _rhsIusedAttrs]
                                      ++ [ Map.lookup (AltAttr _LOC attr True) _lhsIaltAttrs | attr <- _rhsIusedLocals ++ _rhsIusedFields ]
                         in Seq.fromList [ (x,y) | Just x <- used, y <- defined ]
                     -- use rule
                     (_lhsOerrors@_) =
                         _patternIerrors Seq.<> _rhsIerrors
                     -- use rule
                     (_lhsOgathAltAttrs@_) =
                         _patternIgathAltAttrs
                     -- use rule
                     (_lhsOgathRules@_) =
                         _gathRules
                     -- use rule
                     (_lhsOlocVars@_) =
                         _patternIlocVars
                     -- copy rule (down)
                     (_patternOallTypeSigs@_) =
                         _lhsIallTypeSigs
                     -- copy rule (down)
                     (_patternOaltAttrs@_) =
                         _lhsIaltAttrs
                     -- copy rule (down)
                     (_patternOcon@_) =
                         _lhsIcon
                     -- copy rule (down)
                     (_patternOinh@_) =
                         _lhsIinh
                     -- copy rule (down)
                     (_patternOnt@_) =
                         _lhsInt
                     -- copy rule (down)
                     (_patternOsyn@_) =
                         _lhsIsyn
                     -- copy rule (down)
                     (_rhsOallfields@_) =
                         _lhsIallfields
                     -- copy rule (down)
                     (_rhsOallnts@_) =
                         _lhsIallnts
                     -- copy rule (down)
                     (_rhsOattrs@_) =
                         _lhsIattrs
                     -- copy rule (down)
                     (_rhsOcon@_) =
                         _lhsIcon
                     -- copy rule (down)
                     (_rhsOnt@_) =
                         _lhsInt
                 in  ( _lhsOdirectDep,_lhsOerrors,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOlocVars)))
-- Rules -------------------------------------------------------
{-
   inherited attributes:
      allTypeSigs          : Map Name Type
      allfields            : [(Name,Type)]
      allnts               : [Name]
      altAttrs             : Map AltAttr Vertex
      attrs                : [(Name,Name)]
      childInhs            : Map Name Attributes
      childNts             : Map Name Nonterminal
      con                  : Identifier
      inh                  : Attributes
      nt                   : Identifier
      o_case               : Bool
      o_cata               : Bool
      o_dovisit            : Bool
      o_newtypes           : Bool
      o_rename             : Bool
      o_sem                : Bool
      o_sig                : Bool
      o_wantvisit          : Bool
      prefix               : String
      syn                  : Attributes

   chained attributes:

   synthesised attributes:
      directDep            : Seq Edge
      errors               : Seq Error
      gathAltAttrs         : [AltAttr]
      gathRules            : Seq CRule
      locVars              : [Name]

-}
{-
   local variables for Rules.Cons:

-}
{-
   local variables for Rules.Nil:

-}
-- semantic domain
newtype T_Rules = T_Rules ((Map Name Type) ->
                           ([(Name,Type)]) ->
                           ([Name]) ->
                           (Map AltAttr Vertex) ->
                           ([(Name,Name)]) ->
                           (Map Name Attributes) ->
                           (Map Name Nonterminal) ->
                           (Identifier) ->
                           (Attributes) ->
                           (Identifier) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (Bool) ->
                           (String) ->
                           (Attributes) ->
                           ( (Seq Edge),(Seq Error),([AltAttr]),(Seq CRule),([Name])))
-- cata
sem_Rules :: (Rules) ->
             (T_Rules)
sem_Rules (list) =
    (Prelude.foldr (sem_Rules_Cons) (sem_Rules_Nil) ((Prelude.map sem_Rule list)))
data Inh_Rules = Inh_Rules {allTypeSigs_Inh_Rules :: Map Name Type
                           ,allfields_Inh_Rules :: [(Name,Type)]
                           ,allnts_Inh_Rules :: [Name]
                           ,altAttrs_Inh_Rules :: Map AltAttr Vertex
                           ,attrs_Inh_Rules :: [(Name,Name)]
                           ,childInhs_Inh_Rules :: Map Name Attributes
                           ,childNts_Inh_Rules :: Map Name Nonterminal
                           ,con_Inh_Rules :: Identifier
                           ,inh_Inh_Rules :: Attributes
                           ,nt_Inh_Rules :: Identifier
                           ,o_case_Inh_Rules :: Bool
                           ,o_cata_Inh_Rules :: Bool
                           ,o_dovisit_Inh_Rules :: Bool
                           ,o_newtypes_Inh_Rules :: Bool
                           ,o_rename_Inh_Rules :: Bool
                           ,o_sem_Inh_Rules :: Bool
                           ,o_sig_Inh_Rules :: Bool
                           ,o_wantvisit_Inh_Rules :: Bool
                           ,prefix_Inh_Rules :: String
                           ,syn_Inh_Rules :: Attributes
                           }
data Syn_Rules = Syn_Rules {directDep_Syn_Rules :: Seq Edge,errors_Syn_Rules :: Seq Error,gathAltAttrs_Syn_Rules :: [AltAttr],gathRules_Syn_Rules :: Seq CRule,locVars_Syn_Rules :: [Name]}
wrap_Rules :: (T_Rules) ->
              (Inh_Rules) ->
              (Syn_Rules)
wrap_Rules ((T_Rules (sem))) ((Inh_Rules (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))) =
    let ( s1,s2,s3,s4,s5) =
            (sem (i1) (i2) (i3) (i4) (i5) (i6) (i7) (i8) (i9) (i10) (i11) (i12) (i13) (i14) (i15) (i16) (i17) (i18) (i19) (i20))
    in  (Syn_Rules (s1) (s2) (s3) (s4) (s5))
sem_Rules_Cons :: (T_Rule) ->
                  (T_Rules) ->
                  (T_Rules)
sem_Rules_Cons ((T_Rule (hd_))) ((T_Rules (tl_))) =
    (T_Rules (\ _lhsIallTypeSigs
                _lhsIallfields
                _lhsIallnts
                _lhsIaltAttrs
                _lhsIattrs
                _lhsIchildInhs
                _lhsIchildNts
                _lhsIcon
                _lhsIinh
                _lhsInt
                _lhsIo_case
                _lhsIo_cata
                _lhsIo_dovisit
                _lhsIo_newtypes
                _lhsIo_rename
                _lhsIo_sem
                _lhsIo_sig
                _lhsIo_wantvisit
                _lhsIprefix
                _lhsIsyn ->
                  let _lhsOdirectDep :: (Seq Edge)
                      _lhsOerrors :: (Seq Error)
                      _lhsOgathAltAttrs :: ([AltAttr])
                      _lhsOgathRules :: (Seq CRule)
                      _lhsOlocVars :: ([Name])
                      _hdIdirectDep :: (Seq Edge)
                      _hdIerrors :: (Seq Error)
                      _hdIgathAltAttrs :: ([AltAttr])
                      _hdIgathRules :: (Seq CRule)
                      _hdIlocVars :: ([Name])
                      _hdOallTypeSigs :: (Map Name Type)
                      _hdOallfields :: ([(Name,Type)])
                      _hdOallnts :: ([Name])
                      _hdOaltAttrs :: (Map AltAttr Vertex)
                      _hdOattrs :: ([(Name,Name)])
                      _hdOchildInhs :: (Map Name Attributes)
                      _hdOchildNts :: (Map Name Nonterminal)
                      _hdOcon :: (Identifier)
                      _hdOinh :: (Attributes)
                      _hdOnt :: (Identifier)
                      _hdOo_case :: (Bool)
                      _hdOo_cata :: (Bool)
                      _hdOo_dovisit :: (Bool)
                      _hdOo_newtypes :: (Bool)
                      _hdOo_rename :: (Bool)
                      _hdOo_sem :: (Bool)
                      _hdOo_sig :: (Bool)
                      _hdOo_wantvisit :: (Bool)
                      _hdOprefix :: (String)
                      _hdOsyn :: (Attributes)
                      _tlIdirectDep :: (Seq Edge)
                      _tlIerrors :: (Seq Error)
                      _tlIgathAltAttrs :: ([AltAttr])
                      _tlIgathRules :: (Seq CRule)
                      _tlIlocVars :: ([Name])
                      _tlOallTypeSigs :: (Map Name Type)
                      _tlOallfields :: ([(Name,Type)])
                      _tlOallnts :: ([Name])
                      _tlOaltAttrs :: (Map AltAttr Vertex)
                      _tlOattrs :: ([(Name,Name)])
                      _tlOchildInhs :: (Map Name Attributes)
                      _tlOchildNts :: (Map Name Nonterminal)
                      _tlOcon :: (Identifier)
                      _tlOinh :: (Attributes)
                      _tlOnt :: (Identifier)
                      _tlOo_case :: (Bool)
                      _tlOo_cata :: (Bool)
                      _tlOo_dovisit :: (Bool)
                      _tlOo_newtypes :: (Bool)
                      _tlOo_rename :: (Bool)
                      _tlOo_sem :: (Bool)
                      _tlOo_sig :: (Bool)
                      _tlOo_wantvisit :: (Bool)
                      _tlOprefix :: (String)
                      _tlOsyn :: (Attributes)
                      ( _hdIdirectDep,_hdIerrors,_hdIgathAltAttrs,_hdIgathRules,_hdIlocVars) =
                          (hd_ (_hdOallTypeSigs) (_hdOallfields) (_hdOallnts) (_hdOaltAttrs) (_hdOattrs) (_hdOchildInhs) (_hdOchildNts) (_hdOcon) (_hdOinh) (_hdOnt) (_hdOo_case) (_hdOo_cata) (_hdOo_dovisit) (_hdOo_newtypes) (_hdOo_rename) (_hdOo_sem) (_hdOo_sig) (_hdOo_wantvisit) (_hdOprefix) (_hdOsyn))
                      ( _tlIdirectDep,_tlIerrors,_tlIgathAltAttrs,_tlIgathRules,_tlIlocVars) =
                          (tl_ (_tlOallTypeSigs) (_tlOallfields) (_tlOallnts) (_tlOaltAttrs) (_tlOattrs) (_tlOchildInhs) (_tlOchildNts) (_tlOcon) (_tlOinh) (_tlOnt) (_tlOo_case) (_tlOo_cata) (_tlOo_dovisit) (_tlOo_newtypes) (_tlOo_rename) (_tlOo_sem) (_tlOo_sig) (_tlOo_wantvisit) (_tlOprefix) (_tlOsyn))
                      -- use rule
                      (_lhsOdirectDep@_) =
                          _hdIdirectDep Seq.<> _tlIdirectDep
                      -- use rule
                      (_lhsOerrors@_) =
                          _hdIerrors Seq.<> _tlIerrors
                      -- use rule
                      (_lhsOgathAltAttrs@_) =
                          _hdIgathAltAttrs ++ _tlIgathAltAttrs
                      -- use rule
                      (_lhsOgathRules@_) =
                          _hdIgathRules Seq.<> _tlIgathRules
                      -- use rule
                      (_lhsOlocVars@_) =
                          _hdIlocVars ++ _tlIlocVars
                      -- copy rule (down)
                      (_hdOallTypeSigs@_) =
                          _lhsIallTypeSigs
                      -- copy rule (down)
                      (_hdOallfields@_) =
                          _lhsIallfields
                      -- copy rule (down)
                      (_hdOallnts@_) =
                          _lhsIallnts
                      -- copy rule (down)
                      (_hdOaltAttrs@_) =
                          _lhsIaltAttrs
                      -- copy rule (down)
                      (_hdOattrs@_) =
                          _lhsIattrs
                      -- copy rule (down)
                      (_hdOchildInhs@_) =
                          _lhsIchildInhs
                      -- copy rule (down)
                      (_hdOchildNts@_) =
                          _lhsIchildNts
                      -- copy rule (down)
                      (_hdOcon@_) =
                          _lhsIcon
                      -- copy rule (down)
                      (_hdOinh@_) =
                          _lhsIinh
                      -- copy rule (down)
                      (_hdOnt@_) =
                          _lhsInt
                      -- copy rule (down)
                      (_hdOo_case@_) =
                          _lhsIo_case
                      -- copy rule (down)
                      (_hdOo_cata@_) =
                          _lhsIo_cata
                      -- copy rule (down)
                      (_hdOo_dovisit@_) =
                          _lhsIo_dovisit
                      -- copy rule (down)
                      (_hdOo_newtypes@_) =
                          _lhsIo_newtypes
                      -- copy rule (down)
                      (_hdOo_rename@_) =
                          _lhsIo_rename
                      -- copy rule (down)
                      (_hdOo_sem@_) =
                          _lhsIo_sem
                      -- copy rule (down)
                      (_hdOo_sig@_) =
                          _lhsIo_sig
                      -- copy rule (down)
                      (_hdOo_wantvisit@_) =
                          _lhsIo_wantvisit
                      -- copy rule (down)
                      (_hdOprefix@_) =
                          _lhsIprefix
                      -- copy rule (down)
                      (_hdOsyn@_) =
                          _lhsIsyn
                      -- copy rule (down)
                      (_tlOallTypeSigs@_) =
                          _lhsIallTypeSigs
                      -- copy rule (down)
                      (_tlOallfields@_) =
                          _lhsIallfields
                      -- copy rule (down)
                      (_tlOallnts@_) =
                          _lhsIallnts
                      -- copy rule (down)
                      (_tlOaltAttrs@_) =
                          _lhsIaltAttrs
                      -- copy rule (down)
                      (_tlOattrs@_) =
                          _lhsIattrs
                      -- copy rule (down)
                      (_tlOchildInhs@_) =
                          _lhsIchildInhs
                      -- copy rule (down)
                      (_tlOchildNts@_) =
                          _lhsIchildNts
                      -- copy rule (down)
                      (_tlOcon@_) =
                          _lhsIcon
                      -- copy rule (down)
                      (_tlOinh@_) =
                          _lhsIinh
                      -- copy rule (down)
                      (_tlOnt@_) =
                          _lhsInt
                      -- copy rule (down)
                      (_tlOo_case@_) =
                          _lhsIo_case
                      -- copy rule (down)
                      (_tlOo_cata@_) =
                          _lhsIo_cata
                      -- copy rule (down)
                      (_tlOo_dovisit@_) =
                          _lhsIo_dovisit
                      -- copy rule (down)
                      (_tlOo_newtypes@_) =
                          _lhsIo_newtypes
                      -- copy rule (down)
                      (_tlOo_rename@_) =
                          _lhsIo_rename
                      -- copy rule (down)
                      (_tlOo_sem@_) =
                          _lhsIo_sem
                      -- copy rule (down)
                      (_tlOo_sig@_) =
                          _lhsIo_sig
                      -- copy rule (down)
                      (_tlOo_wantvisit@_) =
                          _lhsIo_wantvisit
                      -- copy rule (down)
                      (_tlOprefix@_) =
                          _lhsIprefix
                      -- copy rule (down)
                      (_tlOsyn@_) =
                          _lhsIsyn
                  in  ( _lhsOdirectDep,_lhsOerrors,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOlocVars)))
sem_Rules_Nil :: (T_Rules)
sem_Rules_Nil  =
    (T_Rules (\ _lhsIallTypeSigs
                _lhsIallfields
                _lhsIallnts
                _lhsIaltAttrs
                _lhsIattrs
                _lhsIchildInhs
                _lhsIchildNts
                _lhsIcon
                _lhsIinh
                _lhsInt
                _lhsIo_case
                _lhsIo_cata
                _lhsIo_dovisit
                _lhsIo_newtypes
                _lhsIo_rename
                _lhsIo_sem
                _lhsIo_sig
                _lhsIo_wantvisit
                _lhsIprefix
                _lhsIsyn ->
                  let _lhsOdirectDep :: (Seq Edge)
                      _lhsOerrors :: (Seq Error)
                      _lhsOgathAltAttrs :: ([AltAttr])
                      _lhsOgathRules :: (Seq CRule)
                      _lhsOlocVars :: ([Name])
                      -- use rule
                      (_lhsOdirectDep@_) =
                          Seq.empty
                      -- use rule
                      (_lhsOerrors@_) =
                          Seq.empty
                      -- use rule
                      (_lhsOgathAltAttrs@_) =
                          []
                      -- use rule
                      (_lhsOgathRules@_) =
                          Seq.empty
                      -- use rule
                      (_lhsOlocVars@_) =
                          []
                  in  ( _lhsOdirectDep,_lhsOerrors,_lhsOgathAltAttrs,_lhsOgathRules,_lhsOlocVars)))
-- TypeSig -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typeSigs             : Map Name Type

   synthesised attributes:

-}
{-
   local variables for TypeSig.TypeSig:

-}
-- semantic domain
newtype T_TypeSig = T_TypeSig ((Map Name Type) ->
                               ( (Map Name Type)))
-- cata
sem_TypeSig :: (TypeSig) ->
               (T_TypeSig)
sem_TypeSig ((TypeSig (_name) (_tp))) =
    (sem_TypeSig_TypeSig (_name) (_tp))
data Inh_TypeSig = Inh_TypeSig {typeSigs_Inh_TypeSig :: Map Name Type}
data Syn_TypeSig = Syn_TypeSig {typeSigs_Syn_TypeSig :: Map Name Type}
wrap_TypeSig :: (T_TypeSig) ->
                (Inh_TypeSig) ->
                (Syn_TypeSig)
wrap_TypeSig ((T_TypeSig (sem))) ((Inh_TypeSig (i1))) =
    let ( s1) =
            (sem (i1))
    in  (Syn_TypeSig (s1))
sem_TypeSig_TypeSig :: (Name) ->
                       (Type) ->
                       (T_TypeSig)
sem_TypeSig_TypeSig (name_) (tp_) =
    (T_TypeSig (\ _lhsItypeSigs ->
                    let _lhsOtypeSigs :: (Map Name Type)
                        -- "Order.ag"(line 260, column 13)
                        (_lhsOtypeSigs@_) =
                            Map.insert name_ tp_ _lhsItypeSigs
                    in  ( _lhsOtypeSigs)))
-- TypeSigs ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:
      typeSigs             : Map Name Type

   synthesised attributes:

-}
{-
   local variables for TypeSigs.Cons:

-}
{-
   local variables for TypeSigs.Nil:

-}
-- semantic domain
newtype T_TypeSigs = T_TypeSigs ((Map Name Type) ->
                                 ( (Map Name Type)))
-- cata
sem_TypeSigs :: (TypeSigs) ->
                (T_TypeSigs)
sem_TypeSigs (list) =
    (Prelude.foldr (sem_TypeSigs_Cons) (sem_TypeSigs_Nil) ((Prelude.map sem_TypeSig list)))
data Inh_TypeSigs = Inh_TypeSigs {typeSigs_Inh_TypeSigs :: Map Name Type}
data Syn_TypeSigs = Syn_TypeSigs {typeSigs_Syn_TypeSigs :: Map Name Type}
wrap_TypeSigs :: (T_TypeSigs) ->
                 (Inh_TypeSigs) ->
                 (Syn_TypeSigs)
wrap_TypeSigs ((T_TypeSigs (sem))) ((Inh_TypeSigs (i1))) =
    let ( s1) =
            (sem (i1))
    in  (Syn_TypeSigs (s1))
sem_TypeSigs_Cons :: (T_TypeSig) ->
                     (T_TypeSigs) ->
                     (T_TypeSigs)
sem_TypeSigs_Cons ((T_TypeSig (hd_))) ((T_TypeSigs (tl_))) =
    (T_TypeSigs (\ _lhsItypeSigs ->
                     let _lhsOtypeSigs :: (Map Name Type)
                         _hdItypeSigs :: (Map Name Type)
                         _hdOtypeSigs :: (Map Name Type)
                         _tlItypeSigs :: (Map Name Type)
                         _tlOtypeSigs :: (Map Name Type)
                         ( _hdItypeSigs) =
                             (hd_ (_hdOtypeSigs))
                         ( _tlItypeSigs) =
                             (tl_ (_tlOtypeSigs))
                         -- copy rule (up)
                         (_lhsOtypeSigs@_) =
                             _tlItypeSigs
                         -- copy rule (down)
                         (_hdOtypeSigs@_) =
                             _lhsItypeSigs
                         -- copy rule (chain)
                         (_tlOtypeSigs@_) =
                             _hdItypeSigs
                     in  ( _lhsOtypeSigs)))
sem_TypeSigs_Nil :: (T_TypeSigs)
sem_TypeSigs_Nil  =
    (T_TypeSigs (\ _lhsItypeSigs ->
                     let _lhsOtypeSigs :: (Map Name Type)
                         -- copy rule (chain)
                         (_lhsOtypeSigs@_) =
                             _lhsItypeSigs
                     in  ( _lhsOtypeSigs)))


